package pstsp.functional_tests.c_one_change.ts_c_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;
import pstsp.support.test_utils.PstspTags;

/**
 * Edit team name
 *
 * @author David Kuta
 * @version 2022-03-17
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.02.01: Edit team name")
public class TS_C_02_01 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.02.01.01: average name")
    void test_1() {
        Team_Actions.editTeamNameAsLeaderSuccess("Nejlepší kodéři","leader");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @Tag(PstspTags.BOUNDARY)
    @DisplayName("TC.C.02.01.02: shortest name")
    void test_2() {
        Team_Actions.editTeamNameAsLeaderSuccess("a","leader");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.BOUNDARY)
    @Tag(PstspTags.IMP_MAJOR)
    @DisplayName("TC.C.02.01.03: large name")
    void test_3() {
        String expected= "qndy5WLrXSqIl6QdvScJwSxTWwSUiWYzcs03iPNkq9x4YzDHRmgQS27MTUt02Zfey11sAWFnTx1qCraF5JwtjTBSd2eNDGnNEBR1Br4fqqEKpwdIFKFBJlvKh2HBwerASdUDnSCS8v306PApPFmr91mw9MwivBugIe3ks5eVwgTWuPekeyGhrx8FhRkaAnsJTNLAZGZAKG2u0gB2aMxIMy8f2dZHsdscDLDP3TMEQVtXkThnwLyOJBKKJi6j8kv";
        Team_Actions.editTeamNameAsLeaderSuccess(expected,"leader");
    }

    @Order(4)
    @Test
    @Tag(PstspTags.IMP_MINOR)
    @DisplayName("TC.C.02.01.04: diacritic name")
    void test_4() {
        String expected= "Příliš žluťoučký kůň úpěl ďábelské ódy";
        Team_Actions.editTeamNameAsLeaderSuccess(expected,"leader");
    }

}
