package pstsp.functional_tests.c_one_change.ts_c_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;
import pstsp.support.test_utils.PstspTags;

/**
 * Team completenes
 *
 * @author David Kuta
 * @version 2022-03-17
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.02.03: Edit team complete")
public class TS_C_02_03 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @DisplayName("TC.C.02.03.01: team complete with project")
    void test_1() {
        Team_Actions.setTeamCompleteAsLeaderSuccess("leader");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @DisplayName("TC.C.02.03.02: team incomplete with project")
    void test_2() {
        Team_Actions.setTeamInCompleteAsLeaderSuccess("leader");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @DisplayName("TC.C.02.03.03: team complete without project")
    void test_3() {
        Team_Actions.setTeamCompleteAsLeaderSuccess("cacha");
    }

    @Order(4)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @DisplayName("TC.C.02.03.02: team incomplete without project")
    void test_4() {
        Team_Actions.setTeamInCompleteAsLeaderSuccess("cacha");
    }

}
