package pstsp.functional_tests.c_one_change.ts_c_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;
import pstsp.support.test_utils.PstspTags;

/**
 * Delete topic interest
 *
 * @author David Kuta
 * @version 2022-03-17
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.02.05: delete topic interest")
public class TS_C_02_05 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.02.05.01: remove interrest with very low priroity")
    void test_1() {
        String topicName = "Administrativní klient pro systém SensLog";
        Team_Actions.deleteTopicInterrestAsLeaderSuccess(topicName,"Velmi nízký","papirnik","mentor");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.02.05.02: remove interrest with low priroity")
    void test_2() {
        String topicName = "Převedení vizualizace scény pro rehabilitaci paže pomocí rehabilitačního robota do virtuální reality";
        Team_Actions.deleteTopicInterrestAsLeaderSuccess(topicName,"Nízký","stricz","mentor");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.02.05.03: remove interrest with middle priroity")
    void test_3() {
        String topicName = "Rozšíření Genealogy pluginu";
        Team_Actions.deleteTopicInterrestAsLeaderSuccess(topicName,"Střední","stricz","mentor");
    }

    @Order(4)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.02.05.04: remove interrest with high priroity")
    void test_4() {
        String topicName = "Rehabilitační hra pro virtuální realitu";
        Team_Actions.deleteTopicInterrestAsLeaderSuccess(topicName,"Velký","papirnik","mentor");

    }

    @Order(5)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.02.05.05: remove interrest with very high priroity")
    void test_5() {
        String topicName = "Konfigurovatelný dashboard zobrazování senzorových dat";
        Team_Actions.deleteTopicInterrestAsLeaderSuccess(topicName,"Velmi velký","sochorec","mentor");
    }

}
