package pstsp.functional_tests.c_one_change.ts_c_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.team.Team_Page_Meeting_Modal;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;
import pstsp.support.test_utils.PstspTags;

/**
 * Add meeting
 *
 * @author David Kuta
 * @version 2022-03-17
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.02.07: Add meeting")
public class TS_C_02_07 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @DisplayName("TC.C.02.07.01: add meeting")
    void test_1() {
        String datetime="28.6.2022 13:51";
        String room="CrossCafé náměstí";
        String topic = "Team building pro přípravu projektu";
        String option =  Team_Page_Meeting_Modal.SELECT_OPTION_INTERN;
        Team_Actions.addMeetingAsLeaderSuccess(datetime,room,topic, option,"motlm","mentor");
    }
    @Order(2)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.02.07.02: add link mentor")
    void test_2() {
        String datetime="25.7.2022 9:00";
        String room="U Salzmanů";
        String topic = "Týmový oběd";
        String option =  Team_Page_Meeting_Modal.SELECT_OPTION_MENTOR;
        Team_Actions.addMeetingAsLeaderSuccess(datetime,room,topic, option,"motlm","mentor");
    }




}
