package pstsp.functional_tests.c_one_change.ts_c_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * Edit meeting description
 *
 * @author David Kuta
 * @version 2022-03-23
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.02.08: Edit meeting description")
public class TS_C_02_08 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_MINOR)
    @DisplayName("TC.C.02.08.01: add meeting description")
    void test_1() {
        String datetime = "24.7.2022 9:00";
        Team_Actions.editMeetingTopicDescriptionAsLeaderSuccess(datetime, "Schůzka byla OK", "leader");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_MINOR)
    @DisplayName("TC.C.02.08.02: add other meeting description")
    void test_2() {
        String datetime = "26.4.2022 13:51";
        Team_Actions.editMeetingTopicDescriptionAsLeaderSuccess(datetime, "Druhá schůzka byla OK", "leader");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.IMP_MINOR)
    @DisplayName("TC.C.02.08.03: remove meeting description")
    void test_3() {
        String datetime = "24.7.2022 9:00";
        Team_Actions.editMeetingTopicDescriptionAsLeaderSuccess(datetime, "", "leader");
    }

    @Order(4)
    @Test
    @Tag(PstspTags.IMP_MINOR)
    @DisplayName("TC.C.02.08.04: remove other meeting description")
    void test_4() {
        String datetime = "26.4.2022 13:51";
        Team_Actions.editMeetingTopicDescriptionAsLeaderSuccess(datetime, "", "leader");
    }


}
