package pstsp.functional_tests.c_one_change.ts_c_03;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignment.Assignment_Actions;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * Add leader topic interest
 *
 * @author David Kuta
 * @version 2022-03-23
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.03: Add leader topic interest")
public class TS_C_03 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.03.01: very low priority interest")
    void test_1() {
        String assignmentName = "Administrativní klient pro systém SensLog";
        String interestLevel = "Velmi nízký";
        Assignment_Actions.makeLeaderInterestOnAssignmentSuccess(assignmentName,interestLevel,"mentor","stricz");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.03.02: low priority interest")
    void test_2() {
        String assignmentName = "Převedení vizualizace scény pro rehabilitaci paže pomocí rehabilitačního robota do virtuální reality";
        String interestLevel = "Nízký";
        Assignment_Actions.makeLeaderInterestOnAssignmentSuccess(assignmentName,interestLevel,"mentor","papirnik");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.03.03: middle priority interest")
    void test_3() {
        String assignmentName = "Rozšíření Genealogy pluginu";
        String interestLevel = "Střední";
        Assignment_Actions.makeLeaderInterestOnAssignmentSuccess(assignmentName,interestLevel,"mentor","sochorec");
    }

    @Order(4)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.03.04: high priority interest")
    void test_4() {
        String assignmentName = "Rehabilitační hra pro virtuální realitu";
        String interestLevel = "Velký";
        Assignment_Actions.makeLeaderInterestOnAssignmentSuccess(assignmentName,interestLevel,"mentor","stricz");
    }

    @Order(5)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.03.05: very high priority interest")
    void test_5() {
        String assignmentName = "Konfigurovatelný dashboard zobrazování senzorových dat";
        String interestLevel = "Velmi velký";
        Assignment_Actions.makeLeaderInterestOnAssignmentSuccess(assignmentName,interestLevel,"herout","stricz");
    }


}
