package pstsp.functional_tests.c_one_change.ts_c_04;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;
import pstsp.support.services.entities.storage.ProjectTable;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.project.Project_Leader_Actions;
import pstsp.support.test_oracle.storage.ProjectPageStepList;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;

/**
 * edit minimal criteria project table
 *
 * @author David Kuta
 * @version 2022-03-24
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.04.01: edit minimal criteria project table as leader")
public class TS_C_04_01 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }


    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @ParameterizedTest(name = "TC.C.04.01.{index}: Step: {0} - choice: {1}")
    @MethodSource("streamForMinCritSteps")
    void test_01(String step, int choice) {
        Project_Leader_Actions.editMinCritTblSuccess(step,choice,"motlm","mentor");
    }

    static Stream<Arguments> streamForMinCritSteps() {
        List<String> minCritList = ProjectPageStepList.getInstance().getAllMinimalCriteriaSteps();
        List<Arguments> args = new ArrayList<>();
        for (String step: minCritList) {
            for(int i = ProjectTable.MIN_OPTION; i <= ProjectTable.MAX_OPTION; i++){
                args.add(Arguments.of(step,i));
            }
        }
        return args.stream();
    }


}
