package pstsp.functional_tests.c_one_change.ts_c_04;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.project.Project_Leader_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * add used experience
 *
 * @author David Kuta
 * @version 2022-03-25
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.04.05: add used experience links")
public class TS_C_04_05 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.04.05.01: avg name and description")
    void test_01() {
        String subjectName = "KIV/OKS";
        String subjectInfo = "Jednotkové testování";
        Project_Leader_Actions.addUsedExpSuccess(subjectName,subjectInfo,"honzar");
    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.04.05.02: short name and long description")
    void test_02() {
        String subjectName = "K/O";
        String subjectInfo = "Jednotkové testování, Integrační testování";
        Project_Leader_Actions.addUsedExpSuccess(subjectName,subjectInfo,"honzar");
    }

    @Order(3)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.04.05.03: shortest name and shortest description")
    void test_03() {
        String subjectName = "a";
        String subjectInfo = "b";
        Project_Leader_Actions.addUsedExpSuccess(subjectName,subjectInfo,"honzar");
    }

    @Order(4)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.04.05.04: longest name and longest description")
    void test_04() {
        String subjectName = "xn0DI7kAěbakRNT4ýfqoVPč6gGR1Eáš81AlTžLE6eFázO";
        String subjectInfo = "TMVWéčrísOYis37CsíuUéb8jIKfwMčZžyOčoZ2zůSEšóP";
        Project_Leader_Actions.addUsedExpSuccess(subjectName,subjectInfo,"honzar");
    }

    @Order(5)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.04.05.05: longest name and longest description")
    void test_05() {
        String subjectName = "xn0DI7kAěbakRNT4ýfqoVPč6gGR1Eáš81AlTžLE6eFázO";
        String subjectInfo = "a";
        Project_Leader_Actions.addUsedExpSuccess(subjectName,subjectInfo,"honzar");
    }

    @Order(6)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.04.05.05: shortest name and longest description")
    void test_06() {
        String subjectName = "b";
        String subjectInfo = "xn0DI7kAěbakRNT4ýfqoVPč6gGR1Eáš81AlTžLE6eFázO";;
        Project_Leader_Actions.addUsedExpSuccess(subjectName,subjectInfo,"honzar");
    }
}
