package pstsp.functional_tests.c_one_change.ts_c_05;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;
import pstsp.support.services.entities.storage.ProjectTable;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.project.Project_Mentor_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;

/**
 * edit used exp table as mentor
 *
 * @author David Kuta
 * @version 2022-03-24
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.MENTOR)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.04.02: edit used exp table as mentor")
public class TS_C_05_02 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }


    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @ParameterizedTest(name = "TC.C.05.02.{index}: subject: {0} - info: {1} - choice: {2}")
    @MethodSource("streamForUsedExp")
    void test_01(String subjectName,String subjectInfo, int choice) {
        Project_Mentor_Actions.editUsedExpTblSuccess(subjectName,subjectInfo,choice,"Dobrá trojka","Aplikace pro správu X.509 certifikátů","mentor","motlm");
    }

    static Stream<Arguments> streamForUsedExp() {
        List<String[]> usedExp = new ArrayList<>();
        usedExp.add(new String[]{"KIV/PSA","něco"});
        usedExp.add(new String[]{"KIV/PPA2","další něco"});
        usedExp.add(new String[]{"KIV/ZSWI","Plánování vývoje software"});

        List<Arguments> args = new ArrayList<>();
        for (String[] subj: usedExp) {
            for(int i = ProjectTable.MIN_OPTION; i <= ProjectTable.MAX_OPTION; i++){
                args.add(Arguments.of(subj[0],subj[1],i));
            }
        }
        return args.stream();
    }


}
