package pstsp.functional_tests.c_one_change.ts_c_06;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.team.Team_Page_Meeting_Modal;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * Add meeting as Mentor
 *
 * @author David Kuta
 * @version 2022-03-17
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.MENTOR)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.06.01: Add meeting as mentor")
public class TS_C_06_01 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }


    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.06.01.01: add meeting")
    void test_1() {
        String datetime = "25.4.2022 13:51";
        String room = "CrossCafé";
        String topic = "Oslava obhájení projektu";
        String option = Team_Page_Meeting_Modal.SELECT_OPTION_INTERN;
        String teamName = "Sedm statečných";
        Team_Actions.addMeetingAsMentorSuccess(datetime, room, topic, option, teamName, "mentor");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.06.01.02: add link mentor")
    void test_2() {
        String datetime = "28.6.2022 13:51";
        String room = "U Kata";
        String topic = "Team building pro přípravu projektu";
        String option = Team_Page_Meeting_Modal.SELECT_OPTION_MENTOR;
        String teamName = "Sedm statečných";
        Team_Actions.addMeetingAsMentorSuccess(datetime, room, topic, option, teamName, "mentor");
    }


}
