package pstsp.functional_tests.c_one_change.ts_c_06;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * Edit meeting description as mentor
 *
 * @author David Kuta
 * @version 2022-03-23
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.MENTOR)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.06.02: Edit meeting description as mentor")
public class TS_C_06_02 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_MINOR)
    @DisplayName("TC.C.06.02.01: add meeting description")
    void test_1() {
        String datetime = "26.4.2022 13:51";
        String teamName = "Nejlepší kodéři";
        Team_Actions.editMeetingTopicDescriptionAsMentorSuccess(datetime,"Schůzka byla OK",teamName,"herout");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_MINOR)
    @DisplayName("TC.C.06.02.02: add other meeting description")
    void test_2() {
        String datetime = "24.7.2022 9:00";
        String teamName = "Nejlepší kodéři";
        Team_Actions.editMeetingTopicDescriptionAsMentorSuccess(datetime,"Druhá schůzka byla OK",teamName,"herout");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.IMP_MINOR)
    @DisplayName("TC.C.06.02.03: remove meeting description")
    void test_3() {
        String datetime = "26.4.2022 13:51";
        String teamName = "Nejlepší kodéři";
        Team_Actions.editMeetingTopicDescriptionAsMentorSuccess(datetime,"",teamName,"herout");
    }

    @Order(4)
    @Test
    @Tag(PstspTags.IMP_MINOR)
    @DisplayName("TC.C.06.02.04: remove other meeting description")
    void test_4() {
        String datetime = "24.7.2022 9:00";
        String teamName = "Nejlepší kodéři";
        Team_Actions.editMeetingTopicDescriptionAsMentorSuccess(datetime,"",teamName,"herout");
    }


}
