package pstsp.functional_tests.c_one_change.ts_c_07;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignment.Assignment_Actions;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * Mentor assignment assign
 *
 * @author David Kuta
 * @version 2022-03-17
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.MENTOR)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.07: Mentor assignment assign")
public class TS_C_07 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.C.07.01: assign first assignment")
    void test_1() {
        String assignmentName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String assignmentOwner = "Pan Garant";
        String assignmentOwnerMail = "garant@example.com";
        Assignment_Actions.assignAssignmentToMentor(assignmentName,assignmentOwner,assignmentOwnerMail,"aloneMentor","Sam Mentor","aloneMentor@example.com");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @DisplayName("TC.C.07.02: assign second assignment")
    void test_2() {
        String assignmentName = "Testování webové aplikace";
        String assignmentOwner = "Petr Dobrovolný";
        String assignmentOwnerMail = "dobr@example.com";
        Assignment_Actions.assignAssignmentToMentor(assignmentName,assignmentOwner,assignmentOwnerMail,"aloneMentor","Sam Mentor","aloneMentor@example.com");
    }





}
