package pstsp.functional_tests.c_one_change.ts_c_09;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentswithoutmentormanagement.Assign_Without_Mentor_Management_Actions;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

/**
 * Assignments without mentor management
 *
 * @author David Kuta
 * @version 2022-03-17
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.09.01: Assignments without mentor management - edit")
public class TS_C_09_01 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.01: edit assignment name")
    void test_1() {
        String expectedName = "Rozšíření aplikace pro detekci kolizních drah";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentNameSuccess(expectedName,destAssignName,destAssignOwner,"garant");
    }


    @Order(2)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.02: edit assignment desc")
    void test_2() {
        String expectedDesc = "Nulla quis diam. Sed ac dolor sit amet purus malesuada congue. Praesent vitae arcu tempor neque lacinia pretium. Mauris dictum facilisis augue. Phasellus enim erat, vestibulum vel, aliquam a, posuere eu, velit. Etiam neque. Morbi leo mi, nonummy eget tristique non, rhoncus non leo. Nam quis nulla. Integer malesuada. Proin in tellus sit amet nibh dignissim sagittis. Duis risus. Temporibus autem quibusdam et aut officiis debitis aut rerum necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Mauris dolor felis, sagittis at, luctus sed, aliquam non, tellus. Phasellus rhoncus. Phasellus faucibus molestie nisl. Aliquam in lorem sit amet leo accumsan lacinia. Fusce tellus odio, dapibus id fermentum quis, suscipit id erat. Mauris elementum mauris vitae tortor.";
        String destAssignName = "Extrakce úponových oblastí na povrchu 3D modelu kosti";
        String destAssignOwner = "Karel Vopršálek";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentDescriptionSuccess(expectedDesc,destAssignName,destAssignOwner,"garant");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.03: edit assignment owner first name")
    void test_3() {
        String expectedFirstName = "Bronimír";
        String destAssignName = "Extrakce úponových oblastí na povrchu 3D modelu kosti";
        String expectedAssignmentFullName = "Bronimír Vopršálek";
        String destAssignOwner = "Karel Vopršálek";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerFirstNameSuccess(expectedFirstName, expectedAssignmentFullName,destAssignName,destAssignOwner,"garant");
    }

    @Order(4)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.04: edit assignment owner last name")
    void test_4() {
        String expectedLastName = "Mlýnský";
        String destAssignName = "Filtry ve zpracování medicínských obrazových dat";
        String expectedAssignmentFullName = "Jaroslav Mlýnský";
        String destAssignOwner = "Jaroslav Rýnský";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerLastNameSuccess(expectedLastName, expectedAssignmentFullName,destAssignName,destAssignOwner,"garant");
    }

    @Order(5)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.05: edit assignment owner email")
    void test_5() {
        String expectedEmail = "bronimir@example.com";
        String destAssignName = "Interaktivní vizualizace získaných dat";
        String destAssignOwner = "David Drahý";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerEmailSuccess(expectedEmail,destAssignName,destAssignOwner,"garant");
    }

    @Order(6)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.06: edit assignment owner phone")
    void test_6() {
        String expectedPhone = "456321789";
        String destAssignName = "Interaktivní vizualizace získaných dat";
        String destAssignOwner = "David Drahý";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerPhoneSuccess(expectedPhone,destAssignName,destAssignOwner,"garant");
    }

    @Order(7)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.07: edit assignment owner description")
    void test_7() {
        String expectedOtherInfo = "David drahý z firmy AC.soft";
        String destAssignName = "Interaktivní vizualizace získaných dat";
        String destAssignOwner = "David Drahý";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerOtherInfoSuccess(expectedOtherInfo,destAssignName,destAssignOwner,"garant");
    }

    @Order(8)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.08: edit assignment time needed")
    void test_8() {
        String expectedTime = "1234";
        String destAssignName = "Interaktivní vizualizace získaných dat";
        String destAssignOwner = "David Drahý";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentExpectedTimeSuccess(expectedTime,destAssignName,destAssignOwner,"garant");
    }

    @Order(9)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.09: edit assignment team size")
    void test_9() {
        String expTeamSize = "4";
        String destAssignName = "Interaktivní vizualizace získaných dat";
        String destAssignOwner = "David Drahý";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentTeamSize(expTeamSize,destAssignName,destAssignOwner,"garant");
    }

    @Order(10)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.10: edit assignment tags")
    void test_10() {
        Set<String> teamProfile = new HashSet<>();
        teamProfile.add("PHP");
        teamProfile.add("Frontend");
        String destAssignName = "Interaktivní vizualizace získaných dat";
        String destAssignOwner = "David Drahý";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentExpectedTeamProfile(teamProfile,destAssignName,destAssignOwner,"garant");
    }

    @Order(11)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.11: edit assignment mentor - without")
    void test_11() {
        String mentor = Assign_Without_Mentor_Management_Actions.MENTOR_NOT_ASSIGNED;
        String destAssignName = "Interaktivní vizualizace získaných dat";
        String destAssignOwner = "David Drahý";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentCurrMentor(mentor,destAssignName,destAssignOwner,"garant");
    }

    @Order(12)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.12: edit assignment mentor - with")
    void test_12() {
        String mentor = "One Mentor";
        String destAssignName = "Interaktivní vizualizace získaných dat";
        String destAssignOwner = "David Drahý";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentCurrMentor(mentor,destAssignName,destAssignOwner,"garant");
    }

    @Order(13)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.13: edit assignment visibility - all")
    void test_13() {
        String visibility = Assign_Without_Mentor_Management_Actions.VISIBILITY_ALL;
        String destAssignName = "Neuronové sítě pro zpracování záznamů elektrické aktivity mozku";
        String destAssignOwner = "Václav Elektrický";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentVisibility(visibility,destAssignName,destAssignOwner,"garant");
    }

    @Order(14)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.14: edit assignment visibility - mentor only")
    void test_14() {
        String visibility = Assign_Without_Mentor_Management_Actions.VISIBILITY_MENTOR;
        String destAssignName = "Neuronové sítě pro zpracování záznamů elektrické aktivity mozku";
        String destAssignOwner = "Václav Elektrický";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentVisibility(visibility,destAssignName,destAssignOwner,"garant");
    }

    @Order(15)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @Tag(PstspTags.GARANT)
    @DisplayName("TC.C.09.01.15: edit assignment visibility - hidden")
    void test_15() {
        String visibility = Assign_Without_Mentor_Management_Actions.VISIBILITY_HIDDNEN;
        String destAssignName = "Neuronové sítě pro zpracování záznamů elektrické aktivity mozku";
        String destAssignOwner = "Václav Elektrický";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentVisibility(visibility,destAssignName,destAssignOwner,"garant");
    }
}
