package pstsp.functional_tests.c_one_change.ts_c_10.ts_c_10_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.teammanagement.Team_Management_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

/**
 * edit team name from team management
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.10.02.01: edit team name from team management")
public class TS_C_10_02_01 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.01.01: edit team name")
    void test_01() {
        String expTeamName = "Sedm hrdinů";
        String destTeamName = "Sedm statečných";
        String user = "garant";
        Team_Management_Actions.editTeamNameSuccess(expTeamName, destTeamName, user);
    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.01.02: add member")
    void test_02() {
        Set<String> expected = new HashSet<>();
        expected.add("Jan KUBICE (A19B0114P)");
        expected.add("David KŮTA (A19B0118P)");
        expected.add("Jaroslav LEHEČKA (A19B0121P)");
        expected.add("Miroslav LEVORA (A19B0122P)");
        expected.add("Matěj HOLUBEC (A20B0104P)");
        String expTeamName = "Pět skvělých programátorů";
        String user = "garant";
        Team_Management_Actions.editTeamMembersSuccess(expected, expTeamName, user);
    }

    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.01.03: remove member")
    void test_03() {
        Set<String> expected = new HashSet<>();
        expected.add("Jan KUBICE (A19B0114P)");
        expected.add("David KŮTA (A19B0118P)");
        expected.add("Jaroslav LEHEČKA (A19B0121P)");
        expected.add("Miroslav LEVORA (A19B0122P)");
        String expTeamName = "Pět skvělých programátorů";
        String user = "garant";
        Team_Management_Actions.editTeamMembersSuccess(expected, expTeamName, user);
    }

    @Order(4)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.01.04: set team complete")
    void test_04() {
        boolean complete = true ;
        String destTeamName = "Pět skvělých programátorů";
        String user = "garant";
        Team_Management_Actions.editTeamCompletnessSuccess(complete,destTeamName,user);
    }

    @Order(5)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.01.05: set team incomplete")
    void test_05() {
        boolean complete = false ;
        String destTeamName = "Pět skvělých programátorů";
        String user = "garant";
        Team_Management_Actions.editTeamCompletnessSuccess(complete,destTeamName,user);
    }


}