package pstsp.functional_tests.c_one_change.ts_c_10.ts_c_10_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.teammanagement.Team_Management_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * credit management for team
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.10.02.02: credit management for team")
public class TS_C_10_02_02 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.02.01: add first credit")
    void test_01() {
        String teamName = "Pět skvělých programátorů";
        String leaderName = "kubala";
        String user = "garant";
        Team_Management_Actions.setFirstCreditSuccess("25052022",teamName,leaderName,user);
    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.02.02: remove first creditcredit")
    void test_02() {
        String teamName = "Pět skvělých programátorů";
        String leaderName = "kubala";
        String user = "garant";
        Team_Management_Actions.setFirstCreditSuccess("",teamName,leaderName,user);
    }

    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.02.03: add second credit")
    void test_03() {
        String teamName = "Pět skvělých programátorů";
        String leaderName = "kubala";
        String user = "garant";
        Team_Management_Actions.setSecondCreditSuccess("20122022",teamName,leaderName,user);
    }

    @Order(4)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.02.04: remove second creditcredit")
    void test_04() {
        String teamName = "Pět skvělých programátorů";
        String leaderName = "kubala";
        String user = "garant";
        Team_Management_Actions.setSecondCreditSuccess("",teamName,leaderName,user);
    }


}