package pstsp.functional_tests.c_one_change.ts_c_10.ts_c_10_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.entities.DefenceInfo;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.teammanagement.Team_Management_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * credit management for team
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.10.02.02: credit management for team")
public class TS_C_10_02_03 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.03.01: add first attempt")
    void test_01() {
        DefenceInfo defence = new DefenceInfo(1,"11. 06. 2022","Nesplněno");
        String teamName = "Pět skvělých programátorů";
        String leaderName = "kubala";
        String user = "garant";
        Team_Management_Actions.addDefenceSuccess(defence,teamName,leaderName,user);
    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.10.02.03.02: add second attempt")
    void test_02() {
        DefenceInfo defence = new DefenceInfo(2,"15. 07. 2022","Splněno");
        String teamName = "Pět skvělých programátorů";
        String leaderName = "kubala";
        String user = "garant";
        Team_Management_Actions.addDefenceSuccess(defence,teamName,leaderName,user);
    }

    @Order(3)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.10.02.03.03: third attempt")
    void test_03() {
        DefenceInfo defence = new DefenceInfo(3,"18. 08. 2022","Nespecifikováno");
        String teamName = "Pět skvělých programátorů";
        String leaderName = "kubala";
        String user = "garant";
        Team_Management_Actions.addDefenceSuccess(defence,teamName,leaderName,user);
    }



}