package pstsp.functional_tests.c_one_change.ts_c_11;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentswithoutteam.Assignments_Without_Team_Garant_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * topic suitability table as garant from mentor management
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.11.02: topic suitability table as garant")
public class TS_C_11_02 {


    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.11.02.01: topic suitability n/a")
    void test_01() {
        String teamName = "Vždycky bez tématu";
        String assignmentName = "Administrativní klient pro systém SensLog";
        String mentorFullName = "Pan Mentor";
        String user = "garant";
        Assignments_Without_Team_Garant_Actions.editAssignmentSuitabilityForTeamSuccess(0,teamName,assignmentName,mentorFullName,user);
    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.11.02.02: topic suitability bad")
    void test_02() {
        String teamName = "Vždycky bez tématu";
        String assignmentName = "Administrativní klient pro systém SensLog";
        String mentorFullName = "Pan Mentor";
        String user = "garant";
        Assignments_Without_Team_Garant_Actions.editAssignmentSuitabilityForTeamSuccess(1,teamName,assignmentName,mentorFullName,user);
    }

    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.11.02.03: topic suitability good")
    void test_03() {
        String teamName = "Vždycky bez tématu";
        String assignmentName = "Administrativní klient pro systém SensLog";
        String mentorFullName = "Pan Mentor";
        String user = "garant";
        Assignments_Without_Team_Garant_Actions.editAssignmentSuitabilityForTeamSuccess(2,teamName,assignmentName,mentorFullName,user);
    }
}
