package pstsp.functional_tests.c_one_change.ts_c_12;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.usermanagement.User_Management_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * Add mentor from user management
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.12.01: add mentor from user management")
public class TS_C_12_01 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.12.01.01: classic mentor")
    void test_01() {

        String login = "kdohnal";
        String email = "kdohnnnn@example.com";
        String firstName = "Jaroslav";
        String lastName = "Dohnal";
        User_Management_Actions.addMentorSuccess(login, email, firstName, lastName, "garant");
    }

    @Order(2)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.12.01.02: long mentor")
    void test_02() {

        String login = "SC7CSycYB9OMLMgeI5CKQPNLP3E32uvclnaK6csvCGPTt";
        String email = "long@example.test";
        String firstName = "Long";
        String lastName = "LONG";
        User_Management_Actions.addMentorSuccess(login, email, firstName, lastName, "garant");
    }

    @Order(3)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.12.01.03: short mentor")
    void test_03() {

        String login = "a";
        String email = "a@example.test";
        String firstName = "b";
        String lastName = "c";
        User_Management_Actions.addMentorSuccess(login, email, firstName, lastName, "garant");
    }

}
