package pstsp.functional_tests.c_one_change.ts_c_12;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.usermanagement.User_Management_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * remove users from user management
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.12.02: remove users from user management")
public class TS_C_12_02 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.12.02.01: remove mentor")
    void test_01() {

        String fistName = "Mentor";
        String lastName = "Smazaný";
        String email = "menToDel@test.test";
        String mentorLogin = "menToDel";
        User_Management_Actions.removeMentorSuccess(fistName, lastName, email, mentorLogin, "tsp", "garant");
    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.12.02.02: remove leader")
    void test_02() {

        String fistName = "Druhý";
        String lastName = "Kmazání";
        String email = "secondStudToDel@example.tst";
        String leaderLogin = "secondStudToDel";
        String leaderPass = "tsp";
        User_Management_Actions.removeLeaderSuccess(fistName, lastName, email, leaderLogin, leaderPass, "garant");

    }


}
