package pstsp.functional_tests.c_one_change.ts_c_13.TS_C_13_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentmanagement.Assignment_Management_Actions;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;


/**
 * edit assignment name
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.13.02.01: edit assignment name")
public class TS_C_13_02_01 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
        Home_Actions.resetDB();
    }

    @Order(1)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.13.02.01.01: long name")
    void test_01() {

        String expectedName = "Nejdelší název zadaní který kdy mohl byt vymyslen a dalsi nahodna slova navic, ktere tento dlouhy nazev krasne prodlouzi, jelikoz je to od nej zadouci";
        String assignmentName = "Testování webové aplikace";
        String ownerFirsName = "Petr";
        String ownerLastName = "Dobrovolný";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentNameSuccess(expectedName, assignmentName, ownerFullNAme, "garant");

    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.01.02: regular name")
    void test_02() {

        String expectedName = "Integrace CI/CD do vývojového cyklu aplikací";
        String assignmentName = "Skryté zadání pro testovací účely";
        String ownerFirsName = "Karel";
        String ownerLastName = "Schovaný";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentNameSuccess(expectedName, assignmentName, ownerFullNAme, "garant");

    }

    @Order(2)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.13.02.01.03: short name")
    void test_03() {

        String expectedName = "a";
        String assignmentName = "Extrakce úponových oblastí na povrchu 3D modelu kosti";
        String ownerFirsName = "Karel";
        String ownerLastName = "Vopršálek";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentNameSuccess(expectedName, assignmentName, ownerFullNAme, "garant");
    }

    @Order(2)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.13.02.01.04: diacritic name")
    void test_04() {

        String expectedName = "Příliš žluťoučký kůň úpěl ďábelské ódy";
        String assignmentName = "Filtry ve zpracování medicínských obrazových dat";
        String ownerFirsName = "Jaroslav";
        String ownerLastName = "Rýnský";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentNameSuccess(expectedName, assignmentName, ownerFullNAme, "garant");

    }


}
