package pstsp.functional_tests.c_one_change.ts_c_13.TS_C_13_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentmanagement.Assignment_Management_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;


/**
 * edit assignment description
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.13.02.02: edit assignment description")
public class TS_C_13_02_02 {


    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.13.02.01.01: empty desc")
    void test_01() {
        String expected = "";
        String assignmentName = "Testování webové aplikace";
        String ownerFirsName = "Petr";
        String ownerLastName = "Dobrovolný";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentDescriptionSuccess(expected, assignmentName, ownerFullNAme, "garant");
    }

    @Order(2)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.13.02.01.02: long desc")
    void test_02() {
        String expected = "Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli, but the Little Blind Text didn’t listen. She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove, the headline of Alphabet Village and the subline of her own road, the Line Lane. Pityful a rethoric question ran over her cheek, then she continued her way. On her way she met a copy. The copy warned the Little Blind Text, that where it came from it would have been rewritten a thousand times and everything that was left from its origin would be the word \"and\" and the Little Blind Text should turn around and return to its own, safe country. But nothing the copy said could convince her and so it didn’t take long until a few insidious Copy Writers ambushed her, made her drunk with Longe and Parole and dragged her into their agency, where they abused her for their";
        String assignmentName = "Testování webové aplikace";
        String ownerFirsName = "Petr";
        String ownerLastName = "Dobrovolný";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentDescriptionSuccess(expected, assignmentName, ownerFullNAme, "garant");
    }

    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.01.03: regular desc")
    void test_03() {
        String expected = "Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to";
        String assignmentName = "Testování webové aplikace";
        String ownerFirsName = "Petr";
        String ownerLastName = "Dobrovolný";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentDescriptionSuccess(expected, assignmentName, ownerFullNAme, "garant");
    }

    @Order(4)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.13.02.01.04: diacritic desc")
    void test_04() {
        String expected = "Příliš žliťoučký kůň úpěl ďábelksé ódy";
        String assignmentName = "Testování webové aplikace";
        String ownerFirsName = "Petr";
        String ownerLastName = "Dobrovolný";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentDescriptionSuccess(expected, assignmentName, ownerFullNAme, "garant");
    }

}
