package pstsp.functional_tests.c_one_change.ts_c_13.TS_C_13_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentmanagement.Assignment_Management_Actions;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;


/**
 * edit assignment description
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.13.02.03: edit assignment owner name")
public class TS_C_13_02_03 {


    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
        Home_Actions.resetDB();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.03.01: regular name")
    void test_01() {

        String assignmentName = "Testování webové aplikace";
        String expected1 = "Bořek";
        String expected2 = "Krásný";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerNameSuccess(expected1, expected2, assignmentName, ownerName, "garant");
    }

    @Order(2)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.13.02.03.02: long name")
    void test_02() {
        String assignmentName = "Skryté zadání pro testovací účely";
        String expected1 = "TiNaEeglsZkUnLFhsGuZpghPjMJPSziGbNiZWoZVaDxjHmZWQQwleVGwJikXKBKpgIEDfJSgBxrxTHrnTkHgRXneGnYawNBpLhqn";
        String expected2 = "TiNaEeglsZkUnLFhsGuZpghPjMJPSziGbNiZWoZVaDxjHmZWQQwleVGwJikXKBKpgIEDfJSgBxrxTHrnTkHgRXneGnYawNBpLhqn";
        String ownerName = "Karel Schovaný";
        Assignment_Management_Actions.editAssignmentOwnerNameSuccess(expected1, expected2, assignmentName, ownerName, "garant");
    }

    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.03.03: empty name")
    void test_03() {
        String assignmentName = "Extrakce úponových oblastí na povrchu 3D modelu kosti";
        String expected1 = "";
        String expected2 = "";
        String ownerName = "Karel Vopršálek";
        Assignment_Management_Actions.editAssignmentOwnerNameSuccess(expected1, expected2, assignmentName, ownerName, "garant");
    }

    @Order(4)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.13.02.03.04: diacritic name")
    void test_04() {
        String assignmentName = "Filtry ve zpracování medicínských obrazových dat";
        String expected1 = "Příliš";
        String expected2 = "žluťoučký";
        String ownerName = "Jaroslav Rýnský";
        Assignment_Management_Actions.editAssignmentOwnerNameSuccess(expected1, expected2, assignmentName, ownerName, "garant");
    }

}
