package pstsp.functional_tests.c_one_change.ts_c_13.TS_C_13_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentmanagement.Assignment_Management_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;


/**
 * edit assignment owner email
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.13.02.04: edit assignment owner email")
public class TS_C_13_02_04 {


    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.04.01: regular email")
    void test_01() {
        String expected = "pd@example.com";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerMailSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.04.02: empty email")
    void test_02() {
        String expected = "";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerMailSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(3)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.13.02.04.03: random email")
    void test_03() {
        String expected = "TiNaEeglsZkUnLFhsGuZpghPjMJPSziGbNiZWoZ@aDxjHmZWQQwleVGwJikXKBKpgIEDfJSgBxrxTHrnTkHgRXneGnYawNB.Lhqn";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerMailSuccess(expected, assignmentName, ownerName, "garant");
    }


}
