package pstsp.functional_tests.c_one_change.ts_c_13.TS_C_13_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentmanagement.Assignment_Management_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;


/**
 * edit assignment owner other info
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.13.02.06: edit assignment owner other info")
public class TS_C_13_02_06 {


    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.06.01: regular info")
    void test_01() {
        String expected = "Zadavatel z firmy NECO.soft ochotny jednat";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerOtherInfoSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(2)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.13.02.06.02: longest info")
    void test_02() {
        String expected = "b03vrGlRdPUgQpxBrQRm6NzZX7Jf0zatdhnOjTBXe7o0JZOvU565F0uUBdtD0eqqXs08T5OAUHrA2eXCCl0NmqGeh3ERefuSSUJAAu1yJpuSeV1foxoVUQ3PgdVluzs58yk3TgK0sHRid2YuIxSfNwtZB2Lqg5UsIvWqiGUpm3eS4U3eDcxFgDGdQjy5UEMytxUSs3MgWkZNJy2KqQlXxA6O6EvuyYsRA0adMWX3EnK1zYEx7ZJG9CKeha9vlvR";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerOtherInfoSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.06.03: empty")
    void test_03() {
        String expected = "";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerOtherInfoSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(4)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.13.02.06.04: diacritic")
    void test_04() {
        String expected = "Příliš žliťoučký kůň úpěl ďábelksé ódy";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerOtherInfoSuccess(expected, assignmentName, ownerName, "garant");
    }


}
