package pstsp.functional_tests.c_one_change.ts_c_13.TS_C_13_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentmanagement.Assignment_Management_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;


/**
 * edit assignment team size
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.13.02.08: edit assignment team size")
public class TS_C_13_02_08 {


    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.08.01: regular")
    void test_01() {
        String expected = "7";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamSizeSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(2)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.13.02.08.02: big")
    void test_02() {
        String expected = "100";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamSizeSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.08.03: empty")
    void test_03() {
        String expected = "";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamSizeSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(4)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.13.02.08.04: small")
    void test_04() {
        String expected = "1";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamSizeSuccess(expected, assignmentName, ownerName, "garant");
    }


}
