package pstsp.functional_tests.c_one_change.ts_c_13.TS_C_13_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentmanagement.Assignment_Management_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;


/**
 * edit assignment profile
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.13.02.09: edit assignment profile")
public class TS_C_13_02_09 {


    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.09.01: empty")
    void test_01() {
        Set<String> expected = new HashSet<>();
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamProfileSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(2)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.13.02.09.02: 3 profiles")
    void test_02() {
        Set<String> expected = new HashSet<>();
        expected.add("PHP");
        expected.add("Frontend");
        expected.add("JavaScript");
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamProfileSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.09.03: remove 3 profiles")
    void test_03() {
        Set<String> expected = new HashSet<>();
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamProfileSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Order(4)
    @Tag(PstspTags.IMP_MAJOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.13.02.09.04: 6 profiles")
    void test_04() {
        Set<String> expected = new HashSet<>();
        expected.add("Frontend");
        expected.add("JavaScript");
        expected.add("Backend");
        expected.add("C");
        expected.add("C#");
        expected.add("Java");
        expected.add("C++");
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamProfileSuccess(expected, assignmentName, ownerName, "garant");
    }


}
