package pstsp.functional_tests.c_one_change.ts_c_13.TS_C_13_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentmanagement.Assignment_Management_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;


/**
 * edit assignment visibility
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.13.02.09: edit assignment visibility")
public class TS_C_13_02_11 {


    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.10.01: no mentor hidden")
    void test_01() {
        String expected = "Skryté";
        boolean withMentor = false;
        String assignmentName = "Neuronové sítě pro zpracování záznamů elektrické aktivity mozku";
        String ownerName = "Václav Elektrický";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Order(2)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.13.02.10.02: no mentor visible for mentors")
    void test_02() {
        String expected = "Viditelné pouze pro mentory";
        boolean withMentor = false;
        String assignmentName = "Neuronové sítě pro zpracování záznamů elektrické aktivity mozku";
        String ownerName = "Václav Elektrický";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Order(3)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.13.02.10.03: no mentor visible for all")
    void test_03() {

        String expected = "Publikováno pro všechny";
        boolean withMentor = false;
        String assignmentName = "Neuronové sítě pro zpracování záznamů elektrické aktivity mozku";
        String ownerName = "Václav Elektrický";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Order(4)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.13.02.10.04: with mentor hidden")
    void test_04() {
        String expected = "Skryté";
        boolean withMentor = true;
        String assignmentName = "Strojové zpracování vizuálního obsahu";
        String ownerName = "Pavel Herout";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Order(5)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.13.02.10.05: with mentor visible for mentors")
    void test_05() {

        String expected = "Viditelné pouze pro mentory";
        boolean withMentor = true;
        String assignmentName = "Strojové zpracování vizuálního obsahu";
        String ownerName = "Pavel Herout";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Order(6)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.02.10.06: with mentor visible for all")
    void test_06() {
        String expected = "Publikováno pro všechny";
        boolean withMentor = true;
        String assignmentName = "Strojové zpracování vizuálního obsahu";
        String ownerName = "Pavel Herout";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant", withMentor);

    }
}
