package pstsp.functional_tests.c_one_change.ts_c_14;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmentmanagement.Assignment_Management_Actions;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.tagmanagement.Tag_Management_Actions;
import pstsp.support.services.usermanagement.User_Management_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

/**
 * add team role
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.14.01: add team role")
public class TS_C_14_01 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.14.01.01: add short role")
    void test_01() {
        String name = "a";
        String color = "Fialová";
        boolean enabled = true;
        String user = "garant";
        Tag_Management_Actions.addTeamRoleSuccess(name,color,enabled,user);

    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.14.01.02: add classic role")
    void test_02() {
        String name = "DevOps Master";
        String color = "Černá";
        boolean enabled = true;
        String user = "garant";
        Tag_Management_Actions.addTeamRoleSuccess(name,color,enabled,user);
    }

    @Order(3)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.14.01.03: add long role")
    void test_03() {
        String name = "UFVjEEDI4ASlWMZHR0CE9OrXDptLpFMlWSDkKcVj0YQji";
        String color = "Žlutá";
        boolean enabled = true;
        String user = "garant";
        Tag_Management_Actions.addTeamRoleSuccess(name,color,enabled,user);
    }

    @Order(4)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.14.01.04: add non usable role")
    void test_04() {
        String name = "Nepoužitelná role";
        String color = "Tyrkysová";
        boolean enabled = false;
        String user = "garant";
        Tag_Management_Actions.addTeamRoleSuccess(name,color,enabled,user);
    }

}