package pstsp.functional_tests.c_one_change.ts_c_14;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.tagmanagement.Tag_Management_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * edit team role
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.14.02: edit team role")
public class TS_C_14_02 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.14.01.01: edit short role")
    void test_01() {
        String name = "a";
        String color = "Fialová";
        boolean enabled = true;

        String destName = "Programátor";
        String destColor = "Modrá";
        boolean destEnabled = true;
        String user = "garant";

        Tag_Management_Actions.editTeamRoleSuccess(name,color,enabled,destName,destColor,destEnabled,user);

    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.14.02.02: edit classic role")
    void test_02() {
        String name = "DevOps Master";
        String color = "Oranžová";
        boolean enabled = true;

        String destName = "Tester";
        String destColor = "Žlutá";
        boolean destEnabled = true;
        String user = "garant";

        Tag_Management_Actions.editTeamRoleSuccess(name,color,enabled,destName,destColor,destEnabled,user);
    }

    @Order(3)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.14.02.03: edit long role")
    void test_03() {
        String name = "UFVjEEDI4ASlWMZHR0CE9OrXDptLpFMlWSDkKcVj0YQji";
        String color = "Limetková";
        boolean enabled = true;

        String destName = "Dokumentarista";
        String destColor = "Zelená";
        boolean destEnabled = true;
        String user = "garant";

        Tag_Management_Actions.editTeamRoleSuccess(name,color,enabled,destName,destColor,destEnabled,user);
    }

    @Order(4)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.14.02.04: edit non use role")
    void test_04() {
        String name = "Nepoužitelná role";
        String color = "Šedá";
        boolean enabled = true;

        String destName = "Grafik";
        String destColor = "Tyrkysová";
        boolean destEnabled = true;
        String user = "garant";

        Tag_Management_Actions.editTeamRoleSuccess(name,color,enabled,destName,destColor,destEnabled,user);
    }

}