package pstsp.functional_tests.c_one_change.ts_c_14;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.tagmanagement.Tag_Management_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * add profile
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.14.03: add  pofile")
public class TS_C_14_03 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.14.03.01: add short profile")
    void test_01() {
        String name = "a";
        boolean enabled = true;
        String user = "garant";
        Tag_Management_Actions.addTeamProfileSuccess(name,enabled,user);

    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.14.03.02: add classic profile")
    void test_02() {
        String name = "Selenium";
        boolean enabled = true;
        String user = "garant";
        Tag_Management_Actions.addTeamProfileSuccess(name,enabled,user);
    }

    @Order(3)
    @Tag(PstspTags.IMP_MINOR)
    @Test
    @DisplayName("TC.C.14.03.03: add long profile")
    void test_03() {
        String name = "UFVjEEDI4ASlWMZHR0CE9OrXDptLpFMlWSDkKcVj0YQji";
        boolean enabled = true;
        String user = "garant";
        Tag_Management_Actions.addTeamProfileSuccess(name,enabled,user);
    }

    @Order(4)
    @Tag(PstspTags.IMP_MAJOR)
    @Test
    @DisplayName("TC.C.14.03.04: add non usable profile")
    void test_04() {
        String name = "Nepoužitelný profil";
        boolean enabled = false;
        String user = "garant";
        Tag_Management_Actions.addTeamProfileSuccess(name,enabled,user);
    }

}