package pstsp.functional_tests.c_one_change.ts_c_15;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.assignmenttoteammanagement.Assignment_To_Team_Management_Actions;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * garant assignment to team management
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.15.01: garant assignment to team management")
public class TS_C_15_01 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.15.01.01: team 1")
    void test_01() {

        String teamName = "Čtyři stateční";
        String assignmentName = "Rozšíření Genealogy pluginu";
        Assignment_To_Team_Management_Actions.assignAssignmentToTeam(assignmentName, teamName,"garant","mentor","stricz");
    }

    @Order(2)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.15.01.02: team 2")
    void test_02() {

        String teamName = "Papírníci";
        String assignmentName = "Rehabilitační hra pro virtuální realitu";
        Assignment_To_Team_Management_Actions.assignAssignmentToTeam(assignmentName, teamName,"garant","mentor","papirnik");
    }
    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.15.01.03: team 3")
    void test_03() {

        String teamName = "Tým bez tématu Soch";
        String assignmentName = "Konfigurovatelný dashboard zobrazování senzorových dat";
        Assignment_To_Team_Management_Actions.assignAssignmentToTeam(assignmentName, teamName,"garant","herout","sochorec");
    }

}
