package pstsp.functional_tests.c_one_change.ts_c_16;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.studentmanagement.Student_Management_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * add students from student management
 *
 * @author David Kuta
 * @version 2022-04-22
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ONE_CHANGE)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.GARANT)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.C.16.01: add student from student management")
public class TS_C_16_01 {

    @BeforeAll
    public static void setup() {
        Home_Actions.resetDB();
    }

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.16.01.01: add classic student")
    void test_01() {

        String login ="creatStudLogin";
        String firstName ="Karel";
        String lastName ="Kohout";
        String email ="kkohout@example.com";
        String personalID ="A12B1224C";
        String periodTSP ="LS 21/22 - ZS 22/23";
        String fieldOfStudy ="";
        String faculty ="";
        Student_Management_Actions.addStudent(login,firstName,lastName,email,personalID,periodTSP,fieldOfStudy,faculty,"garant", "leader");
    }

    @Order(2)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.16.01.02: add long student")
    void test_02() {

        String login ="K1YU3ZSJVZD1LPTNBHME1JNIUJGDP04ZVKPJ3D2DQ15U2";
        String firstName ="XIWJ21TUO62V7H7JPYHRXWY10YMRT3UODP7WVM6BTDFFG";
        String lastName ="XIWJ21TUO62V7ASDPYHRXWY10YMRT3UODP7WVM6BTDFFG";
        String email ="LMZU3VNFS6OTJ23IPRIANJ4UEQA6WW0SA978RFGQ9NOV77FZB5AJQKAR51T9E791E43XQ5RT9PP0CXXLUQEPBG5RMYM5H2BA745BV3Y4V5FEWSH@W8LHI9A9K3EF7H78USZR971GZH63RXQFLRWRANI4GL15VLC2B6NK3IHS2PLZW341WMWFUDAN3I2AE11E19.QTIUS";
        String personalID ="6LWVFF33ZS0GM65R8R8H53NILLU92WXY1TUS7MYBP9BRL";
        String periodTSP ="LS 21/22 - ZS 22/23";
        String fieldOfStudy ="";
        String faculty ="";
        Student_Management_Actions.addStudent(login,firstName,lastName,email,personalID,periodTSP,fieldOfStudy,faculty,"garant", "leader");
    }

    @Order(3)
    @Tag(PstspTags.IMP_MINOR)
    @Tag(PstspTags.BOUNDARY)
    @Test
    @DisplayName("TC.C.16.01.03: add short student")
    void test_03() {

        String login ="b";
        String firstName ="c";
        String lastName ="d";
        String email ="bt@c.d";
        String personalID ="A";
        String periodTSP ="LS 21/22 - ZS 22/23";
        String fieldOfStudy ="";
        String faculty ="";
        Student_Management_Actions.addStudent(login,firstName,lastName,email,personalID,periodTSP,fieldOfStudy,faculty,"garant", "leader");
    }


}
