package pstsp.functional_tests.d_negative.ts_d_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.negative.team.Neg_Team_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

/**
 * team member roles
 *
 * @author David Kuta
 * @version 2022-04-25
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@Tag(PstspTags.NEGATIVE)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.D.02.02: team member roles")
public class TS_D_02_02 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.02.02.01: blank team name")
    void test_1() {
        Set<String> roles = new HashSet<>();
        roles.add("Programátor");
        roles.add("Dokumentarista");
        roles.add("Tester");
        roles.add("Grafik");
        Neg_Team_Actions.editTeamMemberRolesNegative(roles,"Pan Vedoucí (AxxBxxxxP)","Můžou být vybrány maximálně 3 předvolby","leader");
    }
}
