package pstsp.functional_tests.d_negative.ts_d_02;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.negative.team.Neg_Team_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

/**
 * invalid meeting
 *
 * @author David Kuta
 * @version 2022-04-25
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@Tag(PstspTags.NEGATIVE)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.D.02.03: invalid meeting")
public class TS_D_02_03 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }



    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.02.03.01: blank room")
    void test_021() {
        String date="21032000";
        String time="20:23";
        String room="";
        String topic="NECO";
        String expectedMessage = "Místo setkání musí být vyplněno.";
        Neg_Team_Actions.addMeetingAsLeaderNegative(date,time,topic,room,expectedMessage,"leader");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.02.03.02: blank topic")
    void test_02() {
        String date="21032000";
        String time="20:23";
        String room="FAV";
        String topic="";
        String expectedMessage = "Obsah schůzky musí být vyplněn.";
        Neg_Team_Actions.addMeetingAsLeaderNegative(date,time,topic,room,expectedMessage,"leader");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.02.03.03: blank date")
    void test_03() {
        String date="";
        String time="";
        String room="FAV";
        String topic="NECO";
        String expectedMessage = "Termín schůzky musí být vyplněn.";
        Neg_Team_Actions.addMeetingAsLeaderNegative(date,time,topic,room,expectedMessage,"leader");
    }
}
