package pstsp.functional_tests.d_negative.ts_d_03;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.negative.login.Neg_Login_Actions;
import pstsp.support.services.negative.project.Neg_Project_Actions;
import pstsp.support.services.negative.team.Neg_Team_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.ArrayList;
import java.util.List;

/**
 * edit project links
 *
 * @author David Kuta
 * @version 2022-04-25
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.LEADER)
@Tag(PstspTags.NEGATIVE)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.D.03.01: edit project links")
public class TS_D_03_01 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.03.01.01: 1 invalid")
    void test_1() {
        List<String> otherLinks = new ArrayList<>();
        otherLinks.add("asdsd");
        Neg_Project_Actions.setOtherUrlsNegative(otherLinks,"Zadané odkazy nejsou ve formátu: NAZEV;URL.","hintik");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.03.01.02: 2 invalid")
    void test_2() {
        List<String> otherLinks = new ArrayList<>();
        otherLinks.add("asdsd\nABSC;dsds");
        Neg_Project_Actions.setOtherUrlsNegative(otherLinks,"Zadané odkazy nejsou ve formátu: NAZEV;URL.","hintik");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.03.01.03: 2 valid 1 invalid")
    void test_3() {
        List<String> otherLinks = new ArrayList<>();
        otherLinks.add("Google;https://www.google.com\nInvalid;invalid\nSeznam;https://www.seznam.cz");
        Neg_Project_Actions.setOtherUrlsNegative(otherLinks,"Zadané odkazy nejsou ve formátu: NAZEV;URL.","hintik");
    }
}
