package pstsp.functional_tests.d_negative.ts_d_04;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.negative.login.Neg_Login_Actions;
import pstsp.support.services.negative.team.Neg_Team_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

/**
 * invalid add mentor meeting
 *
 * @author David Kuta
 * @version 2022-04-25
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.MENTOR)
@Tag(PstspTags.NEGATIVE)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.D.04.01: invalid add mentor meeting")
public class TS_D_04_01 {

    @AfterAll
    public static void tearDownAfterAll() {
        Login_Actions.logoutIfPossible();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.04.01: blank room")
    void test_01() {
        String date="21032000";
        String time="20:23";
        String room="";
        String topic="NECO";
        String expectedMessage = "Místo setkání musí být vyplněno.";
        Neg_Team_Actions.addMeetingAsMentorNegative(date,time,topic,room,expectedMessage,"Pět skvělých programátorů","mentor");
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.04.02: blank topic")
    void test_02() {
        String date="21032000";
        String time="20:23";
        String room="FAV";
        String topic="";
        String expectedMessage = "Obsah schůzky musí být vyplněn.";
        Neg_Team_Actions.addMeetingAsMentorNegative(date,time,topic,room,expectedMessage,"Pět skvělých programátorů","mentor");
    }

    @Order(3)
    @Test
    @Tag(PstspTags.IMP_CRITICAL)
    @DisplayName("TC.D.04.03: blank date")
    void test_03() {
        String date="";
        String time="";
        String room="FAV";
        String topic="NECO";
        String expectedMessage = "Termín schůzky musí být vyplněn.";
        Neg_Team_Actions.addMeetingAsMentorNegative(date,time,topic,room,expectedMessage,"Pět skvělých programátorů","mentor");
    }
}
