package pstsp.functional_tests.e_endtoend;

import org.junit.jupiter.api.*;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.login.Home_Actions;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.negative.login.Neg_Login_Actions;
import pstsp.support.services.negative.team.Neg_Team_Actions;
import pstsp.support.services.project.Project_Leader_Actions;
import pstsp.support.services.project.Project_Mentor_Actions;
import pstsp.support.services.scenario.Scenario_Leader_Actions;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.*;

/**
 * mentor e2e tests
 *
 * @author David Kuta
 * @version 2022-04-29
 */
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
@Tag(PstspTags.ACTIVE)
@Tag(PstspTags.MENTOR)
@Tag(PstspTags.END_TO_END)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@DisplayName("TS.E.02: mentor e2e tests")
public class TS_E_02 {

    @BeforeEach
    public void init() {
        Home_Actions.resetDB();
    }

    @Order(1)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @DisplayName("TC.E.02.01: mentor project page edit")
    void test_01() {

        String leaderName = "vikkot";
        String teamName = "Sedm statečných";
        String assignmentName = "Modularizovatelná webová aplikace s modulem pro správu cílů";
        String mentorName = "mentor";

        Project_Mentor_Actions.editMinCritTblSuccess("Plán projektu",0,teamName,assignmentName,
                mentorName,leaderName);

        Project_Mentor_Actions.editProjStateTblSuccess("Odkaz na dokument předání výsledků zadavateli",1,teamName,assignmentName,
                mentorName,leaderName);

        Project_Mentor_Actions.editProjStateTblSuccess("Odkaz na softwarové řízení projektu",3,teamName,assignmentName,
                mentorName,leaderName);

        Project_Mentor_Actions.editUsedExpTblSuccess("KIV/PPA2","Využití datových struktur",2,teamName,assignmentName,mentorName,leaderName);
    }

    @Order(2)
    @Test
    @Tag(PstspTags.IMP_MAJOR)
    @DisplayName("TC.E.02.02: add meeting and set description")
    void test_02() {
        String teamName = "Jedničky";
        String mentorName = "oneMentor";
        Team_Actions.addMeetingAsMentorSuccess("23.6.2022 14:30","UC.421","Meeting","Mentor",teamName,mentorName);
        Team_Actions.editMeetingTopicDescriptionAsMentorSuccess("23.6.2022 14:30","Schůzka se vydařila",teamName,mentorName);
    }
}