package pstsp.run_tests;

/**
 * Class for external running set of SMOKE tests
 *
 * @author Pavel Herout
 * @version 2022-01-25
 */

import pstsp.support.test_utils.PstspTags;

import org.junit.platform.launcher.Launcher;
import org.junit.platform.launcher.LauncherDiscoveryRequest;
import org.junit.platform.launcher.core.LauncherDiscoveryRequestBuilder;
import org.junit.platform.launcher.core.LauncherFactory;

import static org.junit.platform.engine.discovery.DiscoverySelectors.selectPackage;
import static org.junit.platform.launcher.TagFilter.excludeTags;
import static org.junit.platform.launcher.TagFilter.includeTags;

public class RunSmokeTests {

  public static void main(String[] args) {
    LauncherDiscoveryRequest request = LauncherDiscoveryRequestBuilder.request()
            .selectors(
                    selectPackage("pstsp.functional_tests")
            )
            .filters(
               includeTags(PstspTags.SMOKE),
               excludeTags(PstspTags.FAIL)
            )
            .build();
    Launcher launcher = LauncherFactory.create();
    launcher.execute(request);
  }
}
