package pstsp.support.basic;

/**
 * General constants
 *
 * @author Pavel Herout
 * @version 2022-01-20
 */

public class Const {
  /** initial string for a failed logging message */
  public static final String ERROR_LABEL = "TSP_ERR: ";

  /** password for any garant or any mentor od any leader
   *  it cannot be changed anywhere
   */
  public static final String CORRECT_PASSWORD = "tsp";

  public static final String ROLE_MENTOR = "mentor";
  public static final String ROLE_LEADER = "leader";
  public static final String ROLE_GARANT = "garant";
  /**
   * Title label ID for all pages
   */
  public static final String BASE_TITLE_ID = "base-caption";

  /**
   * Class for all bootstrap errors
   */
  public static final String ERROR_CLASS = "error";

  /** repeating elements in tables have ID composed from
   *    the fixed part, e.g. code{stu.mySubjects.enrolledTable.unenrollSubjectButton-}
   *    and a variable part which is a number
   *
   *  whole ID eg. code{stu.mySubjects.enrolledTable.unenrollSubjectButton-0}
   *
   *  The first element has a number 0
   */
  public static final String FIRST_ELEMENT = "0";

  public static final String NOT_LOGGED_INFO = "USER_NOT_LOGGED";

  // Constraints
  // Limitations regarding users
  public static final int FIRST_NAME_MIN_LENGTH = 2;
  public static final int FIRST_NAME_MAX_LENGTH = 30;
  public static final int LAST_NAME_MIN_LENGTH = 2;
  public static final int LAST_NAME_MAX_LENGTH = 30;
  public static final int EMAIL_MIN_LENGTH = 2;
  public static final int EMAIL_MAX_LENGTH = 40;

  /** default timeout for clicks */
  public static final int DEFAULT_TIMEOUT = 10;
}
