package pstsp.support.basic;

import java.util.HashSet;
import java.util.Set;

/**
 * All URLs in whole application
 **
 * @author Pavel Herout
 * @version 2022-01-20
 */

public class Url {

  /** the value from configuration file
   * @see Configurations
   * */
  public static String BASE_URL;

  public static String URL_NONE = "data:,";

  public static String URL_LOGIN;
  public static String URL_LOGOUT;
  public static String URL_LOGIN_ERROR;
  public static String URL_ASSIGNMENT_LIST;
  public static String URL_INCOMPLETE_TEAM;
  public static String URL_GAR_BASE;

  public static String URL_MEN_BASE;
  public static String URL_MEN_PROJECTS;

  public static String URL_LEA_BASE;
  public static String URL_LEA_PROJECT;
  public static String URL_LEA_PROJECT_EDIT_LINKS;

  public static String URL_ASSIGNMENT;

  /** set of known URL's */
  private static Set<String> loginPageUrlsSet;

  /**
   * prepare all possible URLs in the whole application
   */
  public static void setConstantURLs() {
    if (BASE_URL.endsWith("/") == false) {
      BASE_URL += "/";
    }

    URL_LOGIN = BASE_URL + "sign/in";
    URL_LOGOUT = BASE_URL + "sign/in?_fid=do9k";
    URL_LOGIN_ERROR = URL_LOGIN + "sign/in";
    URL_ASSIGNMENT_LIST = BASE_URL + "assignment-list/";
    URL_INCOMPLETE_TEAM = BASE_URL + "incomplete-teams/";
    loginPageUrlsSet = new HashSet<>();
    loginPageUrlsSet.add(URL_NONE);
//    loginPageUrlsSet.add(BASE_URL);
    loginPageUrlsSet.add(URL_LOGIN);
    loginPageUrlsSet.add(URL_LOGOUT);

    URL_GAR_BASE = BASE_URL + "";

    URL_MEN_BASE = BASE_URL + "";
    URL_MEN_PROJECTS = URL_MEN_BASE + "mentored-projects/";

    URL_LEA_BASE = BASE_URL + "";
    URL_LEA_PROJECT = URL_LEA_BASE + "project/show/";
  }

  /**
   * check if url is valid for logging activity
   *
   * @param url current URL
   */
  public static boolean isValidLoginPageURL(String url) {
    return loginPageUrlsSet.contains(url);
  }

}
