package pstsp.support.pageobjects.assignment;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import org.openqa.selenium.support.ui.Select;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

/**
 * Leader make interrest modal
 * Leader
 * @author David Kuta
 */
public class Assignment_Page_Leader_Interrest_Modal extends PageObject {

    public static final String PAGE_ID = "modal-show-interest";
    public static final String WEIGHT_SELECT = "frm-showInterestForm-weight";
    public static final String SUBMIT_BUTTON = "frm-showInterestForm-submit";
    public static final String CANCEL_BUTTON = "frm-showInterestForm-cancel";

    @FindBy(id = WEIGHT_SELECT)
    private List<WebElement> weightSelect;

    @FindBy(id = SUBMIT_BUTTON)
    private List<WebElement> submitButton;

    @FindBy(id = CANCEL_BUTTON)
    private List<WebElement> cancelButton;

    public List<String> getOptionsToSelect(){
        WebElement element = getElement(weightSelect, WEIGHT_SELECT);
        Select select = new Select(element);
        List<String> options = new ArrayList<>();
        select.getOptions().forEach(a -> options.add(a.getText()));
        return options;
    }

    public void selectWeightByVisibleText(String value){
        WebElement element = getElement(weightSelect, WEIGHT_SELECT);
        Select select = new Select(element);
       select.selectByVisibleText(value);
    }

    public void closeModal(){
        WebElement element = getElement(cancelButton, CANCEL_BUTTON);
        Click.clickAndWaitId(element, Assignment_Page.PAGE_ID);
    }

    public void clickOnSubmit(){
        WebElement element = getElement(submitButton, SUBMIT_BUTTON);
        Click.clickAndWaitId(element, Assignment_Page.PAGE_ID);
    }
}
