package pstsp.support.pageobjects.assignment;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;

import java.util.List;
/**
 * Mentor assign assignment modal
 * Mentor
 * @author David Kuta
 */
public class Assignment_Page_Mentor_Assign_Modal extends PageObject {
    public static final String PAGE_ID = "modal-mentor-confirm";
    public static final String CANCEL_BTN = "assignmentPage-mentorAssignment-cancel";
    public static final String SUBMIT_BTN = "assignmentPage-mentorAssignment-submit";

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitButton;

    @FindBy(id = CANCEL_BTN)
    private List<WebElement> cancelButton;

    public void closeModal(){
        WebElement element = getElement(cancelButton, CANCEL_BTN);
        Click.clickAndWaitId(element, Assignment_Page.PAGE_ID);
    }

    public void clickOnSubmit(){
        WebElement element = getElement(submitButton, SUBMIT_BTN);
        Click.clickAndWaitId(element, Assignment_Page.PAGE_ID);
    }


}
