package pstsp.support.pageobjects.assignmentmanagement;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import org.openqa.selenium.support.ui.Select;
import pstsp.support.basic.Const;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.pageobjects.team.Team_Page;
import pstsp.support.selenium_utils.Click;

import java.util.HashSet;
import java.util.List;
import java.util.Set;
/**
 * Form for assignment edit and create
 * Garant
 * @author David Kuta
 */
public class Assignment_Form_Page_Object extends PageObject {

    public static final String ASSIGNMENT_NAME = "frm-assignmentCreationForm-name";
    public static final String ASSIGN_DESC = "frm-assignmentCreationForm-description";
    public static final String OWNER_FIRSTNAME = "frm-assignmentCreationForm-creatorFirstname";
    public static final String OWNER_LASTNAME = "frm-assignmentCreationForm-creatorLastname";
    public static final String OWNER_EMAIL = "frm-assignmentCreationForm-creatorEmail";
    public static final String OWNER_PHONE = "frm-assignmentCreationForm-creatorPhone";
    public static final String OWNER_OTHER_INFO = "frm-assignmentCreationForm-creatorInfo";
    public static final String TIME_NEEDED = "frm-assignmentCreationForm-duration";
    public static final String TEAM_SIZE = "frm-assignmentCreationForm-teamSize";
    public static final String ASSIGNMENT_PROFILE_MS = "frm-assignmentCreationForm-profile";
    public static final String ASSIGNMENT_MENTOR_S = "frm-assignmentCreationForm-mentor";
    public static final String ASSIGNMENT_PERIOD_S = "frm-assignmentCreationForm-period";
    public static final String VISIBILITY_S = "frm-assignmentCreationForm-visibility";
    public static final String SUBMIT_BTN = "frm-assignmentCreationForm-submit";
    public static final String BACK_BTN = "frm-assignmentCreationForm-cancel";

    @FindBy(id = ASSIGNMENT_NAME)
    private List<WebElement> assignmentName;

    @FindBy(id = ASSIGN_DESC)
    private List<WebElement> assignmentDesc;

    @FindBy(id = OWNER_FIRSTNAME)
    private List<WebElement> ownerFirstname;

    @FindBy(id = OWNER_LASTNAME)
    private List<WebElement> ownerLastname;

    @FindBy(id = OWNER_EMAIL)
    private List<WebElement> ownerEmail;

    @FindBy(id = OWNER_PHONE)
    private List<WebElement> ownerPhone;

    @FindBy(id = OWNER_OTHER_INFO)
    private List<WebElement> ownerOtherInfo;

    @FindBy(id = TIME_NEEDED)
    private List<WebElement> timeNeeded;

    @FindBy(id = TEAM_SIZE)
    private List<WebElement> teamSize;

    @FindBy(id = ASSIGNMENT_PROFILE_MS)
    private List<WebElement> assignmentProfile_multiS;

    @FindBy(id = ASSIGNMENT_MENTOR_S)
    private List<WebElement> assignmentMentor;

    @FindBy(id = ASSIGNMENT_PERIOD_S)
    private List<WebElement> assignmentPeriod;

    @FindBy(id = VISIBILITY_S)
    private List<WebElement> assignmentVisibility;

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitBTN;

    @FindBy(id = BACK_BTN)
    private List<WebElement> backBTN;


    public void setAssignmentName(String name) {
        WebElement element = getElement(assignmentName, ASSIGNMENT_NAME);
        element.clear();
        element.sendKeys(name);
    }

    public String getAssignmentName() {
        WebElement element = getElement(assignmentName, ASSIGNMENT_NAME);
        return element.getAttribute("value");
    }

    public void setAssignmentDesc(String desc) {
        WebElement element = getElement(assignmentDesc, ASSIGN_DESC);
        element.clear();
        element.sendKeys(desc);
    }

    public String getAssignmentDesc() {
        WebElement element = getElement(assignmentDesc, ASSIGN_DESC);
        return element.getAttribute("value");
    }

    public void setOwnerFirstname(String ownerFirstnamec) {
        WebElement element = getElement(ownerFirstname, OWNER_FIRSTNAME);
        element.clear();
        element.sendKeys(ownerFirstnamec);
    }

    public String getOwnerFirstname() {
        WebElement element = getElement(ownerFirstname, OWNER_FIRSTNAME);
        return element.getAttribute("value");
    }

    public void setOwnerLastname(String ownerFirstnamec) {
        WebElement element = getElement(ownerLastname, OWNER_LASTNAME);
        element.clear();
        element.sendKeys(ownerFirstnamec);
    }

    public String getOwnerLastname() {
        WebElement element = getElement(ownerLastname, OWNER_LASTNAME);
        return element.getAttribute("value");
    }

    public void setOwnerEmail(String ownerEmail) {
        WebElement element = getElement(this.ownerEmail, OWNER_EMAIL);
        element.clear();
        element.sendKeys(ownerEmail);
    }

    public String getOwnerEmail() {
        WebElement element = getElement(this.ownerEmail, OWNER_EMAIL);
        return element.getAttribute("value");
    }

    public void setOwnerPhone(String ownerPhone) {
        WebElement element = getElement(this.ownerPhone, OWNER_PHONE);
        element.clear();
        element.sendKeys(ownerPhone);
    }

    public String getOwnerPhone() {
        WebElement element = getElement(this.ownerPhone, OWNER_PHONE);
        return element.getAttribute("value");
    }

    public void setOwnerOtherInfo(String ownerOtherInfo) {
        WebElement element = getElement(this.ownerOtherInfo, OWNER_OTHER_INFO);
        element.clear();
        element.sendKeys(ownerOtherInfo);
    }

    public String getOwnerOtherInfo() {
        WebElement element = getElement(this.ownerOtherInfo, OWNER_OTHER_INFO);
        return element.getAttribute("value");
    }

    public void setTimeNeeded(String timeNeeded) {
        WebElement element = getElement(this.timeNeeded, TIME_NEEDED);
        element.clear();
        element.sendKeys(timeNeeded);
    }

    public String getTimeNeeded() {
        WebElement element = getElement(this.timeNeeded, TIME_NEEDED);
        return element.getAttribute("value");
    }

    public void setTeamSize(String teamSize) {
        WebElement element = getElement(this.teamSize, TEAM_SIZE);
        element.clear();
        element.sendKeys(teamSize);
    }

    public String getTeamSize() {
        WebElement element = getElement(this.teamSize, TEAM_SIZE);
        return element.getAttribute("value");
    }

    public void setAssignmentProfile(Set<String> profiles) {
        WebElement element = getElement(this.assignmentProfile_multiS, ASSIGNMENT_PROFILE_MS);
        Select sel = new Select(element);
        sel.deselectAll();
        profiles.forEach(a -> sel.selectByVisibleText(a));

    }

    public Set<String> getAssignmentProfile() {
        WebElement st = getElement(this.assignmentProfile_multiS, ASSIGNMENT_PROFILE_MS);
        Select select = new Select(st);
        Set<String> selectedOptions = new HashSet<>();
        select.getAllSelectedOptions().forEach(option -> selectedOptions.add(option.getText().strip()));
        return selectedOptions;
    }

    public Set<String> getAllAvailableProfiles() {
        WebElement st = getElement(this.assignmentProfile_multiS, ASSIGNMENT_PROFILE_MS);
        Select select = new Select(st);
        Set<String> allOptions = new HashSet<>();
        select.getOptions().forEach(option -> allOptions.add(option.getText().strip()));
        return allOptions;
    }

    public void setMentor(String mentor) {
        WebElement element = getElement(this.assignmentMentor, ASSIGNMENT_MENTOR_S);
        Select sel = new Select(element);
        sel.selectByVisibleText(mentor);

    }

    public String getCurrentMentor() {
        WebElement element = getElement(this.assignmentMentor, ASSIGNMENT_MENTOR_S);
        Select select = new Select(element);
        Set<String> selectedOptions = new HashSet<>();
        return select.getAllSelectedOptions().get(0).getText().strip();
    }

    public Set<String> getAllAvailableMentors() {
        WebElement element = getElement(this.assignmentMentor, ASSIGNMENT_MENTOR_S);
        Select select = new Select(element);
        Set<String> allOptions = new HashSet<>();
        select.getOptions().forEach(option -> allOptions.add(option.getText().strip()));
        return allOptions;
    }

    public void setPeriod(String period) {
        WebElement element = getElement(this.assignmentPeriod, ASSIGNMENT_PERIOD_S);
        Select sel = new Select(element);
        sel.selectByVisibleText(period);

    }

    public String getCurrentPeriod() {
        WebElement element = getElement(this.assignmentPeriod, ASSIGNMENT_PERIOD_S);
        Select select = new Select(element);
        Set<String> selectedOptions = new HashSet<>();
        return select.getAllSelectedOptions().get(0).getText().strip();
    }

    public Set<String> getAllAvailablePeriods() {
        WebElement element = getElement(this.assignmentPeriod, ASSIGNMENT_PERIOD_S);
        Select select = new Select(element);
        Set<String> allOptions = new HashSet<>();
        select.getOptions().forEach(option -> allOptions.add(option.getText().strip()));
        return allOptions;
    }

    public void setVisibility(String state) {
        WebElement element = getElement(this.assignmentVisibility, VISIBILITY_S);
        Select sel = new Select(element);
        sel.selectByVisibleText(state);

    }

    public String getCurrentVisibility() {
        WebElement element = getElement(this.assignmentVisibility, VISIBILITY_S);
        Select select = new Select(element);
        Set<String> selectedOptions = new HashSet<>();
        return select.getAllSelectedOptions().get(0).getText().strip();
    }


    public Set<String> getAllAvailableVisibilities() {
        WebElement element = getElement(this.assignmentVisibility, VISIBILITY_S);
        Select select = new Select(element);
        Set<String> allOptions = new HashSet<>();
        select.getOptions().forEach(option -> allOptions.add(option.getText().strip()));
        return allOptions;
    }

    public void clickOnSubmitBTN(){
        WebElement button = getElement(submitBTN, SUBMIT_BTN);
        Click.clickAndWaitId(button, Const.BASE_TITLE_ID);
    }

    public void clickOnBackBTN(){
        WebElement button = getElement(backBTN, BACK_BTN);
        Click.clickAndWaitId(button, Assignment_Management_Page.PAGE_ID);
    }


}
