package pstsp.support.pageobjects.assignmentmanagement;

import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.Table;
import pstsp.support.services.entities.AssignmentManagementTableRow;

import java.util.ArrayList;
import java.util.List;
/**
 * Assignment management page
 * Garant
 * @author David Kuta
 */
public class Assignment_Management_Page extends PageObject {
    public static final String PAGE_ID = "assignmentManagementPage-default-title";
    public static final String TABLE = "assignmentManagementPage-table";
    public static final String ADD_ASSIGNMENT_BTN = "assignmentManagementPage-addAssignmentBTN";

    @FindBy(id = TABLE)
    private List<WebElement> assignmentTable;

    @FindBy(id = ADD_ASSIGNMENT_BTN)
    private List<WebElement> addAssignmentButton;

    public List<AssignmentManagementTableRow> getAllAssignmnets(){
        WebElement table = getElement(assignmentTable,TABLE);

        List<List<WebElement>> a = Table.getTableContent(table);
        List<AssignmentManagementTableRow> assignments = new ArrayList<>();
        for(List<WebElement> row : a){
            if(row.size() != 4) continue;
            AssignmentManagementTableRow assignment = new AssignmentManagementTableRow();
            for(int i = 0; i < row.size(); i++){
                switch (i){
                    case 0: {
                        WebElement name = row.get(i).findElement(By.tagName("a"));
                        assignment.setName(name);
                        break;
                    }
                    case 1: {
                        String owner = row.get(i).getText().strip();
                        assignment.setOwner(owner);
                        break;
                    }
                    case 2: {
                        String state = row.get(i).findElement(By.tagName("span")).getAttribute("data-original-title");
                        assignment.setState(state);
                        break;
                    }
                    case 3:{
                        WebElement editAction = row.get(i).findElement(By.tagName("a"));
                        assignment.setEditAction(editAction);
                        break;
                    }
                }
            }
            if(row.size() > 0) {
                assignments.add(assignment);
            }
        }
        return assignments;
    }

    public Assignment_Create_Page clickOnAddAssignment() {
        WebElement element = getElement(addAssignmentButton, ADD_ASSIGNMENT_BTN);
        Click.clickAndWaitId(element, Assignment_Create_Page.PAGE_ID);
        return new Assignment_Create_Page();
    }

}
