package pstsp.support.pageobjects.assignmentswithoutmentormanagement;

import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Table;
import pstsp.support.services.entities.AssignmentInfo;

import java.util.ArrayList;
import java.util.List;
/**
 * Assignments without mentor management page
 * Garant
 * @author David Kuta
 */
public class Assignments_Without_Mentor_Management extends PageObject {
    public static final String PAGE_ID = "assignmentWithoutMentorManagement-default-title";
    public static final String TABLE = "assignmentWithoutMentorManagement-table";

    @FindBy(id = TABLE)
    private List<WebElement> table;

    public List<AssignmentInfo> getAssignmentsWithoutMentor(){
        WebElement element = getElement(table,TABLE);
        List<List<WebElement>> tableContent = Table.getTableContent(element);
        List<AssignmentInfo> result = new ArrayList<>();
        for (List<WebElement> row: tableContent) {
            if(row.size() != 2) continue;
            AssignmentInfo semiResult = new AssignmentInfo();
            for(int i = 0; i < row.size(); i++){
                switch (i){
                    case 0:{
                        WebElement nameLink = row.get(i).findElement(By.tagName("a"));
                        semiResult.setNameLink(nameLink);
                        break;
                    }
                    case 1:{
                        semiResult.setOwner(row.get(i).getText().strip());
                        break;
                    }
                }
            }
            if(row.size() > 0){
                result.add(semiResult);
            }

        }
        return result;
    }

}
