package pstsp.support.pageobjects.commonparts;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.pageobjects.assignmentlist.Assignment_List_Page;
import pstsp.support.pageobjects.assignmentmanagement.Assignment_Management_Page;
import pstsp.support.pageobjects.assignmentswithmentor.Assignments_With_Mentor_Page;
import pstsp.support.pageobjects.assignmentswithoutmentormanagement.Assignments_Without_Mentor_Management;
import pstsp.support.pageobjects.assignmenttoteammanagement.Assignment_To_Team_Management_Page;
import pstsp.support.pageobjects.mentormanagement.Mentor_Management_Page;
import pstsp.support.pageobjects.studentmanagement.Student_Management_Page;
import pstsp.support.pageobjects.tagsmanagement.TagsManagement_Page;
import pstsp.support.pageobjects.teammanagement.Team_Management_Page;
import pstsp.support.pageobjects.usermanagement.User_Management_Page;
import pstsp.support.selenium_utils.Click;

import java.util.List;
/**
 * Side nav bar for garant
 * Garant
 * @author David Kuta
 */
public class SideNavBarGarant_Page extends PageObject {

    // ID's on web page
    public static final String ASSIGNMENT_LIST = "base-sideNavbar-leader-assignmentList";
    public static final String ASSIGNNMENT_TO_TEAM_MANAGEMENT = "base-sideNavbar-garant-assignmentToTeamManagement";
    public static final String TAG_MANAGEMENT = "base-sideNavbar-garant-tagManagement";
    public static final String ASSIGNMENTS_WITH_MENTOR = "base-sideNavbar-garant-assignmentWithMentor";
    public static final String ASSIGNMENTS_WITHOUT_MENTOR = "base-sideNavbar-garant-assignmentWithoutMentor";
    public static final String TEAM_MANAGEMENT_PAGE = "base-sideNavBar-garant-teamManagementPage";
    public static final String MENTOR_MANAGEMENT="base-sideNavBar-garant-mentorManagementPage";
    public static final String USER_MANAGEMENT = "base-sideNavBar-garant-userManagementPage";
    public static final String STUDENT_MANAGEMENT = "base-sideNavBar-garant-studentManagementPage";
    public static final String ASSIGNMENT_MANAGEMENT = "base-sideNavBar-garant-assignmentManagementPage";

    //////////
    @FindBy(id = ASSIGNMENT_LIST)
    private List<WebElement> assignmentList;

    @FindBy(id = ASSIGNNMENT_TO_TEAM_MANAGEMENT)
    private List<WebElement> assignmentToTeamManagement;

    @FindBy(id = TAG_MANAGEMENT)
    private List<WebElement> tagManagement;

    @FindBy(id = ASSIGNMENTS_WITH_MENTOR)
    private List<WebElement> assignmentsWithMentor;

    @FindBy(id = ASSIGNMENTS_WITHOUT_MENTOR)
    private List<WebElement> assignmentsWithoutMentor;

    @FindBy(id = TEAM_MANAGEMENT_PAGE)
    private List<WebElement> teamManagement;

    @FindBy(id = MENTOR_MANAGEMENT)
    private List<WebElement> mentorManagement;

    @FindBy(id = USER_MANAGEMENT)
    private List<WebElement> userManagement;

    @FindBy(id = STUDENT_MANAGEMENT)
    private List<WebElement> studentManagement;

    @FindBy(id =ASSIGNMENT_MANAGEMENT)
    private List<WebElement> assignmentManagement;


    /**
     * Performs clicking on teamPage link on sidenav menu
     *
     * @return Assignment_List_Page
     */
    public Assignment_List_Page clickAssignmentListPageLink() {
        WebElement link = getElement(assignmentList, ASSIGNMENT_LIST);
        Click.clickAndWaitId(link, Assignment_List_Page.PAGE_ID);
        return new Assignment_List_Page();
    }

    /**
     * Performs clicking on assignmentToTeamManagement link on sidenav menu
     *
     * @return AssignmentToTeamManagement_Page
     */
    public Assignment_To_Team_Management_Page clickAssignmentToTeamManagementPageLink() {
        WebElement link = getElement(assignmentToTeamManagement, ASSIGNNMENT_TO_TEAM_MANAGEMENT);
        Click.clickAndWaitId(link, Assignment_To_Team_Management_Page.PAGE_ID);
        return new Assignment_To_Team_Management_Page();
    }

    /**
     * Performs clicking on TagManagement link on sidenav menu
     *
     * @return TagsManagement_Page
     */
    public TagsManagement_Page clickOnTagsManagementPageLink() {
        WebElement link = getElement(tagManagement, TAG_MANAGEMENT);
        Click.clickAndWaitId(link, TagsManagement_Page.PAGE_ID);
        return new TagsManagement_Page();
    }

    /**
     * Performs clicking on AssignmentsWithMentor link on sidenav menu
     *
     * @return AssignmentsWithMentorPage
     */
    public Assignments_With_Mentor_Page clickOnAssignmentsWithMentorPageLink() {
        WebElement link = getElement(assignmentsWithMentor, ASSIGNMENTS_WITH_MENTOR);
        Click.clickAndWaitId(link, Assignments_With_Mentor_Page.PAGE_ID);
        return new Assignments_With_Mentor_Page();
    }

    /**
     * Performs clicking on Assignments_Without_Mentor_Management link on sidenav menu
     *
     * @return Assignments_Without_Mentor_Management
     */
    public Assignments_Without_Mentor_Management clickOnAssignmentsWithoutMentorPageLink() {
        WebElement link = getElement(assignmentsWithoutMentor, ASSIGNMENTS_WITHOUT_MENTOR);
        Click.clickAndWaitId(link, Assignments_Without_Mentor_Management.PAGE_ID);
        return new Assignments_Without_Mentor_Management();
    }

    /**
     * Performs clicking on Team_Management_Page link on sidenav menu
     *
     * @return Team_Management_Page
     */
    public Team_Management_Page clickOnTeamManagementPageLink() {
        WebElement link = getElement(teamManagement, TEAM_MANAGEMENT_PAGE);
        Click.clickAndWaitId(link, Team_Management_Page.PAGE_ID);
        return new Team_Management_Page();
    }

    /**
     * Performs clicking on Mentor_Management_Page link on sidenav menu
     *
     * @return Mentor_Management_Page
     */
    public Mentor_Management_Page clickOnMentorManagementPageLink() {
        WebElement link = getElement(mentorManagement, MENTOR_MANAGEMENT);
        Click.clickAndWaitId(link, Mentor_Management_Page.PAGE_ID);
        return new Mentor_Management_Page();
    }

    /**
     * Performs clicking on User_Management_Page link on sidenav menu
     *
     * @return User_Management_Page
     */
    public User_Management_Page clickOnUserManagementPageLink() {
        WebElement link = getElement(userManagement, USER_MANAGEMENT);
        Click.clickAndWaitId(link, User_Management_Page.PAGE_ID);
        return new User_Management_Page();
    }

    /**
     * Performs clicking on Student_Management_Page link on sidenav menu
     *
     * @return Student_Management_Page
     */
    public Student_Management_Page clickOnStudentManagementPageLink() {
        WebElement link = getElement(studentManagement, STUDENT_MANAGEMENT);
        Click.clickAndWaitId(link, Student_Management_Page.PAGE_ID);
        return new Student_Management_Page();
    }

    /**
     * Performs clicking on Assignment_Management_Page link on sidenav menu
     *
     * @return Assignment_Management_Page
     */
    public Assignment_Management_Page clickOnAssignmentManagementPageLink() {
        WebElement link = getElement(assignmentManagement, ASSIGNMENT_MANAGEMENT);
        Click.clickAndWaitId(link, Assignment_Management_Page.PAGE_ID);
        return new Assignment_Management_Page();
    }


}
