package pstsp.support.pageobjects.homepage;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.basic.Url;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.pageobjects.login.Login_Page;
import pstsp.support.selenium_utils.Click;

import java.util.List;
/**
 * Home page
 * Unlogged
 * @author David Kuta
 */
public class Home_Page extends PageObject {

    public static final String HOME_PAGE_ID = "homePage-default-title";
    public static final String LOGIN_BTN = "base-upperNavBar-loginBtn";


    @FindBy(id = LOGIN_BTN)
    private List<WebElement> loginButton;

    public Login_Page clickOnLoginButton(){
        WebElement button = getElement(loginButton, LOGIN_BTN);
        Click.clickAndWaitURL(button, Url.URL_LOGIN);
        return new Login_Page();
    }
}
