package pstsp.support.pageobjects.mentoredprojectshistory;

import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Table;
import pstsp.support.services.entities.ProjectHistoryInfo;

import java.util.ArrayList;
import java.util.List;
/**
 * Mentored projects history
 * Mentor
 * @author David Kuta
 */
public class Mentored_Projects_History_Page extends PageObject {
    public static final String PAGE_ID = "mentorHistoryPage-default-title";

    public static final String TABLE_BODY_ID = "snippet-simpleGrid-tbody";

    @FindBy(id = TABLE_BODY_ID)
    private List<WebElement> tableBody;

    public List<ProjectHistoryInfo> getMentoredProjectsHistory(){
        WebElement element = getElement(tableBody,TABLE_BODY_ID);
        List<List<WebElement>> tableContent = Table.getTableContent(element);
        List<ProjectHistoryInfo> result = new ArrayList<>();
        for (List<WebElement> row: tableContent) {

            if(row.size() != 3) continue;

            ProjectHistoryInfo semiResult = new ProjectHistoryInfo();
            for(int i = 0; i < row.size(); i++){
                switch (i){
                    case 0:{
                        WebElement nameLink = row.get(i).findElement(By.tagName("a"));
                        semiResult.setName(nameLink);
                        break;
                    }
                    case 1:{
                        semiResult.setTeam( row.get(i).getText().strip());
                        break;
                    }
                    case 2:{
                        semiResult.setPeriod(row.get(i).getText().strip());
                        break;
                    }
                }
            }
            if(row.size() > 0){
                result.add(semiResult);
            }

        }
        return result;
    }
}
