package pstsp.support.pageobjects.mentormanagement;

import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.Table;
import pstsp.support.services.entities.Meeting;
import pstsp.support.services.entities.MentorInfo;
import pstsp.support.test_utils.Fail;

import java.util.ArrayList;
import java.util.List;
/**
 * Mentor management
 * Garant
 * @author David Kuta
 */
public class Mentor_Management_Page extends PageObject {

    public static final String PAGE_ID = "mentorManagementPage-default-title";
    public static final String TABLE = "mentorManagementPage-table";

    @FindBy(id = TABLE)
    private List<WebElement> table;

    public List<MentorInfo> getTableWithMentorInfo() {
        WebElement table = getElement(this.table, TABLE);

        List<List<WebElement>> a = Table.getTableContent(table);
        List<MentorInfo> mentorInfoList = new ArrayList<>();
        for (List<WebElement> row : a) {
            if (row.size() != 3) continue;
            MentorInfo mentorInfo = new MentorInfo();
            for (int i = 0; i < row.size(); i++) {
                switch (i) {
                    case 0: {
                        mentorInfo.setName(row.get(i).findElement(By.tagName("a")));
                        break;
                    }
                    case 1: {
                        mentorInfo.setTeamName(row.get(i).getText().strip());
                        break;
                    }
                    case 2: {
                        mentorInfo.setProjectName(row.get(i).getText().strip());
                        break;
                    }
                }
            }
            if (row.size() > 0) {
                mentorInfoList.add(mentorInfo);
            }
        }
        return mentorInfoList;
    }
}
