package pstsp.support.pageobjects.project;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;

import java.util.List;
/**
 * Add used experience modal page
 * Leader
 * @author David Kuta
 */
public class Project_Page_Add_Exp_Modal extends PageObject {


    public static final String ID = "project_add_experience";

    public static final String SUBJECT_T = "frm-addExperienceForm-subject";
    public static final String SUBJECT_INFO_T = "frm-addExperienceForm-experienceUse";
    public static final String CANCEL_BTN = "frm-addExperienceForm-cancel";
    public static final String SUBMIT_BTN = "frm-addExperienceForm-submit";

    @FindBy(id = SUBJECT_T)
    private List<WebElement> subjectT;

    @FindBy(id = SUBJECT_INFO_T)
    public List<WebElement> topicT;

    @FindBy(id = CANCEL_BTN)
    private List<WebElement> cancelBTN;

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitBTN;


    public void clickOnCancelBTN() {
        WebElement element = getElement(cancelBTN, CANCEL_BTN);
        Click.clickButtonAndWaitHideModal(element);
    }

    public void clickOnSubmitBTN() {
        WebElement element = getElement(submitBTN, SUBMIT_BTN);
        //Click.clickButtonAndWaitHideModal(element);
        Click.clickAndWaitId(element, Project_Page.PAGE_ID);
    }

    public void setSubject(String subject){
        WebElement tb = getElement(subjectT, SUBJECT_T);
        tb.sendKeys(subject);
    }

    public void setSubjectInfo(String subjectInfo){
        WebElement tb = getElement(topicT, SUBJECT_INFO_T);
        tb.sendKeys(subjectInfo);
    }





}
