package pstsp.support.pageobjects.studentmanagement;


import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import org.openqa.selenium.support.ui.Select;
import pstsp.support.basic.Const;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;

import java.util.ArrayList;
import java.util.List;
/**
 * Add single student modal page
 * Garant
 * @author David Kuta
 */
public class Add_Student_Modal_Page extends PageObject {
    public static final String PAGE_ID = "modal-add-student";
    public static final String LOGIN_T = "frm-studentAddForm-login";
    public static final String FIRSTNAME_T = "frm-studentAddForm-firstname";
    public static final String LASTNAME_T = "frm-studentAddForm-lastname";
    public static final String EMAIL_T = "frm-studentAddForm-email";
    public static final String PERSONALID_T = "frm-studentAddForm-personalID";
    public static final String PERIOD_S = "frm-studentAddForm-period";
    public static final String FIELD_OF_STUDY_T = "frm-studentAddForm-fieldOfStudy";
    public static final String FACULTY_T = "frm-studentAddForm-faculty";
    public static final String CANCEL_BTN = "frm-studentAddForm-cancel";
    public static final String SUBMIT_BTN = "frm-studentAddForm-submit";

    @FindBy(id = LOGIN_T)
    private List<WebElement> loginTB;

    @FindBy(id = FIRSTNAME_T)
    private List<WebElement> firstnameTB;

    @FindBy(id = LASTNAME_T)
    private List<WebElement> lastnameTB;

    @FindBy(id = EMAIL_T)
    private List<WebElement> emailTB;

    @FindBy(id = PERSONALID_T)
    private List<WebElement> personalIdTB;

    @FindBy(id = PERIOD_S)
    private List<WebElement> periodSB;

    @FindBy(id = FIELD_OF_STUDY_T)
    private List<WebElement> fieldOfStudyTB;

    @FindBy(id = FACULTY_T)
    private List<WebElement> facultyTB;

    @FindBy(id = CANCEL_BTN)
    private List<WebElement> cancelButton;

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitButton;

    public void clickOnCancelBTN() {
        WebElement element = getElement(cancelButton, CANCEL_BTN);
        Click.clickButtonAndWaitHideModal(element);
    }

    public void clickOnSubmitBTN() {
        WebElement element = getElement(submitButton, SUBMIT_BTN);
        Click.clickAndWaitId(element, Const.BASE_TITLE_ID);
    }

    public void setLoginT(String login) {
        WebElement element = getElement(loginTB, LOGIN_T);
        element.clear();
        element.sendKeys(login);
    }

    public void setFirstnameT(String firstnameT) {
        WebElement element = getElement(firstnameTB, FIRSTNAME_T);
        element.clear();
        element.sendKeys(firstnameT);
    }

    public void setLastnameT(String lastnameT) {
        WebElement element = getElement(lastnameTB, LASTNAME_T);
        element.clear();
        element.sendKeys(lastnameT);
    }

    public void setEmailT(String emailT) {
        WebElement element = getElement(emailTB, EMAIL_T);
        element.clear();
        element.sendKeys(emailT);
    }

    public void setPersonalidT(String personalidT) {
        WebElement element = getElement(personalIdTB, PERSONALID_T);
        element.clear();
        element.sendKeys(personalidT);
    }

    public void setPeriodS(String periodS) {
        WebElement element = getElement(periodSB, PERIOD_S);
        Select sel = new Select(element);
        sel.selectByVisibleText(periodS);
    }

    public List<String> getPeriods() {
        WebElement element = getElement(periodSB, PERIOD_S);
        Select sel = new Select(element);
        List<String> options = new ArrayList<>();
        sel.getOptions().forEach(a -> options.add(a.getText()));
        return options;
    }

    public void setFieldOfStudyT(String fieldOfStudyT) {
        WebElement element = getElement(fieldOfStudyTB, FIELD_OF_STUDY_T);
        element.clear();
        element.sendKeys(fieldOfStudyT);
    }

    public void setFacultyT(String facultyT) {
        WebElement element = getElement(facultyTB, FACULTY_T);
        element.clear();
        element.sendKeys(facultyT);
    }



}
