package pstsp.support.pageobjects.studentmanagement;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.basic.Const;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.pageobjects.team.Team_Page;
import pstsp.support.selenium_utils.Click;

import java.util.List;
/**
 * Create team leader page
 * Garant
 * @author David Kuta
 */
public class Add_Team_With_Leader_Page extends PageObject {
    public static final String PAGE_ID = "createTeamPage-default-title";

    public static final String TEAM_NAME_T = "frm-teamCreationForm-teamName";
    public static final String LEADER_NAME_T = "frm-teamCreationForm-leaderName";

    public static final String SUBMIT_BTN = "frm-teamCreationForm-submit";
    public static final String CANCEL_BTN = "frm-teamCreationForm-cancel";

    @FindBy(id = TEAM_NAME_T)
    private List<WebElement> teamName;

    @FindBy(id = LEADER_NAME_T)
    private List<WebElement> teamLeaderName;

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitButton;

    @FindBy(id = CANCEL_BTN)
    private List<WebElement> cancelButton;

    public void setTeamName(String teamName) {
        WebElement element = getElement(this.teamName, TEAM_NAME_T);
        element.clear();
        element.sendKeys(teamName);
    }

    public String getTeamLeaderInfo() {
        WebElement element = getElement(teamLeaderName, LEADER_NAME_T);
        return element.getAttribute("value").strip();
    }

    public void clickOnSubmitBTN(){
        WebElement button = getElement(submitButton, SUBMIT_BTN);
        Click.clickAndWaitId(button, Const.BASE_TITLE_ID);
    }

    public void clickOnBackBTN(){
        WebElement button = getElement(cancelButton, CANCEL_BTN);
        Click.clickAndWaitId(button, Team_Page.PAGE_ID);
    }

}
