package pstsp.support.pageobjects.studentmanagement;

import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.Table;
import pstsp.support.services.entities.StudentManagementTableRow;

import java.util.ArrayList;
import java.util.List;
/**
 * Student management page
 * Garant
 * @author David Kuta
 */
public class Student_Management_Page extends PageObject {
    public static final String PAGE_ID = "studentManagementPage-default-title";

    public static final String TABLE = "studentManagementPage-table";
    public static final String ADD_STUDENT_BTN = "studentManagementPage-addStudentBTN";

    @FindBy(id = TABLE)
    private List<WebElement> studentTable;


    public List<StudentManagementTableRow> getStudentTable() {
        WebElement table = getElement(studentTable, TABLE);

        List<List<WebElement>> a = Table.getTableContent(table);
        List<StudentManagementTableRow> studentResult = new ArrayList<>();
        for (List<WebElement> row : a) {

            if (row.size() != 7) continue;

            StudentManagementTableRow leaderInfo = new StudentManagementTableRow();
            for (int i = 0; i < row.size(); i++) {
                switch (i) {
                    case 0: {
                        String firstName = row.get(i).getText().strip();
                        leaderInfo.setFirstname(firstName);

                        break;
                    }
                    case 1: {
                        String surname = row.get(i).getText().strip();
                        leaderInfo.setLastname(surname);

                        break;
                    }
                    case 2: {
                        String personalId = row.get(i).getText().strip();
                        leaderInfo.setPersonalID(personalId);


                        break;
                    }
                    case 3: {
                        String email = row.get(i).getText().strip();
                        leaderInfo.setEmail(email);


                        break;
                    }
                    case 4: {
                        List<WebElement> button = row.get(i).findElements(By.tagName("a"));
                        if (button.size() > 0) {
                            leaderInfo.setTeamButton(button.get(0));
                        }
                        break;
                    }
                    case 5: {
                        String info = row.get(i).getText().strip();
                        leaderInfo.setState(info);


                        break;
                    }
                    case 6: {
                        List<WebElement> makeLeaderBTN = row.get(i).findElements(By.className("btn-success"));
                        List<WebElement> removeBTN = row.get(i).findElements(By.className("btn-danger"));
                        //leaderInfo.setMakeLeaderButton(makeLeaderBTN);
                        //leaderInfo.setRemoveStudentButton(removeBTN);
                        if (makeLeaderBTN.size() > 0) {
                            leaderInfo.setMakeLeaderButton(makeLeaderBTN.get(0));
                        }
                        if (removeBTN.size() > 0) {
                            leaderInfo.setRemoveStudentButton(removeBTN.get(0));
                        }
                    }
                }
            }
            if (row.size() > 0) {
                studentResult.add(leaderInfo);
            }
        }
        return studentResult;
    }

    @FindBy(id = ADD_STUDENT_BTN)
    private List<WebElement> addStudentBTN;

    public Add_Student_Modal_Page openAddStudentModal() {
        WebElement element = getElement(addStudentBTN,ADD_STUDENT_BTN);
        Click.clickAndWaitId(element,Add_Student_Modal_Page.PAGE_ID);
        return new Add_Student_Modal_Page();
    }

}
