package pstsp.support.pageobjects.tagsmanagement;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.basic.Const;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.Utils;

import java.util.List;
/**
 * Team profile tag form page, using when editing and creating
 * Garant
 * @author David Kuta
 */
public class Team_Profile_Tag_Form_Page extends PageObject {
    public static final String NAME = "frm-profileAddForm-label";
    public static final String CAN_USE = "frm-profileAddForm-canUse";
    public static final String SUBMIT_BTN = "frm-profileAddForm-submit";
    public static final String CANCEL_BTN = "frm-profileAddForm-cancel";


    @FindBy(id = NAME)
    private List<WebElement> teamProfileNameT;

    @FindBy(id = CAN_USE)
    private List<WebElement> canUseCHCK;

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitBTN;

    @FindBy(id = CANCEL_BTN)
    private List<WebElement> cancelBTN;

    public void setTeamProfileName(String name) {
        WebElement element = getElement(teamProfileNameT, NAME);
        element.clear();
        element.sendKeys(name);
    }

    public String getTeamProfileName() {
        WebElement element = getElement(teamProfileNameT, NAME);
        return element.getAttribute("value");
    }

    public void setCanUSe(boolean set) {
        WebElement element = getElement(canUseCHCK, CAN_USE);
        Utils.setCheckBox(element,set);
    }

    public boolean getCanUSe() {
        WebElement element = getElement(canUseCHCK, CAN_USE);
        return element.isSelected();
    }

    public void clickOnSubmitBTN() {
        WebElement element = getElement(submitBTN, SUBMIT_BTN);
        Click.clickAndWaitId(element, Const.BASE_TITLE_ID);
    }

    public void clickOnBackBTN() {
        WebElement element = getElement(cancelBTN, CANCEL_BTN);
        Click.clickAndWaitId(element, TagsManagement_Page.PAGE_ID);
    }







}
