package pstsp.support.pageobjects.team;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.basic.Const;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;

import java.util.List;
/**
 * Add meeting modal page
 * Leader
 * @author David Kuta
 */
public class Add_Meeting_Topic_Page extends PageObject {

    public static final String PAGE_ID = "teamPage-editMeetingTopic-title";
    public static final String DESCRIPTION_TA = "frm-editMeetingTopicForm-meetingInfo";
    public static final String SUBMIT_BTN = "frm-editMeetingTopicForm-submit";
    public static final String CANCEL_BTN = "frm-editMeetingTopicForm-cancel";

    @FindBy(id = CANCEL_BTN)
    private List<WebElement> cancelBTN;

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitBTN;

    public void clickOnCancelBTN() {
        WebElement element = getElement(cancelBTN, CANCEL_BTN);
        Click.clickAndWaitId(element, Team_Page.PAGE_ID);
    }

    public void clickOnSubmitBTN() {
        WebElement element = getElement(submitBTN, SUBMIT_BTN);
        Click.clickAndWaitId(element, Const.BASE_TITLE_ID);
    }

    @FindBy(id = DESCRIPTION_TA)
    private List<WebElement> descriptionTA;

    public String getDescription() {
        WebElement element = getElement(descriptionTA, DESCRIPTION_TA);
        return element.getAttribute("value").strip();
    }

    public void setDescription(String description) {
        WebElement element = getElement(descriptionTA, DESCRIPTION_TA);
        element.clear();
        element.sendKeys(description);
    }

}
