package pstsp.support.pageobjects.team;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import org.openqa.selenium.support.ui.Select;
import pstsp.support.basic.Const;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;

import java.util.HashSet;
import java.util.List;
import java.util.Set;
/**
 * Edit team page
 * Leader
 * @author David Kuta
 */
public class Edit_Team_Page extends PageObject {
    public static final String PAGE_ID = "teamPage-editTeam-title";

    private Team_Edit_Form_Page_Object form = new Team_Edit_Form_Page_Object();
    public static final String TEAM_NAME_T = "frm-teamEditForm-name";
    public static final String TEAM_LEADER_NAME_T = "frm-teamEditForm-teamLeaderName";
    public static final String TEAM_MEMBERS_S = "frm-teamEditForm-members";
    public static final String TEAM_COMPLETE_S = "frm-teamEditForm-complete";
    public static final String SUBMIT_BTN = "frm-teamEditForm-submit";
    public static final String BACK_BTN = "frm-teamEditForm-cancel";
    public static final String TEAM_COMPLETE_TEXT = "Ano";
    public static final String TEAM_INCOMPLETE_TEXT = "Ne";

    public String getTeamName() {
        return form.getTeamName();
    }

    public void setTeamName(String teamName) {
        form.setTeamName(teamName);
    }

    public String getTeamLeaderInfo() {
        return form.getTeamLeaderInfo();
    }

    public boolean isTeamLeaderNameReadOnly() {
        return form.isTeamLeaderNameReadOnly();
    }

    public void setTeamMembers(Set<String> options) {
        form.setTeamMembers(options);
    }

    public Set<String> getTeamMembers() {
        return form.getTeamMembers();
    }

    public Set<String> getAllAvailableStudents() {
        return form.getAllAvailableStudents();
    }

    public void setTeamComplete() {
        form.setTeamComplete();
    }

    public void setTeamInComplete() {
        form.setTeamInComplete();
    }

    public boolean isTeamComplete() {
        return form.isTeamComplete();
    }

    public void clickOnSubmitBTN(){
        form.clickOnSubmitBTN();
    }

    public void clickOnBackBTN(){
        form.clickOnBackBTN();
    }


}
