package pstsp.support.pageobjects.team;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import org.openqa.selenium.support.ui.Select;
import pstsp.support.basic.Const;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;

import java.util.HashSet;
import java.util.List;
import java.util.Set;
/**
 * Edit team profile page
 * Leader
 * @author David Kuta
 */
public class Edit_Team_Profile_Page extends PageObject {
    public static final String PAGE_ID = "teamPage-editTeamProfiles-title";
    public static final String PROFILES_SELECT = "frm-teamAdvancesForm-advances";
    public static final String SUBMIT_BTN = "frm-teamAdvancesForm-submit";
    public static final String BACK_BTN = "frm-teamAdvancesForm-cancel";

    @FindBy(id = PROFILES_SELECT)
    private List<WebElement> profilesSelect;

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitButton;

    @FindBy(id = BACK_BTN)
    private List<WebElement> backButton;


    public void clickOnSubmitBTN(){
        WebElement button = getElement(submitButton, SUBMIT_BTN);
        Click.clickAndWaitId(button, Const.BASE_TITLE_ID);
    }

    public void clickOnBackBTN(){
        WebElement button = getElement(backButton, BACK_BTN);
        Click.clickAndWaitId(button,Team_Page.PAGE_ID);
    }


    public void selectValuesByVisibleText(Set<String> options){
        WebElement st = getElement(profilesSelect,PROFILES_SELECT);
        Select select = new Select(st);
        select.deselectAll();
        options.forEach(select::selectByVisibleText);
    }

    public Set<String> getSelectedProfiles(){
        WebElement st = getElement(profilesSelect,PROFILES_SELECT);
        Select select = new Select(st);
        Set<String> selectedOptions = new HashSet<>();
        select.getAllSelectedOptions().forEach(option -> selectedOptions.add(option.getText().strip()));
        return selectedOptions;
    }

}
