package pstsp.support.pageobjects.team;

import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import org.openqa.selenium.support.ui.Select;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.Utils;

import java.util.HashSet;
import java.util.List;
import java.util.Set;
/**
 * Team page - add meeting modal page
 * Leader
 * @author David Kuta
 */
public class Team_Page_Meeting_Modal extends PageObject {

    public static final String SELECT_OPTION_MENTOR = "Mentor";
    public static final String SELECT_OPTION_ZAD = "Zadavatel";
    public static final String SELECT_OPTION_INTERN = "Interní";
    public static final String SELECT_OPTION_OTHER = "Jiné";


    public static final String ID = "modal-default";

    public static final String DATETIME_DT = "frm-addMeetingForm-date";
    public static final String ROOM_TB = "frm-addMeetingForm-place";
    public static final String TOPIC_TB = "frm-addMeetingForm-topic";
    public static final String WITH_SEL = "frm-addMeetingForm-notifyWho";
    public static final String CANCEL_BTN = "frm-addMeetingForm-cancel";
    public static final String SUBMIT_BTN = "frm-AddMeetingForm-submit";

    @FindBy(id = DATETIME_DT)
    private List<WebElement> dateTimeDT;

    @FindBy(id = ROOM_TB)
    public List<WebElement> roomTB;

    @FindBy(id = TOPIC_TB)
    private List<WebElement> topicTB;

    @FindBy(id = WITH_SEL)
    private List<WebElement> withSelect;


    @FindBy(id = CANCEL_BTN)
    private List<WebElement> cancelBTN;

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitBTN;

    public void clickOnCancelBTN() {
        WebElement element = getElement(cancelBTN, CANCEL_BTN);
        Click.clickButtonAndWaitHideModal(element);
    }

    public void clickOnSubmitBTN() {
        WebElement element = getElement(submitBTN, SUBMIT_BTN);
        //Click.clickButtonAndWaitHideModal(element);
        Click.clickAndWaitId(element, Team_Page.PAGE_ID);
    }

    public void setRoom(String room){
        WebElement tb = getElement(roomTB, ROOM_TB);
        tb.sendKeys(room);
    }

    public void setTopic(String topic){
        WebElement tb = getElement(topicTB, TOPIC_TB);
        tb.sendKeys(topic);
    }

    public void setWhoByVisibleText(String option){
        WebElement st = getElement(withSelect,WITH_SEL);
        Select select = new Select(st);
        select.selectByVisibleText(option);
    }

    public String getSelectedWho(){
        WebElement st = getElement(withSelect,WITH_SEL);
        Select select = new Select(st);
        return select.getFirstSelectedOption().getText();
    }



    /**
     * Sets datetime
     * @param date date in format DDMMRRRR
     * @param time time in format HH:MM
     */
    public void setDateTimeDT(String date, String time){
        WebElement dateDT = getElement(dateTimeDT, DATETIME_DT);
        //date = "28022022";
        dateDT.sendKeys(date);

        //Press tab to shift focus to time field

        dateDT.sendKeys(Keys.TAB);

        //time = "18:35";
        dateDT.sendKeys(time);
    }





}
