package pstsp.support.pageobjects.usermanagement;

import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import pstsp.support.basic.Const;
import pstsp.support.pageobjects.PageObject;
import pstsp.support.selenium_utils.Click;

import java.util.List;
/**
 * User management page - add mentor modal
 * Garant
 * @author David Kuta
 */
public class User_Management_Page_Add_Mentor_Modal extends PageObject {
    public static final String PAGE_ID = "modal-add-mentor";
    public static final String LOGIN_T = "frm-mentorAddForm-login";
    public static final String EMAIL_T = "frm-mentorAddForm-email";
    public static final String FIRSTNAME_T = "frm-mentorAddForm-firstname";
    public static final String LASTNAME_T = "frm-mentorAddForm-lastname";
    public static final String SUBMIT_BTN = "frm-mentorAddForm-submit";
    public static final String CANCEL_BTN = "frm-mentorAddForm-cancel";

    @FindBy(id = LOGIN_T)
    private List<WebElement> loginTB;

    @FindBy(id = EMAIL_T)
    private List<WebElement> emailT;

    @FindBy(id = FIRSTNAME_T)
    private List<WebElement> firstnameTB;

    @FindBy(id = LASTNAME_T)
    private List<WebElement> lastnameTB;

    @FindBy(id = CANCEL_BTN)
    private List<WebElement> cancelButton;

    @FindBy(id = SUBMIT_BTN)
    private List<WebElement> submitButton;

    public void clickOnCancelBTN() {
        WebElement element = getElement(cancelButton, CANCEL_BTN);
        Click.clickButtonAndWaitHideModal(element);
    }

    public void clickOnSubmitBTN() {
        WebElement element = getElement(submitButton, SUBMIT_BTN);
        Click.clickAndWaitId(element, Const.BASE_TITLE_ID);
    }

    public void setLoginT(String login) {
        WebElement element = getElement(loginTB, LOGIN_T);
        element.clear();
        element.sendKeys(login);
    }

    public void setFirstnameT(String firstnameT) {
        WebElement element = getElement(firstnameTB, FIRSTNAME_T);
        element.clear();
        element.sendKeys(firstnameT);
    }

    public void setLastnameT(String lastnameT) {
        WebElement element = getElement(lastnameTB, LASTNAME_T);
        element.clear();
        element.sendKeys(lastnameT);
    }

    public void setEmailT(String emailT) {
        WebElement element = getElement(this.emailT, EMAIL_T);
        element.clear();
        element.sendKeys(emailT);
    }
}
