package pstsp.support.services.assignmentswithoutmentormanagement;

import pstsp.support.pageobjects.assignmentmanagement.Assignment_Edit_Page;
import pstsp.support.pageobjects.assignmentswithoutmentormanagement.Assignments_Without_Mentor_Management;
import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.entities.AssignmentInfo;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.Fail;

import java.util.List;
import java.util.Set;
/**
 * Actions related to assignment without mentor management
 * Garant
 * @author David Kuta
 */
public class Assign_Without_Mentor_Management_Actions {
    public static final String MENTOR_NOT_ASSIGNED = "Dosud nepřidělen";
    public static final String VISIBILITY_ALL = "Publikováno pro všechny";
    public static final String VISIBILITY_MENTOR = "Viditelné pouze pro mentory";
    public static final String VISIBILITY_HIDDNEN = "Skryté";
    public static void editPublAssignmentNameSuccess(String expectedName, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setAssignmentName(expectedName);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentNameSuccess(expectedName, ownerName);

    }

    public static void editPublAssignmentDescriptionSuccess(String expectedDesc, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setAssignmentDesc(expectedDesc);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentDescSuccess(expectedDesc, assignmentName, ownerName);

    }

    public static void editPublAssignmentOwnerFirstNameSuccess(String expectedOwnerFirstName, String expectedOwnerFullName, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setOwnerFirstname(expectedOwnerFirstName);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentOwnerNameSuccess(assignmentName, expectedOwnerFullName);

    }

    public static void editPublAssignmentOwnerLastNameSuccess(String expectedOwnerLastName, String expectedOwnerFullName, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setOwnerLastname(expectedOwnerLastName);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentOwnerNameSuccess(assignmentName, expectedOwnerFullName);

    }

    public static void editPublAssignmentOwnerEmailSuccess(String expectedEmail, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setOwnerEmail(expectedEmail);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentOwnerEmailSuccess(expectedEmail,assignmentName, ownerName);
    }

    public static void editPublAssignmentOwnerPhoneSuccess(String expectedPhone, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setOwnerPhone(expectedPhone);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentOwnerPhoneSuccess(expectedPhone,assignmentName, ownerName);
    }

    public static void editPublAssignmentOwnerOtherInfoSuccess(String expectedOtherInfo, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setOwnerOtherInfo(expectedOtherInfo);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentOwnerOtherInfoSuccess(expectedOtherInfo,assignmentName, ownerName);
    }

    public static void editPublAssignmentExpectedTimeSuccess(String expectedTime, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setTimeNeeded(expectedTime);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentTimeNeededSuccess(expectedTime,assignmentName, ownerName);
    }

    public static void editPublAssignmentTeamSize(String expectedTeamSize, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setTeamSize(expectedTeamSize);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentTeamSizeSuccess(expectedTeamSize,assignmentName, ownerName);
    }

    public static void editPublAssignmentExpectedTeamProfile(Set<String> expectedTeamProfile, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setAssignmentProfile(expectedTeamProfile);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentExpectedTeamProfileSuccess(expectedTeamProfile,assignmentName, ownerName);
    }

    public static void editPublAssignmentCurrMentor(String expectedMentorName, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setMentor(expectedMentorName);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentCurrMentorSuccess(expectedMentorName,assignmentName, ownerName);
    }

    public static void editPublAssignmentPeriod(String expectedMentorName, String assignmentName, String ownerName, String user ){
        //todo
        return;
    }


    public static void editPublAssignmentVisibility(String visibility, String assignmentName, String ownerName, String user ){
        Login_Actions.loginIfNecessary(user);
        Assignments_Without_Mentor_Management awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
        List<AssignmentInfo> assignmentInfoList = awmm.getAssignmentsWithoutMentor();
        AssignmentInfo found = null;
        for (AssignmentInfo ai : assignmentInfoList) {
            if(ai.getNameText().equals(assignmentName) && ai.getOwner().equals(ownerName)){
                found = ai;
                break;
            }
        }
        if(found == null){
            Fail.failTestDueToMissingTextInTable(Assignments_Without_Mentor_Management.PAGE_ID,"Assignment: "+assignmentName+" " +ownerName);
            return;
        }

        Click.clickAndWaitId(found.getNameLink(), Assignment_Edit_Page.PAGE_ID);
        Assignment_Edit_Page aep = new Assignment_Edit_Page();
        aep.form.setVisibility(visibility);
        aep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Assign_Without_Mentor_Management_Check.checkEditPublAssignmentVisibilitySuccess(visibility,assignmentName, ownerName);
    }

}
