package pstsp.support.services.assignmentswithoutteam;

import pstsp.support.pageobjects.assignmentswithoutteam.Assignments_Without_Team_Page;
import pstsp.support.pageobjects.team.Team_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.entities.InterrestedTopicMentorTableRow;
import pstsp.support.services.entities.LeaderTopicInterrest;
import pstsp.support.services.entities.storage.MentorInterrestTopicTable;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.Fail;

import java.util.List;
/**
 * Check related to actions related to assignment without mentor management
 * mentor
 * @author David Kuta
 */
public class Assignments_Without_Team_Check {
    public static void checkChangeAssignmentSuitabilityForTeam(String assignmentName, String teamName, String expectedColor) {
        Check.checkPage(Assignments_Without_Team_Page.PAGE_ID);
        Assignments_Without_Team_Page awtp = new Assignments_Without_Team_Page();
        //check change color of the button
        MentorInterrestTopicTable mitt = awtp.getAllTopicInterrests();
        int index = mitt.getIndexForAssignmentName(assignmentName,teamName);
        String actualColor = mitt.getActualButtonColor(index);
        Check.checkText(expectedColor, actualColor,"Color does not match.");
        //check of change on team page
        InterrestedTopicMentorTableRow changedRow = mitt.getInterrestRow(assignmentName, teamName);
        Click.clickAndWaitId(changedRow.getTeamName(), Team_Page.PAGE_ID);
        Team_Page tp = new Team_Page();
        Check.checkText(teamName, tp.getTeamName(),Team_Page.PAGE_ID);
        List<LeaderTopicInterrest> leaderTopicInterrestList = tp.getTopicInterrestTableContent();
        for (LeaderTopicInterrest leaderInterrest: leaderTopicInterrestList) {
            if(leaderInterrest.getTopicName().equals(assignmentName)){
                String color = leaderInterrest.getTopicSuitabilityColor();
                Check.checkText(expectedColor,color,Team_Page.TOPIC_INTERREST_TABLE);
                break;
            }
        }


    }
}
