package pstsp.support.services.assignmentswithoutteam;

import pstsp.support.pageobjects.assignmentswithoutteam.Assignments_Without_Team_Page;
import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.pageobjects.commonparts.SideNavBarMentor_Page;
import pstsp.support.pageobjects.mentoredprojects.Mentored_Projects_Page;
import pstsp.support.pageobjects.mentormanagement.Mentor_Management_Page;
import pstsp.support.pageobjects.teammanagement.Team_Management_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.entities.MentorInfo;
import pstsp.support.services.entities.storage.MentorInterrestTopicTable;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;

import java.util.List;
/**
 * Actions related to assignment without team page
 * Garant
 * @author David Kuta
 */
public class Assignments_Without_Team_Garant_Actions {

    public static void editAssignmentSuitabilityForTeamSuccess( int choice, String teamName, String assignmentName, String mentorFullName, String currentUser) {
        Login_Actions.loginIfNecessary(currentUser);
        Mentor_Management_Page tmp = new SideNavBarGarant_Page().clickOnMentorManagementPageLink();
        List<MentorInfo> table = tmp.getTableWithMentorInfo();
        boolean found = false;
        for (MentorInfo row : table) {
            if (row.getName().getText().strip().equals(mentorFullName)) {
                Click.clickAndWaitId(row.getName(), Mentored_Projects_Page.PAGE_ID);
                found = true;
                break;
            }
        }

        Check.checkCorrectness(found, Team_Management_Page.TABLE, "Team " + teamName + "not found");
        Assignments_Without_Team_Page awtp = new SideNavBarMentor_Page().clickOnAssignmentsWithoutTeam();
        MentorInterrestTopicTable miit = awtp.getAllTopicInterrests();
        String expectedColor = miit.getColorForChoice(choice);
        miit.setValueByNameAndAssign(assignmentName, teamName, choice);
        Check.checkAndCloseAlert(true);
        Assignments_Without_Team_Garant_Check.checkChangeAssignmentSuitabilityForTeam(assignmentName, teamName, expectedColor);

    }
}
