package pstsp.support.services.assignmenttoteammanagement;

import pstsp.support.pageobjects.assignmenttoteammanagement.Assignment_To_Team_Management_Page;
import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.JavaScript;
import pstsp.support.services.entities.AsToTeamManagTeamInterrest;
import pstsp.support.services.entities.AssignmentManagementTableRow;
import pstsp.support.services.entities.AssignmentToTeamManagementTableRow;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;

import java.util.List;
/**
 * Actions related to assignment to team management
 * Garant
 * @author David Kuta
 */
public class Assignment_To_Team_Management_Actions {
    public static void assignAssignmentToTeam(String assignmentName, String teamName, String user, String mentorLogin, String leaderLogin) {
        Login_Actions.loginIfNecessary(user);
        Assignment_To_Team_Management_Page attmp = new SideNavBarGarant_Page().clickAssignmentToTeamManagementPageLink();
        List<AssignmentToTeamManagementTableRow> table = attmp.getManagementTable();
        boolean found = false;
        for (AssignmentToTeamManagementTableRow row : table) {
            if (row.getAssignmentName().getText().strip().equals(assignmentName)) {
                for (AsToTeamManagTeamInterrest interrest : row.getListOfInterrests()) {
                    if(interrest.getTeamName().getText().strip().equals(teamName)) {
                        interrest.getGarantAssignButton().click();
                        JavaScript.confirm_JS_Alert();
                        found = true;
                        break;
                    }
                }
                break;
            }
        }

        Check.checkCorrectness(found,Assignment_To_Team_Management_Page.MANAGEMENT_TABLE,"Team interrest not found.");
        Check.checkAndCloseAlert(true);
        Assignment_To_Team_Management_Check.checkAssignmentToTeamAssignProcess(assignmentName, teamName, mentorLogin, leaderLogin);

    }
}
