package pstsp.support.services.assignmenttoteammanagement;

import pstsp.support.pageobjects.assignmentswithmentor.Assignments_With_Mentor_Page;
import pstsp.support.pageobjects.assignmenttoteammanagement.Assignment_To_Team_Management_Page;
import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.pageobjects.commonparts.SideNavBarLeader_Page;
import pstsp.support.pageobjects.mentoredprojects.Mentored_Projects_Page;
import pstsp.support.pageobjects.mentormanagement.Mentor_Management_Page;
import pstsp.support.pageobjects.project.Project_Page;
import pstsp.support.pageobjects.teammanagement.Team_Management_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.entities.Assignment;
import pstsp.support.services.entities.MentorInfo;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_oracle.storage.UsersSet;
import pstsp.support.test_utils.Check;

import java.util.List;
import java.util.Map;
/**
 * Check related to actions assignment to team management
 * Garant
 * @author David Kuta
 */
public class Assignment_To_Team_Management_Check {

    public static void checkAssignmentToTeamAssignProcess(String assignmentName, String teamName, String mentorLogin, String leaderLogin) {
        Check.checkPage(Assignment_To_Team_Management_Page.PAGE_ID);
        Assignment_To_Team_Management_Page ap = new Assignment_To_Team_Management_Page();
        List<String> teams = ap.getAllTeamsWithoutAssignment();
        boolean teamFound = teams.contains(teamName);
        Check.checkCorrectness(!teamFound,Assignment_To_Team_Management_Page.MANAGEMENT_TABLE,"Team found but has to be hidden");
        Mentor_Management_Page mmp = new SideNavBarGarant_Page().clickOnMentorManagementPageLink();
        List<MentorInfo> mentorTable = mmp.getTableWithMentorInfo();
        boolean mentorFound = false;
        teamFound = false;
        String mentorFullName = UsersSet.getInstance().getUserByUsername(mentorLogin).getFullName();
        for (MentorInfo row: mentorTable) {
            if(row.getName().getText().strip().equals(mentorFullName) &&
            row.getTeamName().equals(teamName) && row.getProjectName().equals(assignmentName)) {
                mentorFound = true;
                Click.clickAndWaitId(row.getName(), Mentored_Projects_Page.PAGE_ID);
                Mentored_Projects_Page mpp = new Mentored_Projects_Page();
                Check.checkText(mentorFullName,mpp.getMentorNameFromGarantView(),Mentored_Projects_Page.PAGE_ID);
                teamFound = mpp.getMentoredProjectsTable().stream().anyMatch(a -> a.getProject().getText().strip().equals(assignmentName) && a.getTeam().getText().strip().equals(teamName));
                break;
            }
        }
        Check.checkCorrectness(mentorFound,Mentor_Management_Page.TABLE,"Mentor not found.");
        Check.checkCorrectness(teamFound,Mentored_Projects_Page.MENTORER_PROJECTS_TBL,"Project not found");
        Team_Management_Page tmp = new SideNavBarGarant_Page().clickOnTeamManagementPageLink();
        teamFound = tmp.getTeamManagementTable().stream().anyMatch(a -> a.getProject().getText().equals(teamName) && a.getOtherInfo().equals(""));
        Check.checkCorrectness(teamFound,Team_Management_Page.TABLE,"Team not found");
        Assignments_With_Mentor_Page awmp = new SideNavBarGarant_Page().clickOnAssignmentsWithMentorPageLink();
        Map<String, Assignment> map = awmp.getAssignments();
        boolean assignmentFound = map.containsKey(assignmentName);
        Check.checkCorrectness(assignmentFound,Assignments_With_Mentor_Page.ASSIGNMENT_DIV_CLS,"Asignment not found");
        Check.checkText("Přidělené", map.get(assignmentName).getStatus(),Assignments_With_Mentor_Page.STATUS_CLS);
        Login_Actions.loginIfNecessary(leaderLogin);
        Project_Page pp = new SideNavBarLeader_Page().clickOnProjectPageLink();
        Check.checkText(assignmentName,pp.getAssignmentName(),Project_Page.ASSIGNMENT_NAME);
    }
}
