package pstsp.support.services.entities;

import org.openqa.selenium.WebElement;

import java.util.Set;

/**
 * Assignment representation
 * @author David Kuta
 */
public class Assignment {
   private final String name;
   private String status;
   private final String desc;
   private final String teamSize;
   private final String timeNeeded;
   private final String mentor;
   private final String owner;
   private final Set<String> tags;
   private final WebElement detailsButton;

    /**
     *
     * @param name
     * @param desc
     * @param teamSize
     * @param timeNeeded
     * @param mentor
     * @param owner
     * @param tags
     */
    public Assignment(String name, String desc, String teamSize, String timeNeeded, String mentor, String owner, Set<String> tags, WebElement detailsButton) {
        this.name = name;
        this.desc = desc;
        this.teamSize = teamSize;
        this.timeNeeded = timeNeeded;
        this.mentor = mentor;
        this.owner = owner;
        this.tags = tags;
        this.detailsButton = detailsButton;
        this.status = "";
    }

    public String getName() {
        return name;
    }

    public String getDesc() {
        return desc;
    }

    public String getTeamSize() {
        return teamSize;
    }

    public String getTimeNeeded() {
        return timeNeeded;
    }

    public String getMentor() {
        return mentor;
    }

    public String getOwner() {
        return owner;
    }

    public Set<String> getTags() {
        return tags;
    }

    public WebElement getDetailsButton() {
        return detailsButton;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Override
    public String toString() {
        return "Assignment{" +
                "name='" + name + '\'' +
                ", status='" + status + '\'' +
                ", teamSize='" + teamSize + '\'' +
                ", timeNeeded='" + timeNeeded + '\'' +
                ", mentor='" + mentor + '\'' +
                ", owner='" + owner + '\'' +
                ", tags=" + tags +
                ", detailsButton=" + detailsButton.getText() +
                '}';
    }
}
