package pstsp.support.services.entities;

import org.openqa.selenium.WebElement;

import java.util.Objects;
/**
 * Assignment short info representation
 * @author David Kuta
 */
public class AssignmentInfo {
    private WebElement nameLink;
    private String nameText;
    private String owner;

    public WebElement getNameLink() {
        return nameLink;
    }

    public void setNameLink(WebElement nameLink) {
        this.nameLink = nameLink;
        this.nameText = nameLink.getText().strip();
    }

    public AssignmentInfo(String nameText, String owner) {
        this.nameText = nameText;
        this.owner = owner;
    }

    public AssignmentInfo() {
        this.nameText = "";
        this.owner = "";
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }

    public String getNameText() {
        return nameText;
    }

    public void setNameText(String nameText) {
        this.nameText = nameText;
    }

    @Override
    public String toString() {
        return "AssignmentInfo{" +
                "name=" + nameText +
                ", owner='" + owner + '\'' +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AssignmentInfo that = (AssignmentInfo) o;
        return nameText.equals(that.nameText) && owner.equals(that.owner);
    }

    @Override
    public int hashCode() {
        return Objects.hash(nameText, owner);
    }
}
