package pstsp.support.services.entities;

import java.util.Objects;
/**
 * Defence representation
 * @author David Kuta
 */
public class DefenceInfo {
    private final int attempt;
    private final String date;
    private final String result;

    public DefenceInfo(int attempt, String date, String result) {
        this.attempt = attempt;
        this.date = date;
        this.result = result;
    }

    public int getAttempt() {
        return attempt;
    }

    public String getDate() {
        return date;
    }

    public String getResult() {
        return result;
    }

    @Override
    public String toString() {
        return "DefenceInfo{" +
                "attempt=" + attempt +
                ", date='" + date + '\'' +
                ", result='" + result + '\'' +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DefenceInfo that = (DefenceInfo) o;
        return attempt == that.attempt && date.equals(that.date) && result.equals(that.result);
    }

    @Override
    public int hashCode() {
        return Objects.hash(attempt, date, result);
    }
}
