package pstsp.support.services.entities;

import org.openqa.selenium.WebElement;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
/**
 * Single row from Assignments without team table, interrested assignments
 * @author David Kuta
 */
public class InterrestedTopicMentorTableRow {
    private WebElement assignmentName;
    private WebElement teamName;
    private String interrestLevel;
    private Date interrestDate;
    private WebElement buttonToggle;
    private String buttonColor;

    public WebElement getAssignmentName() {
        return assignmentName;
    }

    public void setAssignmentName(WebElement assignmentName) {
        this.assignmentName = assignmentName;
    }

    public WebElement getTeamName() {
        return teamName;
    }

    public void setTeamName(WebElement teamName) {
        this.teamName = teamName;
    }

    public String getInterrestLevel() {
        return interrestLevel;
    }

    public void setInterrestLevel(String interrestLevel) {
        this.interrestLevel = interrestLevel;
    }

    public Date getInterrestDate() {
        return interrestDate;
    }

    public void setInterrestDate(String interrestDate) throws ParseException {
        SimpleDateFormat formatter = new SimpleDateFormat("d. M. y H:m");
        this.interrestDate = formatter.parse(interrestDate);
    }

    public WebElement getButtonToggle() {
        return buttonToggle;
    }

    public void setButtonToggle(WebElement buttonToggle) {
        this.buttonToggle = buttonToggle;
    }

    public String getButtonColor() {
        return buttonColor;
    }

    public void setButtonColor(String buttonColor) {
        this.buttonColor = buttonColor;
    }

    @Override
    public String toString() {
        return "InterrestedTopicMentorTableRow{" +
                "assignmentName=" + assignmentName.getText() +
                ", teamName=" + teamName.getText() +
                ", interrestLevel='" + interrestLevel + '\'' +
                ", interrestDate=" + interrestDate.toString() +
                ", buttonToggle=" + buttonToggle.getText()+
                ", buttonColor='" + buttonColor + '\'' +
                '}';
    }
}
