package pstsp.support.services.entities;

import org.openqa.selenium.WebElement;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Objects;
/**
 * Meeting representation
 * @author David Kuta
 */
public class Meeting {

    private Date datetime;
    private String room;
    private WebElement topic;
    private String with;
    private String topicText;

    public Date getDatetime() {
        return datetime;
    }

    public void setDatetime(String datetime) throws ParseException {
        SimpleDateFormat formatter = new SimpleDateFormat("d.M.y H:m");
        this.datetime = formatter.parse(datetime);
    }

    public void setDatetimeFromDateAndTime(String date, String time) throws ParseException {
        SimpleDateFormat formatter = new SimpleDateFormat("dMy H:m");
        this.datetime = formatter.parse(date + " " + time);
    }

    public static Date getDateTimeFromString(String dateTime) throws ParseException {
        SimpleDateFormat formatter = new SimpleDateFormat("d.M.y H:m");
        return formatter.parse(dateTime);
    }

    public String getRoom() {
        return room;
    }

    public void setRoom(String room) {
        this.room = room;
    }

    public WebElement getTopic() {
        return topic;
    }

    public void setTopic(WebElement topic) {
        this.topic = topic;
        this.topicText = topic.getText().strip();
    }

    public String getTopicText() {
        return topicText;
    }

    public void setTopicText(String topicText) {
        this.topicText = topicText;
    }

    public String getWith() {
        return with;
    }

    public void setWith(String with) {
        this.with = with;
    }

    @Override
    public String toString() {
        return "Meeting{" +
                "datetime=" + datetime +
                ", room='" + room + '\'' +
                ", topic=" + topicText +
                ", with='" + with + '\'' +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Meeting meeting = (Meeting) o;
        return datetime.equals(meeting.datetime) && room.equals(meeting.room) && with.equals(meeting.with) && topicText.equals(meeting.topicText);
    }

}
