package pstsp.support.services.entities;

import org.openqa.selenium.WebElement;

import java.util.Date;
/**
 * Single row from mentored projects page or similar types of tables
 * @author David Kuta
 */
public class TeamStateTableRow {
    private WebElement project;
    private WebElement team;
    private int minCritGreen;
    private int minCritOrange;
    private int minCritRed;
    private int prjStateGreen;
    private int prjStateOrange;
    private int prjStateRed;
    private String date;
    private String otherInfo;

    public TeamStateTableRow() {
        this.project=null;
        this.team=null;
        this.minCritGreen=0;
        this.minCritOrange=0;
        this.minCritRed=0;
        this.prjStateGreen=0;
        this.prjStateOrange=0;
        this.prjStateRed=0;
        this.date="";
        this.otherInfo = "";
    }

    public TeamStateTableRow(WebElement project, WebElement team, int minCritGreen, int minCritOrange, int minCritRed, int prjStateGreen, int prjStateOrange, int prjStateRed, String date) {
        this.project = project;
        this.team = team;
        this.minCritGreen = minCritGreen;
        this.minCritOrange = minCritOrange;
        this.minCritRed = minCritRed;
        this.prjStateGreen = prjStateGreen;
        this.prjStateOrange = prjStateOrange;
        this.prjStateRed = prjStateRed;
        this.date = date;
    }

    public WebElement getProject() {
        return project;
    }

    public void setProject(WebElement project) {
        this.project = project;
    }

    public WebElement getTeam() {
        return team;
    }

    public void setTeam(WebElement team) {
        this.team = team;
    }

    public int getMinCritGreen() {
        return minCritGreen;
    }

    public void setMinCritGreen(int minCritGreen) {
        this.minCritGreen = minCritGreen;
    }

    public int getMinCritOrange() {
        return minCritOrange;
    }

    public void setMinCritOrange(int minCritOrange) {
        this.minCritOrange = minCritOrange;
    }

    public int getMinCritRed() {
        return minCritRed;
    }

    public void setMinCritRed(int minCritRed) {
        this.minCritRed = minCritRed;
    }

    public int getPrjStateGreen() {
        return prjStateGreen;
    }

    public void setPrjStateGreen(int prjStateGreen) {
        this.prjStateGreen = prjStateGreen;
    }

    public int getPrjStateOrange() {
        return prjStateOrange;
    }

    public void setPrjStateOrange(int prjStateOrange) {
        this.prjStateOrange = prjStateOrange;
    }

    public int getPrjStateRed() {
        return prjStateRed;
    }

    public void setPrjStateRed(int prjStateRed) {
        this.prjStateRed = prjStateRed;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public String getOtherInfo() {
        return otherInfo;
    }

    public void setOtherInfo(String otherInfo) {
        this.otherInfo = otherInfo;
    }

    @Override
    public String toString() {
        return "TeamStateTableRow{" +
                "project=" + project.getText() +
                ", team=" + team.getText() +
                ", minCritGreen=" + minCritGreen +
                ", minCritOrange=" + minCritOrange +
                ", minCritRed=" + minCritRed +
                ", prjStateGreen=" + prjStateGreen +
                ", prjStateOrange=" + prjStateOrange +
                ", prjStateRed=" + prjStateRed +
                ", date='" + date + '\'' +
                ", otherInfo='" + otherInfo + '\'' +
                '}';
    }
}
