package pstsp.support.services.login;

import pstsp.support.basic.Url;
import pstsp.support.pageobjects.commonparts.HeaderBar_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.test_utils.Check;

/**
 * Actions on Home page
 *
 * @author Pavel Herout
 * @version 2019-24-11
 */

public class Home_Actions {
  /**
   * Read defect clone version
   * <p>
   * Reads version of deployed UIS defect version.
   *
   * @return String representation of read defect version
   */
  public static String readVersion() {
//        Click.openUrlAndWait(Url.BASE_URL);
//        return new Home_Page().getDefectCloneVersion();
    return "0.2.0";
  }


  /**
   * Read build numbers
   * <p>
   * Reads version of deployed UIS application.
   *
   * @return String representation of UIS application version
   */
  public static String readBuildNumber(){
//    Click.openUrlAndWait(Url.URL_INDEX);
//    return new Home_Page().getBuildNumber();
    return "0.2.0";
  }

  /**
   * Clicks on button on upper nav bar and resets database
   */
  public static void resetDB(){
    Click.openUrlAndWait(Url.URL_ASSIGNMENT_LIST);
    HeaderBar_Page hbp = new HeaderBar_Page();
    hbp.clickOnResetDB();
    Check.checkAndCloseAlert(true);
  }
}
