package pstsp.support.services.mentoredprojects;

import pstsp.support.pageobjects.mentoredprojects.Mentored_Projects_Page;
import pstsp.support.pageobjects.project.Mentor_View_On_Project_Page;
import pstsp.support.pageobjects.project.Project_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.entities.TeamStateTableRow;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;

import java.util.List;
/**
 * Actions related to mentored projects page
 * Mentor
 * @author David Kuta
 */
public class Mentored_Projects_Actions {

    public static Mentor_View_On_Project_Page goToProjectPage(String teamName, String assignmentName, String mentorName){
        Login_Actions.loginIfNecessary(mentorName);
        Check.checkPage(Mentored_Projects_Page.PAGE_ID);
        Mentored_Projects_Page mpp = new Mentored_Projects_Page();
        List<TeamStateTableRow> list = mpp.getMentoredProjectsTable();
        for (TeamStateTableRow tableRow: list) {
            if(tableRow.getProject().getText().strip().equals(assignmentName) && tableRow.getTeam().getText().strip().equals(teamName)){
                Click.clickAndWaitId(tableRow.getProject(), Project_Page.PAGE_ID);
                return new Mentor_View_On_Project_Page();
            }
        }
        throw new IllegalStateException("Invalid team and assignment in mentored projects: " + teamName + " " + assignmentName);
    }
}
