package pstsp.support.services.negative.team;

import pstsp.support.basic.Const;
import pstsp.support.pageobjects.commonparts.ModalClose_Page;
import pstsp.support.pageobjects.commonparts.SideNavBarLeader_Page;
import pstsp.support.pageobjects.team.*;
import pstsp.support.selenium_utils.Utils;
import pstsp.support.services.entities.storage.StudentStorage;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.Check;

import java.util.Set;
/**
 * Negative team actions
 * Leader
 * @author David Kuta
 */
public class Neg_Team_Actions {
    public static void editTeamNameNegative(String teamName, String expectedMessage, String currentUser){
        Login_Actions.loginIfNecessary(currentUser);
        Edit_Team_Page etp = new SideNavBarLeader_Page().clickOnTeamPageLink().clickOnTeamEditButton();
        etp.setTeamName(teamName);
        etp.clickOnSubmitBTN();
        Check.checkCorrectness(Utils.getFormErrorText().contains(expectedMessage), Const.ERROR_CLASS,"Error message " + expectedMessage + "was not found");
    }

    public static void editTeamMemberRolesNegative(Set<String> teamMemberRoles, String teamMember, String expectedMessage,String currentUser){
        Login_Actions.loginIfNecessary(currentUser);
        Team_Page tp = new SideNavBarLeader_Page().clickOnTeamPageLink();
        StudentStorage studStor = tp.getTeamMembers();
        Edit_Team_Roles_Page etp = tp.clickOnEditTeamRoles();
        etp.selectValuesByVisibleText(studStor.getStudentOrder(teamMember),teamMemberRoles);
        etp.clickOnSubmitBTN();
        Check.checkCorrectness(Utils.getFormErrorText().contains(expectedMessage), Const.ERROR_CLASS,"Error message " + expectedMessage + "was not found");
    }

    public static void addMeetingAsLeaderNegative(String date, String time, String topic, String room, String expectedMessage, String currentUser) {
        Login_Actions.loginIfNecessary(currentUser);
        Team_Page tp = new SideNavBarLeader_Page().clickOnTeamPageLink();
        Team_Page_Meeting_Modal tpmm = tp.openMeetingModal();
        tpmm.setDateTimeDT(date, time);
        tpmm.setTopic(topic);
        tpmm.setRoom(room);
        tpmm.clickOnSubmitBTN();
        Check.checkCorrectness(Utils.getFormErrorText().contains(expectedMessage), Const.ERROR_CLASS,"Error message " + expectedMessage + "was not found");
        tpmm.clickOnCancelBTN();
    }

    public static void addMeetingAsMentorNegative(String date, String time, String topic, String room, String expectedMessage, String teamName, String currentUser) {
        Login_Actions.loginIfNecessary(currentUser);
        Team_Page tp = Team_Actions.goToTeamPageAsMentor(teamName, currentUser);
        Team_Page_Meeting_Modal tpmm = tp.openMeetingModal();
        tpmm.setDateTimeDT(date, time);
        tpmm.setTopic(topic);
        tpmm.setRoom(room);
        tpmm.clickOnSubmitBTN();
        Check.checkCorrectness(Utils.getFormErrorText().contains(expectedMessage), Const.ERROR_CLASS,"Error message " + expectedMessage + "was not found");
        tpmm.clickOnCancelBTN();
    }


}
