package pstsp.support.services.project;

import pstsp.support.pageobjects.commonparts.SideNavBarLeader_Page;
import pstsp.support.pageobjects.project.Mentor_View_On_Project_Page;
import pstsp.support.pageobjects.project.Project_Page;
import pstsp.support.pageobjects.project.Project_Page_Add_Exp_Modal;
import pstsp.support.services.entities.storage.ProjectTable;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.services.mentoredprojects.Mentored_Projects_Actions;
import pstsp.support.test_utils.Check;
/**
 * Actions on project page from mentor view
 * Mentor
 * @author David Kuta
 */
public class Project_Mentor_Actions {


    public static void editMinCritTblSuccess(String stepName, int choice, String teamName, String assignmentName, String mentorName, String leaderName) {
        Mentor_View_On_Project_Page mvp = Mentored_Projects_Actions.goToProjectPage(teamName, assignmentName, mentorName);

        ProjectTable before = mvp.getMinimalCriteriaMentorTable();
        //row
        int row = before.getIndexForStepName(stepName);
        String expectedColor = before.getColorForChoice(choice);
        before.setStateValue(row, choice);
        Check.checkAndCloseAlert(true);
        Project_Mentor_Check.checkMinCritTblSuccessEdit(stepName, expectedColor, teamName, assignmentName, leaderName);
    }

    public static void editUsedExpTblSuccess(String subjName, String subjInfo, int choice, String teamName, String assignmentName, String mentorName, String leaderName) {
        Mentor_View_On_Project_Page mvp = Mentored_Projects_Actions.goToProjectPage(teamName, assignmentName, mentorName);

        ProjectTable before = mvp.getUsedExpMentorTable();
        //row
        int row = before.getIndexForStepNameAndTextInfo(subjName, subjInfo);
        String expectedColor = before.getColorForChoice(choice);
        before.setStateValue(row, choice);
        Check.checkAndCloseAlert(true);
        Project_Mentor_Check.checkUsedExpTblSuccessEdit(subjName, subjInfo, expectedColor, leaderName);
    }

    public static void editProjStateTblSuccess(String stepName, int choice, String teamName, String assignmentName, String mentorName, String leaderName) {
        Mentor_View_On_Project_Page mvp = Mentored_Projects_Actions.goToProjectPage(teamName, assignmentName, mentorName);

        ProjectTable before = mvp.getProjectStateMentorTable();
        //row
        int row = before.getIndexForStepName(stepName);
        String expectedColor = before.getColorForChoice(choice);
        before.setStateValue(row, choice);
        Check.checkAndCloseAlert(true);
        Project_Mentor_Check.checkProjStateTblSuccessEdit(stepName, expectedColor, teamName, assignmentName, leaderName);
    }


}
