package pstsp.support.services.tagmanagement;

import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.pageobjects.tagsmanagement.*;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.entities.TagTableRow;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;

import java.util.List;
/**
 * Actions on tag management page
 * Garant
 * @author David Kuta
 */
public class Tag_Management_Actions {

    public static void addTeamProfileSuccess(String expectedName, boolean enabled, String user){
        Login_Actions.loginIfNecessary(user);
        TagsManagement_Page tmp = new SideNavBarGarant_Page().clickOnTagsManagementPageLink();

        Team_Profile_Tag_Create_Modal modal = tmp.clickOnAddTeamProfileBTN();
        modal.form.setTeamProfileName(expectedName);
        modal.form.setCanUSe(enabled);
        modal.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Tag_Management_Check.checkTeamProfileSuccess(expectedName, enabled);
    }

    public static void editTeamProfileSuccess(String expectedName, boolean enabled, String destName, boolean destEnabled, String user){
        Login_Actions.loginIfNecessary(user);
        TagsManagement_Page tmp = new SideNavBarGarant_Page().clickOnTagsManagementPageLink();

        List<TagTableRow> list = tmp.getTeamProfileTagTable();
        boolean found = false;
        for (TagTableRow row :list) {
            if(row.getTagText().equals(destName) && (row.isAccesible() == destEnabled)) {
                Click.clickAndWaitId(row.getEditButton(), Team_Profile_Tag_Edit_Page.PAGE_ID);
                found = true;
                break;
            }

        }
        Check.checkCorrectness(found,TagsManagement_Page.TEAM_PROFLIE_TABLE, "Tag with name: " + destName
                + " and usability" + destEnabled + "is not in table");
        Team_Profile_Tag_Edit_Page tptep = new Team_Profile_Tag_Edit_Page();
        tptep.form.setTeamProfileName(expectedName);
        tptep.form.setCanUSe(enabled);
        tptep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Tag_Management_Check.checkTeamProfileSuccess(expectedName, enabled);
    }

    public static void addTeamRoleSuccess(String expectedName, String color, boolean enabled, String user){
        Login_Actions.loginIfNecessary(user);
        TagsManagement_Page tmp = new SideNavBarGarant_Page().clickOnTagsManagementPageLink();

        Team_Role_Tag_Create_Modal modal = tmp.clickOnAddTeamRoleBTN();
        modal.form.setName(expectedName);
        modal.form.setColor(color);
        modal.form.setCanUSe(enabled);
        modal.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Tag_Management_Check.checkTeamRoleSuccess(expectedName,color, enabled);
    }

    public static void editTeamRoleSuccess(String expectedName, String color, boolean enabled, String destName, String destColor, boolean destEnabled, String user){
        Login_Actions.loginIfNecessary(user);
        TagsManagement_Page tmp = new SideNavBarGarant_Page().clickOnTagsManagementPageLink();

        List<TagTableRow> list = tmp.getTeamRoleTagTable();
        boolean found = false;
        for (TagTableRow row :list) {
            if(row.getTagText().equals(destName) && (row.isAccesible() == destEnabled) && row.getTagColor().equals(Tag_Management_Check.colorConvertToCssClass(destColor))) {
                Click.clickAndWaitId(row.getEditButton(), Team_Role_Tag_Edit_Page.PAGE_ID);
                found = true;
                break;
            }


        }
        Check.checkCorrectness(found,TagsManagement_Page.TEAM_ROLE_TABLE, "Tag with name: " + destName
                + " and usability" + destEnabled +"and color" + destColor + "is not in table");
        Team_Role_Tag_Edit_Page trtep = new Team_Role_Tag_Edit_Page();
        trtep.form.setName(expectedName);
        trtep.form.setColor(color);
        trtep.form.setCanUSe(enabled);
        trtep.form.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        Tag_Management_Check.checkTeamRoleSuccess(expectedName,color, enabled);
    }


}
