package pstsp.support.services.usermanagement;

import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.pageobjects.usermanagement.User_Management_Page;
import pstsp.support.pageobjects.usermanagement.User_Management_Page_Add_Mentor_Modal;
import pstsp.support.selenium_utils.JavaScript;
import pstsp.support.services.entities.UserManagementLeaderTableRow;
import pstsp.support.services.entities.UserManagementMentorTableRow;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;

import java.util.List;
/**
 * Actions related to user management
 * Garant
 * @author David Kuta
 */
public class User_Management_Actions {

    public static void addMentorSuccess(String login, String email, String firstName, String lastName, String currUser){
        Login_Actions.loginIfNecessary(currUser);
        User_Management_Page ump = new SideNavBarGarant_Page().clickOnUserManagementPageLink();
        User_Management_Page_Add_Mentor_Modal umpamm = ump.openAddMentorModal();
        umpamm.setLoginT(login);
        umpamm.setEmailT(email);
        umpamm.setFirstnameT(firstName);
        umpamm.setLastnameT(lastName);
        umpamm.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
        User_Management_Check.checkAddMentorSuccess(login, email, firstName, lastName);
    }

    public static void removeMentorSuccess(String firstName, String lastName, String email,String mentorLogin, String mentorPass, String currUser){
        Login_Actions.loginIfNecessary(currUser);
        User_Management_Page ump = new SideNavBarGarant_Page().clickOnUserManagementPageLink();
        List<UserManagementMentorTableRow> table = ump.getMentorTable();
        boolean found = false;
        for (UserManagementMentorTableRow row : table) {
            if(row.getEmail().equals(email) && row.getFirstname().equals(firstName) && row.getLastname().equals(lastName)){
                found = true;
                row.getDeleteButton().click();
                JavaScript.confirm_JS_Alert();
                break;
            }
        }
        Check.checkPage(User_Management_Page.PAGE_ID);
        Check.checkCorrectness(found,User_Management_Page.MENTOR_TABLE,"Mentor not found.");
        Check.checkAndCloseAlert(true);
        User_Management_Check.checkRemoveMentorSuccess(firstName,lastName,email,mentorLogin, mentorPass);
    }

    public static void removeLeaderSuccess(String firstName, String lastName, String email,String leaderLogin, String leaderPass, String currUser){
        Login_Actions.loginIfNecessary(currUser);
        User_Management_Page ump = new SideNavBarGarant_Page().clickOnUserManagementPageLink();
        List<UserManagementLeaderTableRow> table = ump.getLeaderTable();
        boolean found = false;
        for (UserManagementLeaderTableRow row : table) {
            if(row.getEmail().equals(email) && row.getFirstname().equals(firstName) && row.getLastname().equals(lastName)){
                found = true;
                row.getDeleteButton().click();
                JavaScript.confirm_JS_Alert();
                break;
            }
        }
        Check.checkPage(User_Management_Page.PAGE_ID);
        Check.checkCorrectness(found,User_Management_Page.MENTOR_TABLE,"Mentor not found.");
        Check.checkAndCloseAlert(true);
        User_Management_Check.checkRemoveLeaderSuccess(firstName,lastName,email,leaderLogin, leaderPass);
    }


}
