package pstsp.support.services.usermanagement;

import pstsp.support.pageobjects.assignmentlist.Assignment_List_Page;
import pstsp.support.pageobjects.commonparts.HeaderBar_Page;
import pstsp.support.pageobjects.login.Login_Page;
import pstsp.support.pageobjects.usermanagement.User_Management_Page;
import pstsp.support.services.entities.UserManagementLeaderTableRow;
import pstsp.support.services.entities.UserManagementMentorTableRow;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;

import java.util.List;
/**
 * Check related to actions from user management
 * Garant
 * @author David Kuta
 */
public class User_Management_Check {
    public static void checkAddMentorSuccess(String login, String email, String firstName, String lastName) {
        Check.checkPage(User_Management_Page.PAGE_ID);
        User_Management_Page ump = new User_Management_Page();
        List<UserManagementMentorTableRow> table = ump.getMentorTable();

        boolean found = false;
        for (UserManagementMentorTableRow row: table) {
            if(row.getFirstname().equals(firstName) && row.getLastname().equals(lastName) && row.getEmail().equals(email)){
                found = true;
                break;
            }
        }
        Check.checkCorrectness(found,User_Management_Page.MENTOR_TABLE,"Mentor " + firstName + " " + lastName + " not found" );
    }

    public static void checkRemoveMentorSuccess(String firstName, String lastName, String email, String mentorLogin, String mentorPass) {
        Check.checkPage(User_Management_Page.PAGE_ID);
        User_Management_Page ump = new User_Management_Page();
        List<UserManagementMentorTableRow> table = ump.getMentorTable();
        boolean found = false;
        for (UserManagementMentorTableRow row : table) {
            if(row.getEmail().equals(email) && row.getFirstname().equals(firstName) && row.getLastname().equals(lastName)){
                found = true;
                break;
            }
        }
        Check.checkBoolean(false, found,User_Management_Page.MENTOR_TABLE);
        Login_Actions.logoutIfPossible();
        Check.checkPage(Assignment_List_Page.PAGE_ID);
        Login_Page lp = new HeaderBar_Page().clickOnLoginBTN();
        lp.setUsername(mentorLogin);
        lp.setPassword(mentorPass);
        lp.clickOnLoginButton_ErrorLogin();
    }


    public static void checkRemoveLeaderSuccess(String firstName, String lastName, String email, String leaderLogin, String leaderPass) {
        Check.checkPage(User_Management_Page.PAGE_ID);
        User_Management_Page ump = new User_Management_Page();
        List<UserManagementLeaderTableRow> table = ump.getLeaderTable();
        boolean found = false;
        for (UserManagementLeaderTableRow row : table) {
            if(row.getEmail().equals(email) && row.getFirstname().equals(firstName) && row.getLastname().equals(lastName)){
                found = true;
                break;
            }
        }
        Check.checkBoolean(false, found,User_Management_Page.MENTOR_TABLE);
        Login_Actions.logoutIfPossible();
        Check.checkPage(Assignment_List_Page.PAGE_ID);
        Login_Page lp = new HeaderBar_Page().clickOnLoginBTN();

        lp.setUsername(leaderLogin);
        lp.setPassword(leaderPass);
        lp.clickOnLoginButton_ErrorLogin();
    }
}
