package pstsp.support.test_oracle.entities;

/**
 * User class
 *
 * Warning: This class is a "parallel" class to class in the web application.
 * The purpose of this class is for evaluating of web application results.
 * It should not interact directly with web application.
 *
 * @author Pavel Herout
 * @version 2022-01-25
 */

public class User implements Comparable<User> {
  private String firstName;
  private String lastName;
  private String userName;
//  private String email;  // podle potreby se budou pridavat dalsi udaje
  
  public User(String userName, String firstName, String lastName) {
    this.userName = userName;
    this.firstName = firstName;
    this.lastName = lastName;
  }
  
  public String getFirstName() {
    return firstName;
  }

  public String getLastName() {
    return lastName;
  }

  public String getFullName() {
    return firstName + " " + lastName;
  }

  public String getUserName() {
    return userName;
  }

  @Override
  public String toString() {
    return firstName + " " + lastName;
  }

  @Override
  public int compareTo(User other) {
    int result = this.lastName.compareTo(other.lastName);
    if (result != 0) {
      return result;
    }
    else {
      return this.firstName.compareTo(other.firstName);
    }
  }
}
