package pstsp.support.pageobjects.assignment;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.basic.Url;
import pstsp.support.pageobjects.assignmentlist.Assignment_List_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.MyAlert;
import pstsp.support.services.entities.Assignment;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.Map;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class AssignmentPageInterestModalTest {
    Assignment_Page_Leader_Interrest_Modal modal;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("stricz");
        Click.openUrlAndWait(Url.URL_ASSIGNMENT_LIST);
        Assignment_List_Page assignmentListPage = new Assignment_List_Page();
        Map<String, Assignment> map = assignmentListPage.getAssignments();
        Click.clickAndWaitId(map.get("Rozšíření Genealogy pluginu").getDetailsButton(), Assignment_Page.PAGE_ID);
        this.modal = new Assignment_Page().clickOnInterestButton();
    }

    @Test
    void getOptionsToSelect() {
        modal.getOptionsToSelect().forEach(System.out::println);
    }

    @Test
    void selectWeightByVisibleTextTest(){
        modal.selectWeightByVisibleText(modal.getOptionsToSelect().get(1));
    }

    @Test
    void closeModalTest(){
        modal.closeModal();
    }

    @Test
    void submitModal(){
        modal.selectWeightByVisibleText(modal.getOptionsToSelect().get(1));
        modal.clickOnSubmit();
        MyAlert.getAlert().closeAlert();
    }

}