package pstsp.support.pageobjects.assignment;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.basic.Url;
import pstsp.support.pageobjects.assignmentlist.Assignment_List_Page;
import pstsp.support.pageobjects.assignmentswithouthmentor.Assignments_Without_Mentor_Page;
import pstsp.support.pageobjects.commonparts.SideNavBarMentor_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.MyAlert;
import pstsp.support.services.entities.Assignment;
import pstsp.support.services.entities.AssignmentInfo;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.List;
import java.util.Map;

import static org.junit.jupiter.api.Assertions.*;
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class AssignmentPageMentorAssignModalTest {
    Assignment_Page_Mentor_Assign_Modal modal;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("mentor");
        SideNavBarMentor_Page snm = new SideNavBarMentor_Page();
        Assignments_Without_Mentor_Page awm = snm.clickOnAssignmentsWithoutMentor();
        List<AssignmentInfo> list = awm.getUnmentoredAssignments();
        Click.clickAndWaitId(list.get(0).getNameLink(), Assignment_Page.PAGE_ID);
        this.modal = new Assignment_Page().clickOnMentorAssignButton();
    }
    @Test
    void closeModal() {
        modal.closeModal();
    }

    @Test
    void clickOnSubmit() {
        modal.clickOnSubmit();
        Check.checkAndCloseAlert(true);
    }
}