package pstsp.support.pageobjects.assignment;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.basic.Url;
import pstsp.support.pageobjects.assignmentlist.Assignment_List_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.entities.Assignment;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.Map;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class AssignmentTest {

    Assignment_Page assignmentPage;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("stricz");
        Click.openUrlAndWait(Url.URL_ASSIGNMENT_LIST);
        Assignment_List_Page assignmentListPage = new Assignment_List_Page();
        Map<String, Assignment> map = assignmentListPage.getAssignments();
        Click.clickAndWaitId(map.get("Rozšíření Genealogy pluginu").getDetailsButton(), Assignment_Page.PAGE_ID);
        this.assignmentPage = new Assignment_Page();
    }

    @Test
    @DisplayName("TC_Make_Interest")
    void clickOnInterrestButton() {
        assignmentPage.clickOnInterestButton();
    }

    @Test
    void getNameTest(){
        String expected = "Rozšíření Genealogy pluginu";
        String actual = assignmentPage.getName();
        Check.checkText(expected, actual,Assignment_Page.AS_NAME);
    }
}
