package pstsp.support.pageobjects.assignment_list;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.basic.Url;
import pstsp.support.pageobjects.assignment.Assignment_Page;
import pstsp.support.pageobjects.assignmentlist.Assignment_List_Page;
import pstsp.support.pageobjects.commonparts.SideNavBarUnlogged_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.entities.Assignment;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.Map;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class AssignmentListPageTest {

    Assignment_List_Page assignmentListPage;

    @BeforeEach
    void setUp() {
        Click.openUrlAndWait(Url.URL_ASSIGNMENT_LIST);
        SideNavBarUnlogged_Page side = new SideNavBarUnlogged_Page();
        assignmentListPage = side.clickAssignmentListPageLink();
    }

    @Test
    void getAssignmentsAndClick(){
        Map<String, Assignment> map = assignmentListPage.getAssignments();
        Click.clickAndWaitId(map.get("Administrativní klient pro systém SensLog").getDetailsButton(), Assignment_Page.PAGE_ID);
        Assignment_Page pg = new Assignment_Page();
        Check.checkText("Administrativní klient pro systém SensLog",pg.getName(),Assignment_Page.AS_NAME);
    }
}
