package pstsp.support.pageobjects.assignmentswithoutmentormanagement;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.services.entities.AssignmentInfo;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.ArrayList;
import java.util.List;

import static org.junit.jupiter.api.Assertions.*;
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class AssignmentsWithoutMentorManagementTest {

    Assignments_Without_Mentor_Management awmm;
    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("garant");
        awmm = new SideNavBarGarant_Page().clickOnAssignmentsWithoutMentorPageLink();
    }

    @Test
    void getAssignmentsWithoutMentor() {
        List<AssignmentInfo> actual = awmm.getAssignmentsWithoutMentor();
        List<AssignmentInfo> expected = new ArrayList<>();
        AssignmentInfo ai = new AssignmentInfo();
        ai.setNameText("Rozšíření aplikace pro detekci procesní anti-patternů");
        ai.setOwner("Pan Garant");
        expected.add(ai);
        boolean equal = expected.equals(actual);
        Check.checkCorrectness(equal,Assignments_Without_Mentor_Management.TABLE,"content is not as expected");
    }
}