package pstsp.support.pageobjects.assignmentswithoutteam;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.commonparts.SideNavBarMentor_Page;
import pstsp.support.services.entities.AssignmentInfo;
import pstsp.support.services.entities.storage.MentorInterrestTopicTable;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.List;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class AssignmentsWithoutTeamPageTest {
    Assignments_Without_Team_Page awt;
    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("mentor");
        SideNavBarMentor_Page snm = new SideNavBarMentor_Page();
        this.awt = snm.clickOnAssignmentsWithoutTeam();
    }
    @Test
    void getAllNotInterrestedAssignments() {
        List<AssignmentInfo> notInterrestedList = awt.getAllNotInterrestedAssignments();
        notInterrestedList.forEach(a -> System.out.println(a));
        notInterrestedList.get(0).getNameLink().click();
    }

    @Test
    void getAllTopicInterrests() {
        MentorInterrestTopicTable mtt = awt.getAllTopicInterrests();
        mtt.rowList.forEach(System.out::println);
    }

    @Test
    void changeState() {
        String assignName = "Rozšíření Genealogy pluginu";
        String teamName = "Čtyři stateční";
        MentorInterrestTopicTable before = awt.getAllTopicInterrests();
        int choice = 2;
        String expectedColor = before.getColorForChoice(choice);
        before.setValueByNameAndAssign(assignName,teamName,choice);
        MentorInterrestTopicTable after = awt.getAllTopicInterrests();
        int index = after.getIndexForAssignmentName(assignName,teamName);
        String actualColor = after.getActualButtonColor(index);
        Check.checkText(expectedColor, actualColor,"BARVA");
    }
}