package pstsp.support.pageobjects.commonparts;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.assignmentlist.Assignment_List_Page;
import pstsp.support.pageobjects.assignmentswithmentor.Assignments_With_Mentor_Page;
import pstsp.support.pageobjects.assignmentswithoutmentormanagement.Assignments_Without_Mentor_Management;
import pstsp.support.pageobjects.assignmenttoteammanagement.Assignment_To_Team_Management_Page;
import pstsp.support.pageobjects.mentormanagement.Mentor_Management_Page;
import pstsp.support.pageobjects.tagsmanagement.TagsManagement_Page;
import pstsp.support.pageobjects.teammanagement.Team_Management_Page;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class SideNavBarGarantPageTest {
    SideNavBarGarant_Page sideNavBarGarant_page;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("garant");
        this.sideNavBarGarant_page = new SideNavBarGarant_Page();
    }

    @Test
    void clickOnAssignmentPage() {
        sideNavBarGarant_page.clickAssignmentListPageLink();
        Check.checkPage(Assignment_List_Page.PAGE_ID);
    }

    @Test
    void clickOnAssignToTeamManagementPage() {
        sideNavBarGarant_page.clickAssignmentToTeamManagementPageLink();
        Check.checkPage(Assignment_To_Team_Management_Page.PAGE_ID);
    }

    @Test
    void clickOnTagsManagementPage() {
        sideNavBarGarant_page.clickOnTagsManagementPageLink();
        Check.checkPage(TagsManagement_Page.PAGE_ID);
    }

    @Test
    void clickOnassignmentWithMentorPage() {
        sideNavBarGarant_page.clickOnAssignmentsWithMentorPageLink();
        Check.checkPage(Assignments_With_Mentor_Page.PAGE_ID);
    }

    @Test
    void clickOnassignmentWithoutMentorPage() {
        sideNavBarGarant_page.clickOnAssignmentsWithoutMentorPageLink();
        Check.checkPage(Assignments_Without_Mentor_Management.PAGE_ID);
    }

    @Test
    void clickOnTeamManagementPage() {
        sideNavBarGarant_page.clickOnTeamManagementPageLink();
        Check.checkPage(Team_Management_Page.PAGE_ID);
    }

    @Test
    void clickOnMentorManagementPage() {
        sideNavBarGarant_page.clickOnMentorManagementPageLink();
        Check.checkPage(Mentor_Management_Page.PAGE_ID);
    }
}
