package pstsp.support.pageobjects.commonparts;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.project.Project_Page;
import pstsp.support.pageobjects.team.Team_Page;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class SideNavBarLeaderPageTest {
    SideNavBarLeader_Page sideNavBarLeader_page;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("leader");
        this.sideNavBarLeader_page = new SideNavBarLeader_Page();
    }

    @Test
    @DisplayName("TC_click_on_team_page")
    void clickOnTeamPage() {
        sideNavBarLeader_page.clickOnTeamPageLink();
        Check.checkPage(Team_Page.PAGE_ID);
    }

    @Test
    @DisplayName("TC_click_on_project_page")
    void clickOnProjectPageLink() {
        sideNavBarLeader_page.clickOnProjectPageLink();
        Check.checkPage(Project_Page.PAGE_ID);
    }
}
