package pstsp.support.pageobjects.commonparts;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.assignmentswithouthmentor.Assignments_Without_Mentor_Page;
import pstsp.support.pageobjects.assignmentswithoutteam.Assignments_Without_Team_Page;
import pstsp.support.pageobjects.mentoredprojects.Mentored_Projects_Page;
import pstsp.support.pageobjects.mentoredprojectshistory.Mentored_Projects_History_Page;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import static org.junit.jupiter.api.Assertions.*;
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class SideNavBarMentorPageTest {

    SideNavBarMentor_Page sideNavBarMentorPage;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("mentor");
        this.sideNavBarMentorPage = new SideNavBarMentor_Page();
    }
    @Test
    void clickOnTopicsWithoutMentorLink() {
        sideNavBarMentorPage.clickOnAssignmentsWithoutMentor();
        Check.checkPage(Assignments_Without_Mentor_Page.PAGE_ID);
    }

    @Test
    void clickOnAssignmentsWithoutTeam() {
        sideNavBarMentorPage.clickOnAssignmentsWithoutTeam();
        Check.checkPage(Assignments_Without_Team_Page.PAGE_ID);
    }

    @Test
    void clickOnMentoredProjects() {
        sideNavBarMentorPage.clickOnMentoredProjects();
        Check.checkPage(Mentored_Projects_Page.PAGE_ID);
    }

    @Test
    void clickOnMentoredProjectsHistory() {
        sideNavBarMentorPage.clickOnMentoredProjectsHistory();
        Check.checkPage(Mentored_Projects_History_Page.PAGE_ID);
    }
}