package pstsp.support.pageobjects.commonparts;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.basic.Url;
import pstsp.support.pageobjects.incompleteTeam.Incomplete_Team_Page;
import pstsp.support.pageobjects.assignmentlist.Assignment_List_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class SideNavBarUnloggedPageTest {
    SideNavBarUnlogged_Page sideNavBarUnloggedPage;

    @BeforeEach
    void setUp() {
        Click.openUrlAndWait(Url.URL_ASSIGNMENT_LIST);
        this.sideNavBarUnloggedPage = new SideNavBarUnlogged_Page();
    }

    @Test
    @DisplayName("TC_click_on_Assignment_list_page")
    void clickOnTeamPage() {
        sideNavBarUnloggedPage.clickAssignmentListPageLink();
        Check.checkPage(Assignment_List_Page.PAGE_ID);
    }

    @Test
    @DisplayName("TC_click_on_incomplete_team_page")
    void clickOnIncompleteTeamPage() {
        sideNavBarUnloggedPage.clickOnIncompleteTeamsPageLink();
        Check.checkPage(Incomplete_Team_Page.PAGE_ID);
    }

}
