package pstsp.support.pageobjects.incompleteTeam;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.basic.Url;
import pstsp.support.pageobjects.commonparts.SideNavBarUnlogged_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class IncompleteTeamPageTest {

    Incomplete_Team_Page incompleteTeamPage;

    @BeforeEach
    void setUp() {
        Click.openUrlAndWait(Url.URL_ASSIGNMENT_LIST);
        SideNavBarUnlogged_Page side = new SideNavBarUnlogged_Page();
        incompleteTeamPage = side.clickOnIncompleteTeamsPageLink();
    }

    @Test
    void getAssignments() {
        Set<String> actual = incompleteTeamPage.getIncompleteTeams().keySet();
        Set<String> expected = new HashSet<>();
        expected.add("Jedničky");
        expected.add("Dobrá dvojka");
        expected.add("Tři skvělí programátoři");
        expected.add("Čtyři stateční");
        expected.add("Super pětka");
        Check.checkContentsOfTwoSets(expected, actual,"Loaded incomplete teams are not as expected");



    }
}