package pstsp.support.pageobjects.login;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.basic.Url;
import pstsp.support.pageobjects.mentoredprojects.Mentored_Projects_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.login.Login_Check;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class LoginTest {

  Login_Page loginPage;

  @BeforeEach
  void setUp() {
    Click.openUrlAndWait(Url.URL_LOGIN);
    loginPage = new Login_Page();
  }

  @Test
  @DisplayName("TC_Place")
  void placeholderText() {
    String actual = loginPage.getUsernameInputPlaceholderText();
    Check.checkPlaceholder(Login_Page.TXT_USERNAME_INPUT_PLACEHOLDER, actual,
            Login_Page.USERNAME_INPUT);
  }

  @Test
  @DisplayName("TC_Text")
  void text() {
    String actual = loginPage.getUsername();
    Check.checkText("", actual,
            Login_Page.USERNAME_INPUT);
  }

  @Test
  @DisplayName("TC_Set")
  void set() {
    loginPage.setUsername("mentor");
    String actual = loginPage.getUsername();
    Check.checkText("mentor", actual,
            Login_Page.USERNAME_INPUT);
  }

  @Test
  @DisplayName("TC_Klik")
  void klik() {
    loginPage.setUsername("mentor");
    loginPage.setPassword("tsp");
    loginPage.clickOnLoginButton();
    Login_Check.checkLoginProcess("Pan Mentor","Mentor");
    Check.checkPage(Mentored_Projects_Page.PAGE_ID);
  }

}
