package pstsp.support.pageobjects.mentoredprojects;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.entities.MentUpcomingMeeting;
import pstsp.support.services.entities.TeamStateTableRow;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.List;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class MentoredProjectsPageTest {

    Mentored_Projects_Page mp;
    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("mentor");
        Check.checkPage(Mentored_Projects_Page.PAGE_ID);
        this.mp = new Mentored_Projects_Page();
    }

    @Test
    void getMentoredProjectsTable() {
        List<TeamStateTableRow> mentList = mp.getMentoredProjectsTable();
        mentList.forEach(a -> System.out.println(a));
        mentList.get(1).getTeam().click();
    }

    @Test
    void getAllUpcomingMeetings() {
        List<MentUpcomingMeeting> meetList = mp.getAllUpcomingMeetings();
        meetList.forEach(a -> System.out.println(a));
        meetList.get(0).getProject().click();
    }
}