package pstsp.support.pageobjects.project;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.commonparts.SideNavBarLeader_Page;
import pstsp.support.pageobjects.mentoredprojects.Mentored_Projects_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.entities.storage.ProjectTable;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import static org.junit.jupiter.api.Assertions.*;
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class MentorViewOnProjectPageTest {


    Mentor_View_On_Project_Page mvpp;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("mentor");
        Mentored_Projects_Page mp = new Mentored_Projects_Page();
        Click.clickAndWaitId(mp.getMentoredProjectsTable().get(0).getProject(),Project_Page.PAGE_ID);

        this.mvpp = new Mentor_View_On_Project_Page();
    }

    @Test
    void getMinimalCriteriaMentorTable() {
        ProjectTable usedExp = mvpp.getMinimalCriteriaMentorTable();
        usedExp.getRowList().forEach(e -> System.out.println(e));
    }

    @Test
    void getUsedExpMentorTable() {
        ProjectTable usedExp = mvpp.getUsedExpMentorTable();
        usedExp.getRowList().forEach(e -> System.out.println(e));
    }

    @Test
    void getProjectStateMentorTable() {
        ProjectTable usedExp = mvpp.getProjectStateMentorTable();
        usedExp.getRowList().forEach(e -> System.out.println(e));
    }

    @Test
    void setLeaderTableMinCritTest(){
        ProjectTable before = mvpp.getMinimalCriteriaMentorTable();
        int choice = 2;
        int row = before.getIndexForStepName("Dokumentace návrhu");
        String expectedColor = before.getColorForChoice(choice);
        before.setStateValue(row,choice);
        ProjectTable after = mvpp.getMinimalCriteriaMentorTable();
        row = after.getIndexForStepName("Dokumentace návrhu");
        String actualColor = after.getActualValueEnabled(row);
        Check.checkText(expectedColor, actualColor,"BARVA");

    }

    @Test
    void setLeaderTableUsedExpTest(){
        ProjectTable before = mvpp.getUsedExpMentorTable();
        int choice = 3;
        int row = before.getIndexForStepNameAndTextInfo("KIV/PSA","něco");
        String expectedColor = before.getColorForChoice(choice);
        before.setStateValue(row,choice);
        ProjectTable after = mvpp.getUsedExpMentorTable();
        row = after.getIndexForStepNameAndTextInfo("KIV/PSA","něco");
        String actualColor = after.getActualValueEnabled(row);
        Check.checkText(expectedColor, actualColor,"BARVA");

    }

    @Test
    void setLeaderTableProjectStateTest(){
        ProjectTable before = mvpp.getProjectStateMentorTable();
        int choice = 3;
        int row = before.getIndexForStepName("Vytvořená prezentace výsledků projektu jako součást obhajoby");
        String expectedColor = before.getColorForChoice(choice);
        before.setStateValue(row,choice);
        ProjectTable after = mvpp.getProjectStateMentorTable();
        row = after.getIndexForStepName("Vytvořená prezentace výsledků projektu jako součást obhajoby");
        String actualColor = after.getActualValueEnabled(row);
        Check.checkText(expectedColor, actualColor,"BARVA");

    }

}