package pstsp.support.pageobjects.project;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.commonparts.SideNavBarLeader_Page;
import pstsp.support.selenium_utils.MyAlert;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class ProjectPageAddUserExpModalTest {

    Project_Page_Add_Exp_Modal modal;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("leader");
        SideNavBarLeader_Page sn = new SideNavBarLeader_Page();

        Project_Page page  = sn.clickOnProjectPageLink();
        modal = page.openAddExpModal();
    }

    @Test
    void setSubject() {
        modal.setSubject("KIV/PPA2");
    }

    @Test
    void setTopic() {
        modal.setSubjectInfo("Dlouhý popis využití zkušennosti.");
    }

    @Test
    void setAddExperienceTest() {
        modal.setSubject("KIV/PPA2");
        modal.setSubjectInfo("Dlouhý popis využití zkušennosti.");
        modal.clickOnSubmitBTN();
        MyAlert.getAlert().closeAlert();
    }

}
