package pstsp.support.pageobjects.studentmanagement;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class StudentManagementPageTest {

    Student_Management_Page smp;
    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("garant");
        smp = new SideNavBarGarant_Page().clickOnStudentManagementPageLink();
    }

    @Test
    void getStudentTable() {
        smp.getStudentTable().get(0).getTeamButton().click();
    }

    @Test
    void makeTeamLeader() {
        Click.clickAndWaitId(smp.getStudentTable().get(4).getMakeLeaderButton(), Add_Team_With_Leader_Page.PAGE_ID);
        Add_Team_With_Leader_Page ctp = new Add_Team_With_Leader_Page();
        ctp.setTeamName("AAAAAAAA");
        System.out.println(ctp.getTeamLeaderInfo());
    }

    @Test
    void openModal() {
        Add_Student_Modal_Page amp = smp.openAddStudentModal();
        amp.setFirstnameT("aaaa");
        amp.setLastnameT("bbb");
        amp.setLoginT("loginík");
        amp.setEmailT("emailík@sasd.te");
        amp.setPersonalidT("A18CV2554");
        amp.setPeriodS("Testovací ročník");
        amp.setFieldOfStudyT("Nestuduju");
        amp.setFacultyT("Nikde");
    }

}