package pstsp.support.pageobjects.tagsmanagement;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.services.entities.TagTableRow;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.List;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class TagsManagementPageTest {

    TagsManagement_Page tmp;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("garant");
        SideNavBarGarant_Page sn = new SideNavBarGarant_Page();
        this.tmp = sn.clickOnTagsManagementPageLink();
    }
    @Test
    void getTeamProfileTable() {
        List<TagTableRow> list = tmp.getTeamProfileTagTable();
        list.forEach(System.out::println);
        list.get(2).getEditButton().click();
        Check.checkPage(Team_Profile_Tag_Edit_Page.PAGE_ID);
        Team_Profile_Tag_Edit_Page tep = new Team_Profile_Tag_Edit_Page();

        tep.form.setTeamProfileName("Neexistující profil");
        tep.form.setCanUSe(false);
        System.out.println(tep.form.getTeamProfileName());
        System.out.println(tep.form.getCanUSe());

        tep.form.clickOnBackBTN();

    }

    @Test
    void getTeamRoleTable() {
        List<TagTableRow> list = tmp.getTeamRoleTagTable();
        list.forEach(System.out::println);
        list.get(4).getEditButton().click();
        Check.checkPage(Team_Role_Tag_Edit_Page.PAGE_ID);
        Team_Role_Tag_Edit_Page tep = new Team_Role_Tag_Edit_Page();
        System.out.println(tep.form.getName());
        System.out.println(tep.form.getColor());
        System.out.println(tep.form.getCanUSe());
        tep.form.clickOnBackBTN();
    }

    @Test
    void clickAndCloseTeamProfile() {
        Team_Profile_Tag_Create_Modal  modal = tmp.clickOnAddTeamProfileBTN();
        modal.form.setTeamProfileName("Není místo");
        modal.form.setCanUSe(true);
        modal.form.clickOnBackBTN();
    }

    @Test
    void clickAndCloseTeamRole() {
        Team_Role_Tag_Create_Modal  modal = tmp.clickOnAddTeamRoleBTN();
        modal.form.setName("Není místo");
        modal.form.setColor("Modrá");
        modal.form.setCanUSe(true);
        modal.form.clickOnBackBTN();
    }

}