package pstsp.support.pageobjects.team;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.MyAlert;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class AddMeetingTopicPageTest{

    Add_Meeting_Topic_Page meetingTopicPage;

    @BeforeEach
    void setUp() {
        Team_Page tmp = Team_Actions.goToTeamPageAsLeader("leader");
        Click.clickAndWaitId(tmp.getAllMeetings().get(0).getTopic(), Add_Meeting_Topic_Page.PAGE_ID);
        meetingTopicPage = new Add_Meeting_Topic_Page();
    }

    @Test
    @DisplayName("SET_DESCRIPTION")
    void setDescription() {
        meetingTopicPage.setDescription("BLABLABLABLALBA");
    }

    @Test
    @DisplayName("GET_DESCRIPTION")
    void getDescription() {
        String expected = "Testovací podrobný popis ze schůzky";
        meetingTopicPage.setDescription(expected);
        String actual = meetingTopicPage.getDescription();
        Check.checkText(expected,actual,Add_Meeting_Topic_Page.DESCRIPTION_TA);
    }

    @Test
    @DisplayName("SAVE_DESCRIPTION")
    void setDescriptionAndSave() {
        String expected = "Testovací podrobný popis ze schůzky";
        meetingTopicPage.setDescription(expected);
        meetingTopicPage.clickOnSubmitBTN();
        Check.checkPage(Team_Page.PAGE_ID);
        MyAlert.getAlert().closeAlert();
    }


}
