package pstsp.support.pageobjects.team;

import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.commonparts.ModalClose_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.selenium_utils.Utils;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import static org.junit.jupiter.api.Assertions.*;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class TeamPageMeetingModalTest {

    Team_Page_Meeting_Modal teamMeetingModal;

    @BeforeEach
    void setUp() {
        Team_Page teamPage = Team_Actions.goToTeamPageAsLeader("leader");
        this.teamMeetingModal = teamPage.openMeetingModal();
    }


    @Test
    void setAllData() {
        teamMeetingModal.setRoom("Kavárna FAV");
        teamMeetingModal.setTopic("Podmínky absolvování");
        teamMeetingModal.setDateTimeDT("30032022", "12:45");
        teamMeetingModal.setWhoByVisibleText(Team_Page_Meeting_Modal.SELECT_OPTION_OTHER);
        //teamMeetingModal.clickOnCancelBTN();
        teamMeetingModal.clickOnSubmitBTN();

    }

    @Test
    void setRoom() {
        teamMeetingModal.setRoom("FAV");
    }

    @Test
    void setTopic() {
        teamMeetingModal.setTopic("Zahajovací schůzka");
    }

    @Test
    void setWhoByVisibleText() {
        teamMeetingModal.setWhoByVisibleText(Team_Page_Meeting_Modal.SELECT_OPTION_INTERN);
    }

    @Test
    void getSelectedWho() {
        String actual = teamMeetingModal.getSelectedWho();
        Check.checkText(Team_Page_Meeting_Modal.SELECT_OPTION_INTERN, actual, Team_Page_Meeting_Modal.WITH_SEL);
    }



    @Test
    void setDateTimeDT() {
        teamMeetingModal.setDateTimeDT("28022022", "15:43");
    }
}