package pstsp.support.pageobjects.team;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.selenium_utils.MyAlert;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class TeamProfilesEditTest {
    Edit_Team_Profile_Page pEpage;

    @BeforeEach
    void setUp() {
        Team_Page teamPage = Team_Actions.goToTeamPageAsLeader("leader");
        this.pEpage = teamPage.clickOnTeamProfileEditButton();
    }

    @Test
    @DisplayName("TC_SELECT_TEST")
    void selectByVisibleText() {
        Set<String> options = new HashSet<>();
        options.add("Java");
        options.add("PHP");
        options.add("Frontend");
        pEpage.selectValuesByVisibleText(options);
         Set<String> actual = pEpage.getSelectedProfiles();
        Check.checkContentsOfTwoSets(actual, options, "Selection isn't same!");
    }


    @Test
    void clickOnSubmitBTN() {
        Set<String> expected = new HashSet<>();
        expected.add("PHP");
        expected.add("Java");
        expected.add("Frontend");
        expected.add("C#");
        pEpage.selectValuesByVisibleText(expected);
        pEpage.clickOnSubmitBTN();
        Team_Page teamPage = new Team_Page();
        Set<String> actual = teamPage.getTeamProfile();
        MyAlert.getAlert().closeAlert();
        Check.checkContentsOfTwoSets(actual,expected,"Added profiles doesn't match with showed profiles.");
    }

    @Test
    void clickOnBackBTN() {
        pEpage.clickOnBackBTN();
        Check.checkPage(Team_Page.PAGE_ID);
    }


}
