package pstsp.support.pageobjects.teammanagement;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.openqa.selenium.WebElement;
import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.selenium_utils.Click;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import static org.junit.jupiter.api.Assertions.*;
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class TeamManagEditDefenceModalPageTest {

    Team_Manag_Edit_Defence_Modal_Page tmedmp;

    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("garant");
        Team_Management_Page tmp = new SideNavBarGarant_Page().clickOnTeamManagementPageLink();
        WebElement editButton = tmp.getTeamManagementTable().get(4).getTeam();
        Click.clickAndWaitId(editButton, Team_Manag_Edit_Page.PAGE_ID);
        this.tmedmp = new Team_Manag_Edit_Page().openAddDefenceModal();
    }

    @Test
    void clickOnCancelBTN() {
        tmedmp.clickOnCancelBTN();
    }

    @Test
    void clickOnSubmitBTN() {
        tmedmp.setDefenceNumber("1");
        tmedmp.setDefenceDate("25032023");
        tmedmp.setDefenceResultSuccess();
        tmedmp.clickOnSubmitBTN();
        Check.checkAndCloseAlert(true);
    }

    @Test
    void setDefenceNumber() {
        tmedmp.setDefenceNumber("1");
    }

    @Test
    void setDefenceDate() {
        tmedmp.setDefenceDate("25032022");
    }

    @Test
    void setDefenceResultSuccess() {
        tmedmp.setDefenceResultSuccess();
    }

    @Test
    void setDefenceResultUnSuccess() {
        tmedmp.setDefenceResultUnSuccess();
    }

    @Test
    void setDefenceResultUnspecified() {
        tmedmp.setDefenceResultUnspecified();
    }
}