package pstsp.support.pageobjects.usermanagement;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.openqa.selenium.devtools.v85.log.Log;
import pstsp.support.pageobjects.commonparts.SideNavBarGarant_Page;
import pstsp.support.pageobjects.commonparts.SideNavBarUnlogged_Page;
import pstsp.support.selenium_utils.JavaScript;
import pstsp.support.services.entities.UserManagementLeaderTableRow;
import pstsp.support.services.entities.UserManagementMentorTableRow;
import pstsp.support.services.login.Login_Actions;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.List;

import static org.junit.jupiter.api.Assertions.*;
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class User_Management_PageTest {

    User_Management_Page ump;
    @BeforeEach
    void setUp() {
        Login_Actions.loginIfNecessary("garant");
        ump = new SideNavBarGarant_Page().clickOnUserManagementPageLink();
    }

    @Test
    void getMentorTable() {
        List<UserManagementMentorTableRow> table = ump.getMentorTable();
        table.get(0).getDeleteButton().click();
        System.out.println(JavaScript.getText_JS_Alert());
        JavaScript.cancel_JS_Alert();
        table.get(1).getDeleteButton().click();
        System.out.println(JavaScript.getText_JS_Alert());
        JavaScript.cancel_JS_Alert();
    }

    @Test
    void getLeaderTable() {
        List<UserManagementLeaderTableRow> table = ump.getLeaderTable();
        table.get(0).getDeleteButton().click();
        System.out.println(JavaScript.getText_JS_Alert());
        JavaScript.cancel_JS_Alert();
        table.get(1).getDeleteButton().click();
        System.out.println(JavaScript.getText_JS_Alert());
        JavaScript.cancel_JS_Alert();
    }
}