package pstsp.support.selenium_utils;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.devtools.DevTools;
import org.openqa.selenium.devtools.v97.performance.Performance;
import org.openqa.selenium.devtools.v97.performance.model.Metric;
import pstsp.support.basic.Url;
import pstsp.support.test_utils.Check;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;
import pstsp.support.tools.Drivers;

import java.util.List;
import java.util.Optional;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class OpenPageTest {

  @Test
  void openMainPage() {
    Click.openUrlAndWait(Url.URL_LOGIN);
//    Check.checkActualUrl(Url.URL_LOGIN + "x");
    Check.checkActualUrl(Url.URL_LOGIN);
  }

  @Test
  void performanceMetricsExample() {
    ChromeDriver driver = (ChromeDriver) Drivers.getDriver();
    DevTools devTools = driver.getDevTools();
    devTools.createSession();
    devTools.send(Performance.enable(Optional.empty()));
    List<Metric> metricList = devTools.send(Performance.getMetrics());

    driver.get(Url.URL_LOGIN);
    driver.quit();

    for(Metric m : metricList) {
      System.out.println(m.getName() + " = " + m.getValue());
    }
  }
}
