package pstsp.support.services.assignmentmanagement;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Tag;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.test_utils.PstspTags;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

import static org.junit.jupiter.api.Assertions.*;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class AssignmentManagementActionsTest {

    @Test
    void addAssignmentSuccess() {
        String assignmentName = "Testovací zadání 1";
        String assignmentDesc = "Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli, but the Little Blind Text didn’t listen. She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove, the headline of Alphabet Village and the subline of her own road, the Line Lane.";
        String ownerFirsName = "Petr";
        String ownerLastName = "Janek";
        String ownerEmail = "pj@example.org";
        String ownerPhone = "725253123";
        String ownerOtherInfo = "Petr Janek z NICSOFT s.r.o.";
        String timeNeeded = "999";
        String teamSize = "5";
        Set<String> expTeamProfile = new HashSet<>();
        expTeamProfile.add("C");
        expTeamProfile.add("C#");
        expTeamProfile.add("HTML");
        String mentor = "Pan Mentor";
        String period = "LS 21/22 - ZS 22/23";
        String visibility = "Publikováno pro všechny";
        String currUser = "garant";
        String assignmentMentorLogin = "mentor";
        Assignment_Management_Actions.addAssignmentSuccess(assignmentName, assignmentDesc, ownerFirsName, ownerLastName, ownerEmail, ownerPhone, ownerOtherInfo, timeNeeded, teamSize, expTeamProfile,
                mentor, period, visibility, currUser, assignmentMentorLogin);
    }

    @Test
    void addAssignmentNoMentorVisible() {
        String assignmentName = "Testovací zadání 2";
        String assignmentDesc = "Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli, but the Little Blind Text didn’t listen. She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove, the headline of Alphabet Village and the subline of her own road, the Line Lane.";
        String ownerFirsName = "Petr";
        String ownerLastName = "Janek";
        String ownerEmail = "pj@example.org";
        String ownerPhone = "725253123";
        String ownerOtherInfo = "Petr Janek z NICSOFT s.r.o.";
        String timeNeeded = "999";
        String teamSize = "5";
        Set<String> expTeamProfile = new HashSet<>();
        expTeamProfile.add("C");
        expTeamProfile.add("C#");
        expTeamProfile.add("HTML");
        String mentor = "";
        String period = "LS 21/22 - ZS 22/23";
        String visibility = "Publikováno pro všechny";
        String currUser = "garant";
        String assignmentMentorLogin = "";
        Assignment_Management_Actions.addAssignmentSuccess(assignmentName, assignmentDesc, ownerFirsName, ownerLastName, ownerEmail, ownerPhone, ownerOtherInfo, timeNeeded, teamSize, expTeamProfile,
                mentor, period, visibility, currUser, assignmentMentorLogin);
    }

    @Test
    void addAssignmentMentorVisibleOnlyForMentors() {
        String assignmentName = "Testovací zadání 3";
        String assignmentDesc = "Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli, but the Little Blind Text didn’t listen. She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove, the headline of Alphabet Village and the subline of her own road, the Line Lane.";
        String ownerFirsName = "Petr";
        String ownerLastName = "Janek";
        String ownerEmail = "pj@example.org";
        String ownerPhone = "725253123";
        String ownerOtherInfo = "Petr Janek z NICSOFT s.r.o.";
        String timeNeeded = "999";
        String teamSize = "5";
        Set<String> expTeamProfile = new HashSet<>();
        expTeamProfile.add("C");
        expTeamProfile.add("C#");
        expTeamProfile.add("HTML");
        String mentor = "Pan Mentor";
        String period = "LS 21/22 - ZS 22/23";
        String visibility = "Viditelné pouze pro mentory";
        String currUser = "garant";
        String assignmentMentorLogin = "mentor";
        Assignment_Management_Actions.addAssignmentSuccess(assignmentName, assignmentDesc, ownerFirsName, ownerLastName, ownerEmail, ownerPhone, ownerOtherInfo, timeNeeded, teamSize, expTeamProfile,
                mentor, period, visibility, currUser, assignmentMentorLogin);
    }

    @Test
    void addAssignmentNoMentorVisibleOnlyForMentors() {
        String assignmentName = "Testovací zadání 4";
        String assignmentDesc = "Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli, but the Little Blind Text didn’t listen. She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove, the headline of Alphabet Village and the subline of her own road, the Line Lane.";
        String ownerFirsName = "Petr";
        String ownerLastName = "Janek";
        String ownerEmail = "pj@example.org";
        String ownerPhone = "725253123";
        String ownerOtherInfo = "Petr Janek z NICSOFT s.r.o.";
        String timeNeeded = "999";
        String teamSize = "5";
        Set<String> expTeamProfile = new HashSet<>();
        expTeamProfile.add("C");
        expTeamProfile.add("C#");
        expTeamProfile.add("HTML");
        String mentor = "";
        String period = "LS 21/22 - ZS 22/23";
        String visibility = "Viditelné pouze pro mentory";
        String currUser = "garant";
        String assignmentMentorLogin = "";
        Assignment_Management_Actions.addAssignmentSuccess(assignmentName, assignmentDesc, ownerFirsName, ownerLastName, ownerEmail, ownerPhone, ownerOtherInfo, timeNeeded, teamSize, expTeamProfile,
                mentor, period, visibility, currUser, assignmentMentorLogin);
    }

    @Test
    void addAssignmentMentorHidden() {
        String assignmentName = "Testovací zadání 5";
        String assignmentDesc = "Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli, but the Little Blind Text didn’t listen. She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove, the headline of Alphabet Village and the subline of her own road, the Line Lane.";
        String ownerFirsName = "Petr";
        String ownerLastName = "Janek";
        String ownerEmail = "pj@example.org";
        String ownerPhone = "725253123";
        String ownerOtherInfo = "Petr Janek z NICSOFT s.r.o.";
        String timeNeeded = "999";
        String teamSize = "5";
        Set<String> expTeamProfile = new HashSet<>();
        expTeamProfile.add("C");
        expTeamProfile.add("C#");
        expTeamProfile.add("HTML");
        String mentor = "Pan Mentor";
        String period = "LS 21/22 - ZS 22/23";
        String visibility = "Skryté";
        String currUser = "garant";
        String assignmentMentorLogin = "mentor";
        Assignment_Management_Actions.addAssignmentSuccess(assignmentName, assignmentDesc, ownerFirsName, ownerLastName, ownerEmail, ownerPhone, ownerOtherInfo, timeNeeded, teamSize, expTeamProfile,
                mentor, period, visibility, currUser, assignmentMentorLogin);
    }

    @Test
    void addAssignmentNoMentorHidden() {
        String assignmentName = "Testovací zadání 6";
        String assignmentDesc = "";
        String ownerFirsName = "";
        String ownerLastName = "";
        String ownerEmail = "";
        String ownerPhone = "";
        String ownerOtherInfo = "";
        String timeNeeded = "";
        String teamSize = "";
        Set<String> expTeamProfile = new HashSet<>();
        String mentor = "";
        String period = "LS 21/22 - ZS 22/23";
        String visibility = "Skryté";
        String currUser = "garant";
        String assignmentMentorLogin = "";
        Assignment_Management_Actions.addAssignmentSuccess(assignmentName, assignmentDesc, ownerFirsName, ownerLastName, ownerEmail, ownerPhone, ownerOtherInfo, timeNeeded, teamSize, expTeamProfile,
                mentor, period, visibility, currUser, assignmentMentorLogin);
    }

    @Test
    void editNameTest() {
        String expectedName = "Nové jméno 2.0";
        String assignmentName = "Testovací zadání 1";
        String ownerFirsName = "Petr";
        String ownerLastName = "Janek";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentNameSuccess(expectedName, assignmentName, ownerFullNAme, "garant");
    }

    @Test
    void editDescTest() {
        String expected = "Popis zadání kratší.";
        String assignmentName = "Nové jméno 2.0";
        String ownerFirsName = "Petr";
        String ownerLastName = "Janek";
        String ownerFullNAme = ownerFirsName + " " + ownerLastName;
        Assignment_Management_Actions.editAssignmentDescriptionSuccess(expected, assignmentName, ownerFullNAme, "garant");
    }

    @Test
    void editOwnerNameTest() {
        String expected1 = "";
        String expected2 = "";
        String assignmentName = "Nové jméno 2.0";
        String ownerName = "Jaroslav Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerNameSuccess(expected1, expected2, assignmentName, ownerName, "garant");
    }

    @Test
    void editOwnerEmailTest() {
        String expected = "pd@example.com";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerMailSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Test
    void editOwnerPhoneTest() {
        String expected = "123456789";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerPhoneSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Test
    void editOwnerOtherInfoTest() {
        String expected = "123456789 je moje číslo";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentOwnerOtherInfoSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Test
    void editTimeNeededTest() {
        String expected = "1234";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentTimeNeededSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Test
    void editTeamSizeTest() {
        String expected = "12";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamSizeSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Test
    void editAssignmentProfileTest() {
        Set<String> expected = new HashSet<>();
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentExpTeamProfileSuccess(expected, assignmentName, ownerName, "garant");
    }

    @Test
    void editAssignmentMentorTest() {
        String expected = "Pan Mentor";
        String mentorLogin = "mentor";
        //String expected = "";
        //String mentorLogin = "";
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentMentorSuccess(expected,mentorLogin, assignmentName, ownerName, "garant");
    }

    @Test
    void editVisibilityTest() {
        String expected = "Skryté";
        boolean withMentor = false;
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Test
    void editVisibilityTest_1() {
        String expected = "Publikováno pro všechny";
        boolean withMentor = false;
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Test
    void editVisibilityTest_2() {
        String expected = "Viditelné pouze pro mentory";
        boolean withMentor = false;
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Test
    void editVisibilityTest_3() {
        String expected = "Skryté";
        boolean withMentor = true;
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Test
    void editVisibilityTest_4() {
        String expected = "Publikováno pro všechny";
        boolean withMentor = true;
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }

    @Test
    void editVisibilityTest_5() {
        String expected = "Viditelné pouze pro mentory";
        boolean withMentor = true;
        String assignmentName = "Testování webové aplikace";
        String ownerName = "Petr Dobrovolný";
        Assignment_Management_Actions.editAssignmentVisibilitySuccess(expected, assignmentName, ownerName, "garant",withMentor);
    }


    @Order(3)
    @Tag(PstspTags.IMP_CRITICAL)
    @Test
    @DisplayName("TC.C.13.01.03: half clear assignment without mentor visible for all")
    void test_03() {
        String assignmentName = "Poloprazdne tema 2";
        String assignmentDesc = "";
        String ownerFirsName = "";
        String ownerLastName = "";
        String ownerEmail = "";
        String ownerPhone = "";
        String ownerOtherInfo = "";
        String timeNeeded = "";
        String teamSize = "";
        Set<String> expTeamProfile = new HashSet<>();
        String mentor = "";
        String period = "LS 21/22 - ZS 22/23";
        String visibility = "Publikováno pro všechny";
        String currUser = "garant";
        String assignmentMentorLogin = "";
        Assignment_Management_Actions.addAssignmentSuccess(assignmentName, assignmentDesc, ownerFirsName, ownerLastName, ownerEmail, ownerPhone, ownerOtherInfo, timeNeeded, teamSize, expTeamProfile,
                mentor, period, visibility, currUser, assignmentMentorLogin);
    }


}