package pstsp.support.services.assignmentswithoutmentormanagement;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

import static org.junit.jupiter.api.Assertions.*;
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class AssignWithoutMentorManagementActionsTest {

    @Test
    void editPublAssignmentNameSuccess() {
        String expectedName = "Rozšíření aplikace pro detekci kolizních drah";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentNameSuccess(expectedName,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentNameSuccess_1() {
        String destAssignName = "Rozšíření aplikace pro detekci kolizních drah";
        String expectedName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentNameSuccess(expectedName,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentDescSuccess() {
        String expectedDesc = "Nulla quis diam. Sed ac dolor sit amet purus malesuada congue. Praesent vitae arcu tempor neque lacinia pretium. Mauris dictum facilisis augue. Phasellus enim erat, vestibulum vel, aliquam a, posuere eu, velit. Etiam neque. Morbi leo mi, nonummy eget tristique non, rhoncus non leo. Nam quis nulla. Integer malesuada. Proin in tellus sit amet nibh dignissim sagittis. Duis risus. Temporibus autem quibusdam et aut officiis debitis aut rerum necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Mauris dolor felis, sagittis at, luctus sed, aliquam non, tellus. Phasellus rhoncus. Phasellus faucibus molestie nisl. Aliquam in lorem sit amet leo accumsan lacinia. Fusce tellus odio, dapibus id fermentum quis, suscipit id erat. Mauris elementum mauris vitae tortor.";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentDescriptionSuccess(expectedDesc,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentOwnerFirstNameSuccess() {
        String expectedFirstName = "Bronimír";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String expectedAssignmentFullName = "Bronimír Garant";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerFirstNameSuccess(expectedFirstName, expectedAssignmentFullName,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentOwnerLastNameNameSuccess() {
        String expectedLastName = "Bronimír";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String expectedAssignmentFullName = "Pan Bronimír";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerLastNameSuccess(expectedLastName, expectedAssignmentFullName,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentOwnerEmailSuccess() {
        String expectedEmail = "bronimir@example.com";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Bronimír";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerEmailSuccess(expectedEmail,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentOwnerPhoneSuccess() {
        String expectedPhone = "123456789";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Bronimír";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerPhoneSuccess(expectedPhone,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentOwnerOtherInfoSuccess() {
        String expectedOtherInfo = "123456789 další info jen o MĚ";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Bronimír";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentOwnerOtherInfoSuccess(expectedOtherInfo,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentExpectedTimeInfoSuccess() {
        String expectedTime = "1234";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Bronimír";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentExpectedTimeSuccess(expectedTime,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentExpectedTeamSizeSuccess() {
        String expTeamSize = "7";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Bronimír";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentTeamSize(expTeamSize,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentTeamProfile() {
        Set<String> teamProfile = new HashSet<>();
        teamProfile.add("PHP");
        teamProfile.add("JavaScript");
        teamProfile.add("Frontend");
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentExpectedTeamProfile(teamProfile,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentMentor() {
        String mentor = "Petr Pan";
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentCurrMentor(mentor,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentNoMentor() {
        String mentor = Assign_Without_Mentor_Management_Actions.MENTOR_NOT_ASSIGNED;
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentCurrMentor(mentor,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentVisibilityAll() {
        String visibility = Assign_Without_Mentor_Management_Actions.VISIBILITY_ALL;
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentVisibility(visibility,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentVisibilityMentor() {
        String visibility = Assign_Without_Mentor_Management_Actions.VISIBILITY_MENTOR;
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentVisibility(visibility,destAssignName,destAssignOwner,"garant");
    }

    @Test
    void editPublAssignmentVisibilityHidden() {
        String visibility = Assign_Without_Mentor_Management_Actions.VISIBILITY_HIDDNEN;
        String destAssignName = "Rozšíření aplikace pro detekci procesní anti-patternů";
        String destAssignOwner = "Pan Garant";
        Assign_Without_Mentor_Management_Actions.editPublAssignmentVisibility(visibility,destAssignName,destAssignOwner,"garant");
    }




}