package pstsp.support.services.login;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.pageobjects.commonparts.HeaderBar_Page;
import pstsp.support.test_oracle.storage.UsersSet;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import static org.junit.jupiter.api.Assertions.assertEquals;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
public class LoginActionTest {

  @Test
  @DisplayName("TC_uspesny login od zacatku")
  void uspesnyLogin() {
    Login_Actions.loginIfNecessary("mentor");
    HeaderBar_Page hbp = new HeaderBar_Page();
    String expectedFullname = UsersSet.getInstance().getUserByUsername("mentor").getFullName();
    String actualFullname = hbp.getLoggedUserFullName();
    assertEquals(expectedFullname, actualFullname, "login 'mentor' failed");
  }

  @Test
  @DisplayName("TC_pokus o opakovane prihlaseni stejneho user")
  void opakovanePrihlaseni() {
    Login_Actions.loginIfNecessary("mentor");
    Login_Actions.loginIfNecessary("mentor");
    HeaderBar_Page hbp = new HeaderBar_Page();
    String expectedFullname = UsersSet.getInstance().getUserByUsername("mentor").getFullName();
    String actualFullname = hbp.getLoggedUserFullName();
    assertEquals(expectedFullname, actualFullname, "login 'mentor' failed");
  }

  @Test
  @DisplayName("TC_prihlaseni jineho user")
  void prihlaseniJineho() {
    Login_Actions.loginIfNecessary("leader");
    Login_Actions.loginIfNecessary("mentor");
    HeaderBar_Page hbp = new HeaderBar_Page();
    String expectedFullname = UsersSet.getInstance().getUserByUsername("mentor").getFullName();
    String actualFullname = hbp.getLoggedUserFullName();
    assertEquals(expectedFullname, actualFullname, "login 'mentor' failed");
  }

  @Test
  void loginlogoutTest() {
    Login_Actions.loginIfNecessary("leader");
    Login_Actions.logoutIfPossible();
    Login_Actions.logoutIfPossible();
    Login_Actions.loginIfNecessary("leader");
    Login_Actions.logoutIfPossible();

  }

}
