package pstsp.support.services.negative.login;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.ArrayList;
import java.util.List;

import static org.junit.jupiter.api.Assertions.*;
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class NegLoginActionsTest {

    @Test
    void invalidLogin() {
        Neg_Login_Actions.invalidLogin("mentor","pass");
    }

    @Test
    void invalidLogin_1() {
        Neg_Login_Actions.invalidLogin("pass","mentor");
    }

    @Test
    void invalidLogin_2() {
        List<String> expectedMessages = new ArrayList<>();
        expectedMessages.add("Prosím vyplňte své uživatelské jméno.");
        Neg_Login_Actions.invalidLogin_blankInput("","kj",expectedMessages);
    }

    @Test
    void invalidLogin_3() {
        List<String> expectedMessages = new ArrayList<>();
        expectedMessages.add("Prosím vyplňte své heslo.");
        Neg_Login_Actions.invalidLogin_blankInput("erer","",expectedMessages);
    }

    @Test
    void invalidLogin_4() {
        List<String> expectedMessages = new ArrayList<>();
        expectedMessages.add("Prosím vyplňte své uživatelské jméno.");
        expectedMessages.add("Prosím vyplňte své heslo.");

        Neg_Login_Actions.invalidLogin_blankInput("","",expectedMessages);
    }
}