package pstsp.support.services.negative.team;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class NegTeamActionsTest {

    @Test
    void editTeamNameNegative() {
        Neg_Team_Actions.editTeamNameNegative("","This field is required.","leader");
    }

    @Test
    void editTeamMemberRolesNegative() {
        Set<String> roles = new HashSet<>();
        roles.add("Programátor");
        roles.add("Dokumentarista");
        roles.add("Tester");
        roles.add("Grafik");
        Neg_Team_Actions.editTeamMemberRolesNegative(roles,"Jakub ŠMRHA (A19B0206P)","Můžou být vybrány maximálně 3 předvolby","leader");
    }

    @Test
    void AddMeetingNegative_1() {
        String date="";
        String time="";
        String room="FAV";
        String topic="NECO";
        String expectedMessage = "Termín schůzky musí být vyplněn.";
        Neg_Team_Actions.addMeetingAsLeaderNegative(date,time,topic,room,expectedMessage,"leader");
    }

    @Test
    void AddMeetingNegative_2() {
        String date="21032000";
        String time="20:23";
        String room="";
        String topic="NECO";
        String expectedMessage = "Místo setkání musí být vyplněno.";
        Neg_Team_Actions.addMeetingAsLeaderNegative(date,time,topic,room,expectedMessage,"leader");
    }

    @Test
    void AddMeetingNegative_3() {
        String date="21032000";
        String time="20:23";
        String room="FAV";
        String topic="";
        String expectedMessage = "Obsah schůzky musí být vyplněn.";
        Neg_Team_Actions.addMeetingAsLeaderNegative(date,time,topic,room,expectedMessage,"leader");
    }

    @Test
    void AddMeetingMentorNegative_1() {
        String date="";
        String time="";
        String room="FAV";
        String topic="NECO";
        String expectedMessage = "Termín schůzky musí být vyplněn.";
        Neg_Team_Actions.addMeetingAsMentorNegative(date,time,topic,room,expectedMessage,"Pět skvělých programátorů","mentor");
    }

    @Test
    void AddMeetingMentorNegative_2() {
        String date="21032000";
        String time="20:23";
        String room="";
        String topic="NECO";
        String expectedMessage = "Místo setkání musí být vyplněno.";
        Neg_Team_Actions.addMeetingAsMentorNegative(date,time,topic,room,expectedMessage,"Pět skvělých programátorů","mentor");
    }

    @Test
    void AddMeetingMentorNegative_3() {
        String date="21032000";
        String time="20:23";
        String room="FAV";
        String topic="";
        String expectedMessage = "Obsah schůzky musí být vyplněn.";
        Neg_Team_Actions.addMeetingAsMentorNegative(date,time,topic,room,expectedMessage,"Pět skvělých programátorů","mentor");
    }
}