package pstsp.support.services.project;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;
import pstsp.support.test_oracle.storage.ProjectPageStepList;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;

import static org.junit.jupiter.api.Assertions.*;
@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class ProjectGarantActionsTest {

    @ParameterizedTest(name = "{index}: Step: {0} - choice: {1}")
    @MethodSource("streamForMinCritSteps")
    void editMinCritTableParameterTest(String step, int choice) {
        String teamName = "Nejlepší kodéři";
        String user = "garant";
        Project_Garant_Actions.editMinimalCriteriaTableFromTeamManagementSuccess(step,choice,teamName,user);
    }

    static Stream<Arguments> streamForMinCritSteps() {
        //List<String> minCritList = ProjectPageStepList.getInstance().getAllMinimalCriteriaSteps();
        List<String> minCritTest = new ArrayList<>();
        minCritTest.add("Popis potřeb zákazníka");
        minCritTest.add("Plán projektu");
        List<Arguments> args = new ArrayList<>();
        for (String step: minCritTest) {
            for(int i = 0; i < 4; i++){
                args.add(Arguments.of(step,i));
            }
        }
        return args.stream();
    }

    @ParameterizedTest(name = "{index}: Step: {0} - choice: {1}")
    @MethodSource("streamForProjState")
    void editProjStateParameterTest(String step, int choice) {
        String teamName = "Nejlepší kodéři";
        String user = "garant";
        Project_Garant_Actions.editProjectStateTableFromTeamManagementSuccess(step,choice,teamName,user);
    }

    static Stream<Arguments> streamForProjState() {
        //List<String> minCritList = ProjectPageStepList.getInstance().getAllMinimalCriteriaSteps();
        List<String> minCritTest = new ArrayList<>();
        minCritTest.add("Výběr vhodných nástrojů pro vývoj i vedení projektu");
        minCritTest.add("Kontrolní schůzka");
        List<Arguments> args = new ArrayList<>();
        for (String step: minCritTest) {
            for(int i = 0; i < 4; i++){
                args.add(Arguments.of(step,i));
            }
        }
        return args.stream();
    }

    @Test
    void editUsedExpParameterTest() {
        String teamName = "Nejlepší kodéři";
        String user = "garant";
        String step = "KIV/OKS";
        String otherInfo = "Mimofunkční";
        Project_Garant_Actions.editUsedExpTableFromTeamManagementSuccess(step,otherInfo,0,teamName,user);

        Project_Garant_Actions.editUsedExpTableFromTeamManagementSuccess(step,otherInfo,1,teamName,user);

        Project_Garant_Actions.editUsedExpTableFromTeamManagementSuccess(step,otherInfo,2,teamName,user);

        step = "KIV/PSA";
        otherInfo = "Další zkušennost";
        Project_Garant_Actions.editUsedExpTableFromTeamManagementSuccess(step,otherInfo,0,teamName,user);

        Project_Garant_Actions.editUsedExpTableFromTeamManagementSuccess(step,otherInfo,1,teamName,user);

        Project_Garant_Actions.editUsedExpTableFromTeamManagementSuccess(step,otherInfo,2,teamName,user);
    }


    @ParameterizedTest(name = "{index}: Step: {0} - choice: {1}")
    @MethodSource("streamForMinCritSteps")
    void editMinCritTableMentorManagParameterTest(String step, int choice) {
        String teamName = "Dobrá trojka";
        String assignmentName = "Aplikace pro správu X.509 certifikátů";
        String mentorName = "Pan Mentor";
        String user = "garant";
        Project_Garant_Actions.editMinimalCriteriaTableFromMentorManagementSuccess(step,choice,teamName,assignmentName,mentorName,user);
    }

    @ParameterizedTest(name = "{index}: Step: {0} - choice: {1}")
    @MethodSource("streamForProjState")
    void editProjStateMentorManagementParameterTest(String step, int choice) {
        //String teamName = "Nejlepší kodéři";
        //String assignmentName = "Syntéza lidského hlasu";
        //String mentorFullName = "Pavel Herout";
        //String user = "garant";

        String teamName = "Dobrá trojka";
        String assignmentName = "Aplikace pro správu X.509 certifikátů";
        String mentorName = "Pan Mentor";
        String user = "garant";
        Project_Garant_Actions.editProjStateTableFromMentorManagementSuccess(step,choice,teamName,assignmentName,mentorName,user);
    }

    @Test
    void editUsedExpMentorManagement() {
        String teamName = "Nejlepší kodéři";
        String assignmentName = "Syntéza lidského hlasu";
        String mentorFullName = "Pavel Herout";
        String user = "garant";
        String step = "KIV/OKS";
        String otherInfo = "Mimofunkční";
        Project_Garant_Actions.editUsedExpTableFromMentorManagementSuccess(step,otherInfo,0,teamName,assignmentName,mentorFullName,user);

        Project_Garant_Actions.editUsedExpTableFromMentorManagementSuccess(step,otherInfo,1,teamName,assignmentName,mentorFullName,user);

        Project_Garant_Actions.editUsedExpTableFromMentorManagementSuccess(step,otherInfo,2,teamName,assignmentName,mentorFullName,user);

        step = "KIV/PSA";
        otherInfo = "Další zkušennost";
        Project_Garant_Actions.editUsedExpTableFromMentorManagementSuccess(step,otherInfo,0,teamName,assignmentName,mentorFullName,user);

        Project_Garant_Actions.editUsedExpTableFromMentorManagementSuccess(step,otherInfo,1,teamName,assignmentName,mentorFullName,user);

        Project_Garant_Actions.editUsedExpTableFromMentorManagementSuccess(step,otherInfo,2,teamName,assignmentName,mentorFullName,user);
    }


}