package pstsp.support.services.teammanagement;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import pstsp.support.services.entities.DefenceInfo;
import pstsp.support.services.team.Team_Actions;
import pstsp.support.test_utils.TestEvaluation;
import pstsp.support.test_utils.TestSetting;

import java.util.HashSet;
import java.util.Set;

@ExtendWith(TestSetting.class)
@ExtendWith(TestEvaluation.class)
class TeamManagementActionsTest {

    @Test
    void setFirstCreditSuccess() {
        String teamName = "Nejlepší kodéři";
        String leaderName = "leader";
        String user = "garant";
        Team_Management_Actions.setFirstCreditSuccess("",teamName,leaderName,user);
    }

    @Test
    void setSecondCreditSuccess() {
        String teamName = "Nejlepší kodéři";
        String leaderName = "leader";
        String user = "garant";
        Team_Management_Actions.setSecondCreditSuccess("30042022",teamName,leaderName,user);
    }

    @Test
    void addDefenceSuccess() {
        DefenceInfo defence = new DefenceInfo(1,"11. 04. 2022","Nesplněno");
        String teamName = "Nejlepší kodéři";
        String leaderName = "leader";
        String user = "garant";
        Team_Management_Actions.addDefenceSuccess(defence,teamName,leaderName,user);
    }

    @Test
    void addDefenceSuccess_2() {
        DefenceInfo defence = new DefenceInfo(2,"15. 05. 2022","Splněno");
        String teamName = "Nejlepší kodéři";
        String leaderName = "leader";
        String user = "garant";
        Team_Management_Actions.addDefenceSuccess(defence,teamName,leaderName,user);
    }

    @Test
    void editTeamName() {
        String  expTeamName= "Nejlepší kodéři";
        String destTeamName = "Nejlepšejší kodéři";
        String user = "garant";
        Team_Management_Actions.editTeamNameSuccess(expTeamName,destTeamName,user);
    }

    @Test
    void editTeamMembers() {
        Set<String> expected = new HashSet<>();
        expected.add("Jan CHODORA (A19B0066P)");
        expected.add("Václav HRABÍK (A19B0061P)");
        expected.add("Pavel ČÁCHA (A19B0022P)");
        expected.add("Michaela BENEŠOVÁ (A19B0008P)");
        expected.add("David BUBIK (A19B0015P)");
        String expTeamName = "Nejlepší kodéři";
        String user = "garant";
        Team_Management_Actions.editTeamMembersSuccess(expected,expTeamName, user);
    }

    @Test
    void editTeamComplete() {
        boolean complete = true ;
        String destTeamName = "Nejlepší kodéři";
        String user = "garant";
        Team_Management_Actions.editTeamCompletnessSuccess(complete,destTeamName,user);
    }

    @Test
    void editTeamInComplete() {
        boolean complete = false;
        String destTeamName = "Nejlepší kodéři";
        String user = "garant";
        Team_Management_Actions.editTeamCompletnessSuccess(complete,destTeamName,user);
    }
}